
function loadJV3() {
    self.JV3 = Components.classes['@electronic.max/listit;1'].getService().wrappedJSObject;
};

$(document).ready(function() {
    loadJV3();
    self.BASE_URL = JV3.prefs.getCharPref("sync.server")+"/jv3"; // "https://listit.nrcc.noklab.com/listit/jv3";
})

var setmsg = function(msg) {
    if (msg && msg.length > 0) {
        $("#msg").html(msg);
    } else {
       $("#msg").html("&nbsp;");
    }
};

var setok = function(ok) {
    if (ok) {
	$("#submit").fadeIn("fast");
	$("#submit").show();
    } else {
	$("#submit").fadeOut("fast");
    }
};

var getEmailVal = function() { return $("#email").val(); };

var setReturningUser = function(isReturning, username) {
   if (isReturning) {
       $("#login").fadeIn("fast");
       $("#login").show();
       $("#register").fadeOut("fast");
   } else {
       $("#login").fadeOut("fast");
       $("#login").hide();
       $("#register").fadeIn("fast");
   }
};

var determineWhetherUserIsNewOrReturningBasedOnEmail = function(cont) {
    var emailval = getEmailVal()
    emailval = JV3.plumutil.trim(emailval);
    if (emailval.length == 0) {
	return cont(false, "Please type an e-mail address");
    }
    if (!JV3.plumutil.isValidEmail(emailval)) {
	return cont(false, "That doesn't look like a valid e-mail address.");
    } else {
	return $.ajax({ type:"GET",
			     url: BASE_URL + "/userexists?email="+encodeURIComponent(emailval),
			     success: function(data,success, x) {
				 //success means that there exists already such an email adddr
				 setReturningUser(true,emailval);
				 cont(false,"Welcome back; please type in your password");
			     },
			     cache:false,
			     error: function(req,status) {
				 if (req.status == 404){
				     setReturningUser(false);
				     cont(true);
				 } else {
				     cont(false, "Uh oh I can't connect to the server.<br>Please check your internet connection or try again later.");
				 }
			     }});
    }
};

var doLogin = function(username, password, cont) {
    $.ajax( {type:"POST",
       		  url:BASE_URL + "/login",
		  beforeSend:function(username,password) {
		      return function(req) { 
			  var header = JV3.plumutil.make_base_auth(username,password);
			  req.setRequestHeader('Authorization','');
			  req.setRequestHeader('Authorization',header); // not sure why this is redundant here. 
		      };
		  }(username,password),
		  success: function(data,success, x) {
		      cont(true);
		  },
		  cache:false,
		  error: function(req,status) {
		      if (req.status == 401){
			  cont(false,"Username or password incorrect");
		      } else {
			  cont(false, "Uh oh I can't connect to the server.<br>Please check your internet connection or try again later.");
		      } 
		  }});
};

var validateRegistrationPass = function(cont) {
    var p1 = $("#pass1").val();
    var p2 = $("#pass2").val();
    p1 = JV3.plumutil.trim(p1);
    p2 = JV3.plumutil.trim(p2);
    if (p1.length > 3) {
	if (p1 == p2) {
	    return cont(true);
	} else {
	    return cont(false, "Your passwords don't seem to match. Try re-typing?");
	}
    }
    cont(false, "Passwords must have more than 3 characters");    
};

var sendCreateRequest = function() {
    var emailval = getEmailVal()
    var p1 = $("#pass1").val();
    var couhes  = $("#participate")[0].checked;

    setok(false);
    setmsg("Sending request...");
    var cont = function(success, info) {
	if (success) {
	    setmsg();
	    setmsg("You are now logged in!");
            $("#submit").hide();
            var listit_window = getListit();
	    try{
	        JV3.prefs.setBoolPref("sync.support",true);
	        JV3.setUser($("#email").val(),$("#pass1").val());
            } catch(e) {
                JV3.log(e);
            }
	    $("#email").attr("disabled",true);
	    $("#pass1").attr("disabled",true);
	    $("#pass2").attr("disabled",true);
	    $("#participate").attr("disabled",true);
	} else {
	    setmsg();
	    setmsg(info);
	}
    };

    cont(true);     // why do we do this?

    return $.ajax({ type:"POST",
			 url: BASE_URL + "/createuser/",
			 data:({ username: emailval, password: p1, couhes:couhes,firstname:"",lastname:"" }),
			 success: function(data,success) {
			     //success means that there exists already such an email adddr
			     // disabled redundant : cont(true);
			 },
			 cache:false,
			 error: function(data,status) {
			     cont(false,data.responseText);
			 }
		       });
}

var validate = function() {
    var cont = function(ok, msg) {
	setok(ok? true :false);
	setmsg(ok? "" :msg);
    };
    determineWhetherUserIsNewOrReturningBasedOnEmail(function(doregister,msg) {
	if (!doregister) {
	    cont(false,msg);
	}
	else {
	    validateRegistrationPass(function(ok,msg) {  cont(ok,msg); });
	}			    
    });
};

function submitchangepassword(email_addr) {
    var url = BASE_URL + "/changepasswordrequest?username="+email_addr;
    JV3.util.getMainWindow(window).content.document.location = url;
}

var ajax_requests = [];
var login_success = false;
$(document).ready(function() {
    $("#email").val("");
    setok(false);
    setmsg("");
    $("#couhes").hide();
    $("input:checked").attr("checked",false);
    $("#consent").attr("disabled",true);
    document.getElementById("email").addEventListener('keyup',validate,false); //charcode warnings go away when using this instead
    $("#email").blur(function() {validate();   });

    var login_ = function() {
	ajax_requests.push(1);
	setmsg("Checking..");
        doLogin(getEmailVal(),
		$("#loginpassword").val(),
		function(isLoggedIn,msg) {
		    ajax_requests.pop();
		    if(isLoggedIn) {
			// login successful.
			login_success = true;
                        try {
	                    JV3.prefs.setBoolPref("sync.support",true);
	                    JV3.setUser($("#email").val(),$("#loginpassword").val());
                        } catch(e) {
                            JV3.log(e);
                        }
			$("#email").attr("disabled",true);
			$("#loginpassword").attr("disabled",true);
                        if (false && close) { close(); }
			else {
       			    $("#submitlogin").fadeOut("fast");
			    $("#submitchangepassword").fadeOut("fast");
                        }
			setmsg("You are now logged in!");
			JV3.login();			
		    } else {
			if (ajax_requests.length == 0 && !login_success) {
			    setmsg(msg);
			}
		    }
		});
    };
    document.getElementById("loginpassword").addEventListener('keyup',login_,false);
    $("#loginpassword").blur(login_);
    $("#submitchangepassword").click(function() { submitchangepassword(getEmailVal()); });
    document.getElementById("pass1").addEventListener('keyup',validate,false);
    document.getElementById("pass2").addEventListener('keyup',validate,false);
    $("#submit").click(function() {
	sendCreateRequest();
    });	
    $("#participate").click(function() {
 	if ($("#participate")[0].checked)  {
            $("#couhes").fadeIn();
	} else {
	    $("#couhes").fadeOut();
	}
	validate();
    });
});
