
// Copyright (c) 2009 Massachusetts Institute of Technology

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:

// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//

function setItemHeight(tab) {
    var max = undefined;
    $(tab+" .item").each(function(i) {
        $(this).height("");
        var itemHeight = $(this).height();
        if (max === undefined || itemHeight > max) { max = itemHeight; }
    });
    $(tab+" .item").height(max);
};

function insertTutorial() {
    setTimeout( function() {
	
        JV3.util.getWindow().toggleSidebar('viewListitSidebar', true);
        JV3.insertTutorialNotes();
        $('#tutfeedback').slideDown();
        setItemHeight('#home');
    }, 100);
};

var sync = {
    init : function() {
		
        var usrField = document.getElementById("syncEmail");
        usrField.value = JV3.getUser().username === undefined ? "" : JV3.getUser().username;
        var pwdField = document.getElementById("syncPassword");
        pwdField.value = JV3.getUser().password === undefined ? "" : JV3.getUser().password;
        $("#syncChangePassword").click(function() {    submitchangepassword(usrField.value);     });
    },
    
    setmsg : function(msg) {
        if (msg && msg.length > 0) {
            $("#syncmsg").html(msg);
        } else {
            $("#syncmsg").html("&nbsp;");
        }
        setItemHeight('#preferences');
    },

    saveLogin : function() {
        ajax_requests.push(1);
        sync.setmsg("Checking..");
        doLogin($("#syncEmail").val(),
	        $("#syncPassword").val(),
	        function(isLoggedIn,msg) {
		    ajax_requests.pop();
		    if(isLoggedIn) {
		        // login successful.
			JV3.log(">> login success ----------");
		        login_success = true;
                        try {
			    
	                    JV3.prefs.setBoolPref("sync.support",true);
	                    JV3.setUser($("#syncEmail").val(),$("#syncPassword").val());
                        } catch(e) {
                            JV3.log(e);
                        }
			JV3.log(">> sync setmessage");
		        sync.setmsg("You are now logged in!");
		    } else {
		        if (ajax_requests.length == 0 && !login_success) {
			    sync.setmsg(msg);
		        }
		    }
	        });
    },

    syncNow:function() {
	JV3.sync_now();
    },

    createLoginInfo : function(username, password) {
        var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1",
            Components.interfaces.nsILoginInfo,
            "init");
        // Note that I use "chrome://listit" and "list.it sync" to find the login later, so this can't change
        var loginInfo = new nsLoginInfo("chrome://listit", null, "list.it sync", username, password, "", "");
        return loginInfo;
    },

    saveSync: function() {
        var username = document.getElementById("syncEmail").value;
        var password = document.getElementById("syncPassword").value;
        JV3.setUser(username, password);
        $("#syncNotice").text("saved.");
    },

    showSync : function() {
        // call this by clicking on the syncNotice label
        var loginInfo = JV3.getUser();
        $("#syncNotice").text("user: " + loginInfo.username + " pass: " + loginInfo.password);
    }

};

var hotkeys = {
    init : function() {
		
        var opencloseField = document.getElementById("openCloseHotkey");
        $(opencloseField).val(JV3.prefs.getCharPref("hotkey.open"));
        opencloseField.addEventListener('keypress',hotkeys.captureKeyCombo(opencloseField,"open"),false);
        var searchField = document.getElementById("searchHotkey");
        $(searchField).val(JV3.prefs.getCharPref("hotkey.search"));
        searchField.addEventListener('keypress',hotkeys.captureKeyCombo(searchField,"search"),false);
        var inputField = document.getElementById("inputHotkey");
        $(inputField).val(JV3.prefs.getCharPref("hotkey.input"));
        inputField.addEventListener('keypress',hotkeys.captureKeyCombo(inputField,"input"),false);
        var urlField = document.getElementById("urlHotkey");
        $(urlField).val(JV3.prefs.getCharPref("hotkey.url"));
        urlField.addEventListener('keypress',hotkeys.captureKeyCombo(urlField,"url"),false);
    },

    setmsg : function(msg) {
        if (msg && msg.length > 0) {
            $("#hotkeymsg").html(msg);
        } else {
            $("#hotkeymsg").html("&nbsp;");
        }
        setItemHeight('#preferences');
    },

    captureKeyCombo : function(field,hotkey) {
        return function(event) {
            //console.debug(event);
	    if (event.keyCode === 0) {
	        event.preventDefault();
	    }
	    if (event.charCode === 0) {
	        return false;
	    }
	    var keyString = String.fromCharCode(event.charCode).toUpperCase();
	    if (event.shiftKey) {
	        keyString = "Shift+"+keyString;
	    }
	    if (event.ctrlKey) {
	        keyString = "Control+"+keyString;
	    }
	    if (event.metaKey) {
	        keyString = "Meta+"+keyString;
	    }
	    if (event.altKey) {
	        keyString = "Alt+"+keyString;
	    }

	    if(keyString.length>1) {
	        if (hotkeys.hotkeyTaken(keyString)) {
                    var oldKeyString = $(field).val();
                    $(field).val("sorry, that one's taken");
                    clearTimeout(hotkeys.timeout);
		    hotkeys.timeout = setTimeout(function() { $(field).val(oldKeyString); }, 1500);
	        } else {
                    JV3.prefs.setCharPref("hotkey."+hotkey, keyString);
	            field.value = keyString + " Set!";
                    clearTimeout(hotkeys.timeout);
                    hotkeys.timeout = setTimeout(function(){ field.value = keyString; }, 1500);
                    hotkeys.setmsg('Please reset Firefox for changes to take effect.');
                }
	        return keyString;
	    }
	    return false;
        };
    },

    hotkeyTaken : function(keyString) {
		
        var keyChord = JV3.parseHotkey(keyString);
	var keys = getBrowserDocument().getElementById('mainKeyset').childNodes;
	var taken = false;
	keyChord[0] = keyChord[0].replace(new RegExp(JV3.accelKey,'ig'),"accel");
	var modifier = keyChord[0].split(',');
	for (var i=0; i<keys.length; i++) {
	    if (keyChord[1] === keys[i].getAttribute('key').toUpperCase()) {
		var keyModifier = keys[i].getAttribute('modifiers');
		var sameModifier = true; 
		for (var j=0; j<modifier.length; j++) {
		    if (!keyModifier.match(new RegExp(modifier[j], 'i'))) {
			sameModifier = false;
			break;
		    }
		}
		if (sameModifier) {
		    taken = sameModifier;
		    break;
		}
	    }
	}
	return taken;
    },

};

var appearance = {
    init : function() {
        try {
            var fontSize = document.getElementById("fontSize");
            fontSize.value = JV3.prefs.getIntPref("general.fontSize");
            var backgroundImage = document.getElementById("backgroundImage");
            backgroundImage.value = JV3.prefs.getCharPref("general.background");
            var halign = document.getElementById("backgroundHAlign");
            halign.value = JV3.prefs.getCharPref("general.halignBackground");
            var valign = document.getElementById("backgroundVAlign");
            valign.value = JV3.prefs.getCharPref("general.valignBackground");

            $("#fontSize").blur(appearance.setFontSize);
            $("#numButtons #numUp").click(function(event) {
                event.target.blur();
                $("#fontSize").val(parseInt($("#fontSize").val())+1);
                appearance.setFontSize();
            });
            $("#numButtons #numDown").click(function(event) {
                event.target.blur();
                $("#fontSize").val(parseInt($("#fontSize").val())-1);
                appearance.setFontSize();
            });	    	    
        } catch (x) {
            JV3.log(x);
        }
    },

    setBackground : function() {
        	
	var backgroundImage = JV3.prefs.getCharPref("general.background");
	if (!(backgroundImage.indexOf('file://') === 0 ||
	      backgroundImage.indexOf('chrome://') === 0)) {
	    backgroundImage = "file://"+backgroundImage;
	}
	if (backgroundImage) {
	    var halign = JV3.prefs.getCharPref("general.halignBackground");
	    var valign = JV3.prefs.getCharPref("general.valignBackground");
	    var center = halign + " " + valign;
            var listit_window = getListit();
	    // if (listit_window.isSidebarOpen()) {

	    try {
	        var mainBox = listit_window.getSidebarWindow().document.getElementById('mainBox');
	        mainBox.style.backgroundImage = 'url("'+backgroundImage+'")';
	        mainBox.style.backgroundPosition = center;
	    } catch (x) {  }
	    
            // }
	}
    },

    chooseBackground : function() {
	
	const nsIFilePicker = Components.interfaces.nsIFilePicker;
	const nsILocalFile = Components.interfaces.nsILocalFile;

	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	var title = "Choose Image:";
	fp.init(window, title, nsIFilePicker.modeOpen);
	fp.appendFilters(nsIFilePicker.filterImages);

	var currentImage = JV3.prefs.getCharPref("general.background");

	try {
	    var dispDir = Components.classes["@mozilla.org/file/local;1"].
	    createInstance(nsILocalFile);
	    var lastSlash = currentImage.lastIndexOf('/');
	    if (lastSlash === -1) {
		lastSlash = currentImage.lastIndexOf('\\');
	    }
	    dispDir.initWithPath(currentImage.substring(0,lastSlash));
	    fp.displayDirectory = dispDir;
	} catch(e) {
	    var fileLocator = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
	    var homeDirPath = fileLocator.get("Home", Components.interfaces.nsILocalFile).path;
	    var dispDir = Components.classes["@mozilla.org/file/local;1"].
	    createInstance(nsILocalFile);
	    var picDirPath;
	    if (homeDirPath.indexOf('/') !== -1) {
		picDirPath = homeDirPath + "/Pictures";
	    } else {
		picDirPath = homeDirPath + "\\My Documents\\My Pictures";
	    }
	    dispDir.initWithPath(picDirPath);
	    fp.displayDirectory = dispDir;
	}

	if (fp.show() == nsIFilePicker.returnOK) {
	    var filePath = fp.file.path;
	    filePath = filePath.replace(/\\/g,'/'); // for windows paths that have backslashes
	    JV3.prefs.setCharPref('general.background','file://'+filePath);
            $("#backgroundImage").val('file://'+filePath);
            appearance.setBackground();
	}
    },

    clearBackground : function() {
	
        JV3.prefs.setCharPref("general.background","");
        $("#backgroundImage").val("");
        appearance.setBackground();
    },

    ensureNumeric : function(event) {
        if (event.keyCode === 0 && event.charCode < 48 || event.charCode > 57) {
            event.preventDefault();
        }
    },

    setFontSize : function() {
	try {
            var size = $("#fontSize").val();
            JV3.prefs.setIntPref("general.fontSize",size);
            var listit_window = getListit();
	    try {
	      // if (listit_window.isSidebarOpen()) {
                if (size == 0) {
                    listit_window.getSidebarWindow().jSidebar.noteInput.style.setProperty('font-size',"","");
                    listit_window.getSidebarWindow().jSidebar.getView().$j('#entries').css('font-size',"");
                    listit_window.getSidebarWindow().jSidebar.getView().$j('textarea').css('font-size',"");
                } else {
                    listit_window.getSidebarWindow().jSidebar.noteInput.style.setProperty('font-size',size+"px","");
                    listit_window.getSidebarWindow().jSidebar.getView().$j('#entries').css('font-size',size);
                    listit_window.getSidebarWindow().jSidebar.getView().$j('textarea').css('font-size',size);
                }
            // }
	    } catch (x) {    }		
	    
	} catch (x) {
	    JV3.log(x);
	}
    },

    setAlign : function() {
	
        JV3.prefs.setCharPref("general.halignBackground",$("#backgroundHAlign").val());
        JV3.prefs.setCharPref("general.valignBackground",$("#backgroundVAlign").val());
        appearance.setBackground();
    }
};

var misc = {
    init : function() {
	var this_ = this;
	
        var researchActivate = document.getElementById("researchActivate");
        if (JV3.prefs.getBoolPref("researchbar.enabled")) {
            researchActivate.innerHTML = "hide";
        }
        $(researchActivate).click(misc.toggleResearch);

	try {
	    var actlogActivate = document.getElementById("actlogActivate");
            if (!JV3.prefs.getBoolPref("actlog.enabled")) {
		actlogActivate.innerHTML =  "enable";
            }
            $(actlogActivate).click(function() { this_.toggleActLog(); });	    
	} catch (x) { }
    },

    toggleParticipation:function() {
	if (self.JV3.sync === undefined) {  self.JV3.log("Internal error- sync was null"); return;}
	self.JV3.log("current mode : " + current_mode);
	
	$(".study_participation").attr("disabled",true);
	_participate_button_show_error("sending request to server..");

	try {
	    var current_mode = self.JV3.getScienceMode();
	    self.JV3.setScienceMode(!current_mode,!current_mode);
	    self.JV3.sync.set_consenting(!current_mode,
					 function() {
					     JV3.login(function() {
						 try {
						     JV3.log("success login - ");
						     _participate_button_show_error(); // closure fail
						     _manage_participate_button_state();
						 } catch (x) {
						     JV3.log(x);
						 }
					     },function() {
						 _participate_button_show_error("error contacting server; please check your internet connection or try again later.");
					     });
					 },
					 function() {
					     _manage_participate_button_state();
					     _participate_button_show_error("error contacting server; please check your internet connection or try again later.")
					 });		    
	    
	} catch (x) {
	    JV3.log(x);
	}	
    },
    
    toggleActLog : function() {
	/*
	
	var abutton = document.getElementById("actlogActivate");	
	JV3.prefs.setBoolPref("actlog.enabled", !JV3.prefs.getBoolPref("actlog.enabled"));
	if (JV3.prefs.getBoolPref("actlog.enabled")) {
	    abutton.innerHTML = "disable";
	    JV3.initialize_actlog();
	} else {
	    abutton.innerHTML = "enable";
	    delete JV3.actlog;
	}
	 */
    },

    toggleResearch : function() {
        var researchbarEnabled = JV3.prefs.getBoolPref("researchbar.enabled");
        var researchActivate = document.getElementById("researchActivate");
        var listit_window = getListit();
	JV3.prefs.setBoolPref("researchbar.enabled",!researchbarEnabled);
        researchActivate.innerHTML = researchbarEnabled ? "show" : "hide";
	try {
	    if (researchbarEnabled) {
		listit_window.getSidebarWindow().jSidebar.hideResearchbar();     
	    } else {
		listit_window.getSidebarWindow().jSidebar.loadResearchbar();		    
	    }
	} catch (x) {JV3.log(x);}
    }
};

var resetAll = function() {
    
    var obj = {};
    var allPrefs = JV3.prefs.getChildList("",obj);
    for (var i=0; i<allPrefs.length; i++) {
	try {
	    JV3.prefs.clearUserPref(allPrefs[i]);
	} catch(e) {
	    JV3.log(e);
	}
    }
    var label = this_._document.getElementById('changesLabel');
    label.setAttribute('value','Changes will take effect next time Firefox restarts.');
};

function getListit() { return JV3.util.getMainWindow(JV3.util.getWindow()).listit_window; }
function getBrowserDocument() {  return JV3.util.getMainWindow(JV3.util.getWindow()).document; }

function loadJV3() {
    
    self.JV3 = Components.classes['@electronic.max/listit;1'].getService().wrappedJSObject;
};

function _manage_participate_button_state() {
    
    JV3.log("manage participate " + JV3.sync !== undefined);
    var enabled = JV3.sync !== undefined;    
    if (!enabled) {
	if (JV3.getUser().username) {
	    _participate_button_show_error("Can't connect to server: please check your internet connection and hit Synchronize Now (upper left).");		    
	} else {
	    _participate_button_show_error("Before you can consent, please set up note synchronization.");		    
	}

    } else {
	_participate_button_show_error();	
    }
    $(".study_participation").attr("disabled", !enabled);
    if (self.JV3.getScienceMode()) {
	//JV3.log("setting participate button to withdrawal");
	$(".study_participation").html("Currently participating in study.<br>Click to withdraw/cancel.");
	$(".study_participation").removeClass("not_participating");
    } else {
	//JV3.log("setting participate button to part");
	$(".study_participation").html("Currently not participating.<br>Click to participate.");
	$(".study_participation").addClass("not_participating");
        $("#study_ad").show();
        if ($("#home .item").height() < 1) {
            $("#home").css("display","block");
            setItemHeight("#home");
            $("#home").css("display","");
        }
    }
}

function _participate_button_show_error(html) {
    JV3.log("pbshowerror: " + html);
    var val = html || "";
    $(".study_participation_error").html(val);
    if (val.length > 0) {
	$(".study_participation_error").slideDown("slow");
    } else {
	$(".study_participation_error").slideUp("slow");
    }
}


/* participation button */
$(document).ready(function() {
    if (JV3.sync === undefined) {
	try {
	    JV3.log("adding ------- observer ");
	    
	    var o = ({
		observe: function(subject,topic,data) {
		    _manage_participate_button_state();
		    sync.init();		  //_update_login_password();
		    $("#registration").hide();				  
		}
	    });
	    JV3._getObserverService().addObserver(o,"login-success",false);
	    JV3._getObserverService().addObserver(o,"sync-success",false);
	    // get rid of observer
	    document.addEventListener("pagehide",function() {
		JV3._getObserverService().removeObserver(o,"login-success",false);
	    },true);
	    
	} catch (x) {
	    JV3.log(x);
	}
    }
    _manage_participate_button_state();
});

$(document).ready(
    function() {
	
	loadJV3();
	if (JV3.getUser() === undefined || JV3.getUser().username === undefined) //	{  $("#registration").show();    }
	$("#contribute").click(function() { $(this).children("a").click(); });
	$("#showlearnsmart").click(function() { $("#learnsmart").slideToggle(200); });

	// init!
//	sync.init();
	hotkeys.init();
	appearance.init();
//	misc.init();
	
	setItemHeight("#home");
	setItemHeight("#preferences");
	
	$("#tabs").tabs();
    });
	