

// Copyright (c) 2009 Massachusetts Institute of Technology

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:

// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

(function(JV3,analysis,interaction) {
    
    var plumdate = analysis.PlumDate;
    var log = JV3.log;
    var util = JV3.util;

    interaction.lens = {
	textspan: {
	    date: function(string, meaning) {
		var class_ = "semdate__"+JV3.plumutil.guid();
		return [
		    "<span class=\"semantics_date  "+class_+"\">"+string+"</span>", // html
		    function(document,item) { // event click handler

			var jspan = document.$j(item).find(".semantics_date");

			/*
                        not ready yet!
			JV3.$j(item).click(function(evt) {
			    try {
				if (jspan.popup === undefined) {
				    jspan.popup = document.$j("<div class=\"sempopup\" style=\"position:absolute;z-index:+1;background-color:rgba(200,200,200,0.7);display:none\">Semantics</div>").
					css("top", jspan.position().top).
					css("left", jspan.position().left).
					css("width", jspan.width()).
					css("height",jspan.height()).
					appendTo(jspan).slideDown();
				}
			    } catch(e4) {
				JV3.log(e4 + " || " + e4.lineNumber + " " + e4.fileName);
			    }			    
			});
                        */

			document.$j(item).bind("mouseover", 
					       function() {
						   try {						       
						       var ce = arguments.callee;
						       while (jspan.queue().length > 0) {   jspan.dequeue();     }
						       jspan.stop();
						       jspan.animate({color:"yellow"}, 500, undefined,function() {   });						       
						       // log("top: " + jspan.position().top + " " + jspan.position().left);
       
						       
						   } catch(e2) {
						       JV3.log(e2 + " ?? " + e2.lineNumber + " " + e2.fileName);
						   }						   
					       });
			document.$j(item).bind("mouseout", function() {
			    try {
				jspan.animate({color:"white"}, 700, undefined, function() { if (jspan.popup !== undefined) { jspan.popup.slideUp(); jspan.popup.remove(); jspan.popup = undefined; } });
			    } catch(e3) {
				JV3.log(e3 + " || " + e3.lineNumber + " " + e3.fileName);
			    }
			});
			
			return true;
		    }
		];
	    }
	},    
	getTextSpanLens: function(type,string,semantics) {
	    if (this.textspan[type]) {
		return this.textspan[type](string,semantics);	
	    }
	}
    };
    
});