

(function(JV3,ContextMaiden) {
    ContextMaiden.WatchMeContextProvider = {
	id: 'ContextMaiden.WatchMeContextProvider',
	type:'www',
	insteam_update:true, // when true, tries to run update() every push
	use_queue:false,	
	initialize:function(CMS, params) {
	    let this_ = this;
	    this.util = JV3.plumutil;
	    this.log = params.log;
	    this.entity_store = CMS.entity_store;
	    this.FWS = ContextMaiden.FWS;
	    this.FWS.initialize();
	    this.FWS.handleEvent = function(type,location,host,title,fulltext,event) {
		try {
		    //JV3.log("handle event : " + type + " " + location + " " + host);
		    if (!JV3.isPrivateBrowsing()){
			this_.dispatch_event.apply(this_,arguments);
			if (JV3.is_watchme_logging_enabled()) {
			    //JV3.log("beep beep");
			    // user in stealth mode? then we don't log
			    
			    // if (title === undefined || title.length == 0) {
			    // 	JV3.log("___________ title undefined while trying to deal with " + location);
			    // }
			    
			    if (JV3.doEncryptActivities()) {
				this_.update_queue({id:new Date().valueOf(), type:type, location:JV3.salt_hash(location), host:JV3.salt_hash(host)});
			    } else {
				this_.update_queue({ id:new Date().valueOf(), type:type, location:location, host:host, title:title });
			    }
			}
		    } 		    
		} catch (x) {
		    JV3.log(x);
		}
	    };
	    this._populate_page_cache();
	},
	_populate_page_cache:function() {
	    this._pages_ = {};
	    // let pages = {};
	    // this._pages_ = pages;
	    // this.entity_store.getEntitiesAsync({type:"schemas.Webpage"},  undefined, function(pages) {  pages.map(function(p) {  pages[p.id] = p;  }); });
	},
	_get_page_:function(url,title,host,cont) {
	    let this_ = this;
	    let pages = this._pages_;
	    if (pages[url] !== undefined) { return cont(this._pages_[url]); }
	    let nx = {
		type:"schemas.Webpage",
		id:url,
		name:url,
		title:title,
		host: host
	    };
	    // JV3.log("-cache-miss-get-"+url);
	    var _time = new Date();
	    this._pages_[url] = nx;
	    this.entity_store.get_or_createAsync(nx,function(nxout) {
						     // JV3.log("page get " + (new Date().valueOf() - _time.valueOf()) + "msec ", nxout, " -- "); 
						     pages[nxout.id] = nxout;
						     cont(nxout);
						 }); /* took out a bit about setting the title */	    
	},
	set_url_filter:function(fn) {   this.filter = fn; },
	eval_filter:function(url,host,title) {
	    if (this.filter !== undefined) { return this.filter(url,host,title); };
	    return true;
	},	
	shutdown:function() {
	    this.FWS.shutdown();
	},
	listeners:{},
	dispatch_event:function(event_type,url,host,title,text,event) {
	    try {
		let ltype = this.listeners[event_type];
		if (ltype) {
		    let tocall = (ltype.__all__ ? ltype.__all__ : []).concat( ltype[url] ? ltype[url] : [] ).concat( ltype[host] ? ltype[host] : [] );
		    tocall.map(function(ll) {  try {   ll(event_type,url,host,title,text,event);  } catch (x) { JV3.log(x);  }    });
		}		
	    } catch (x) {
		JV3.log(x);
	    }
	},
	add_listener:function(evttype,url_or_host,listener) {
	    if (url_or_host === undefined) { url_or_host = "__all__"; }
	    if (this.listeners[evttype] === undefined) { this.listeners[evttype] = {}; }
	    if (this.listeners[evttype][url_or_host] === undefined) { this.listeners[evttype][url_or_host] = []; }
	    this.listeners[evttype][url_or_host].push(listener);
	},
	remove_listener:function(evttype,url_or_host,listener) {
	    if (url_or_host === undefined) {url_or_host = "__all__"; }
	    if (this.listeners[url_or_host].indexOf(listener) >= 0) {
		JV3.plumutil.removeElement(this.listeners[url_or_host],listener);
	    }
	},
	_create_new_event: function(location,title,host,cont) {
	    //JV3.log("idle " + url);
	    this._get_page_(location,title,host,function(page){
				cont({ type: "www-viewed", start: new Date().valueOf(), end: new Date().valueOf(), entity: page});
			    });
	},	    

	_create_new_event_dd : function(startDatum, endDatum, cont){
	    // return well-formed thingies we can feed directly to the watchme event store
	    //JV3.log("dd " + startDatum.location);
	    let start = new Date(startDatum.id).valueOf();
	    let end = new Date(endDatum.id).valueOf();
	    let title = startDatum.title;
	    let host = startDatum.host;
	    let location = startDatum.location;
	    let newify = JV3.PROTOCROCK.newify;
	    let schemas = JV3.schemas;
	    let entity_store = this.entity_store;
	    this._get_page_(location,title,host, function(page) { cont({ type: "www-viewed", start: start, end: end, entity: page    }); });
	},
	
	_extend_event : function(startEvent, endDatum, cont){
	    // return well-formed thingies we can feed directly to the watchme event store
	    //JV3.log("ed " + startEvent.entity.id);

	    let start = startEvent.start;
	    // JV3.log("extending start : " + start);
	    let end = new Date(endDatum.id).valueOf();
	    let title = startEvent.entity.title;
	    let host = startEvent.entity.host;
	    let location = startEvent.entity.id;
	    
	    let newify = JV3.PROTOCROCK.newify;
	    let schemas = JV3.schemas;
	    let entity_store = this.entity_store;
	    this._get_page_(location,title,host, function(page) { cont({ type: "www-viewed", start: start, end: end, entity: page }); });
	},

	queue_timeout: 10000,

	update_queue:function(datum) {
	    if (!this.use_queue) { return this.update(datum);   }
	    
	    try {
		let this_ = this;
		if (this.__queue === undefined) { this.__queue = []; }
		this.__queue.push(datum);
		if (this.__queueTimer !== undefined) {
		    JV3.clearTimeout(this.__queueTimer);
		}
		this.__queueTimer = JV3.setTimeout(function() {
		    try {
			JV3.plumutil.interval_map( this_.__queue,
						   function(x) { this_.update(x); },
						   function() { /*JV3.log("flush completed.");*/},
						   function(x) { JV3.log(x); },
						   600, JV3 );
		    } catch(e) {
			JV3.log(e);
		    }
		    //this_.__queue.map(function(x) { this_.update(x); });
		    this_.__queue = [];
		},this_.queue_timeout);
	    } catch(e) {
		JV3.log(e);
	    }
	},

	minimum_threshold:200,

	get_current_focused_page:function() {	    
	    let doc = JV3.get_current_focused_page();

	    // debug debug
	    if (doc.title === undefined || doc.title.length == 0) {
		// JV3.log("___________ title undefined while trying to deal with " + doc.loc);
		doc.title = '';
	    }
	    // <-- debug
	    
	    if (doc && JV3.doEncryptActivities()) {
		return {
		    loc:JV3.salt_hash(doc.loc),
		    host:JV3.salt_hash(doc.host),
		    path:JV3.salt_hash(doc.path),
		    title:JV3.salt_hash(doc.title)
		};		
	    }
	    return doc;	    
	},

	update:function(datum) {
	    let event_store = JV3.CMS.event_store;
	    let this_ = this;
	    let FWS = this.FWS;
	    
	    let save = function(evt) {
		// -- debug --
		// if (this_.eval_filter(evt.entity.id,evt.entity.host,evt.entity.title)) {
		//     JV3.log("watchme: SAVE event " +  evt.entity.id + " -- " + (evt.end.valueOf()-evt.start.valueOf()) +  "msec " + evt.start.valueOf() + " " + evt.end.valueOf() );
		// }
		// -- debug --
		if (this_.eval_filter(evt.entity.id,evt.entity.host,evt.entity.title)) { //  && evt.end - evt.start > this_.minimum_threshold) {
		    try {event_store.saveAsync( evt, function() { /*JV3.log("saved event ... ",evt.entity.id,(evt.end-evt.start));*/ } );   } catch (x) { JV3.log(x); }		    
		}
	    };
	    if (datum === null || datum === undefined) { return; }
	    
	    if (datum.type == FWS.PAGE_LOADED) {
		// new page, let's hang on to it
		// this.last_viewed = this_._create_new_event_dd(datum,datum);

		this_._create_new_event_dd(datum,datum,function(x) {
					       if (this_.last_viewed === undefined || this_.last_viewed.entity.id !== x.entity.id) {
						   //JV3.log("PL setting last_viewed " + x.entity.id + " " + x.start);
						   this_.last_viewed = x;	   
					       }					       
					   });		
	    } else if (datum.type == FWS.WINDOW_FOCUSED || datum.type == FWS.USER_AWAKE) {
		// then datum can't tell what the title is, so we have to seek it out for ourselves
		// replace it with our current observation ~		
		let cpage = this_.get_current_focused_page();

		if (this.last_viewed !== undefined) {
		    // user wasn't idle, we're just getting a "focus" event either due to page load
		    // or due to click on same page
		    if (this.last_viewed.entity.id != cpage.loc) {
			// different page, must be a load
			this_._extend_event(this.last_viewed,datum,function(p) {
						// saveit! previous event
						this_.last_viewed = undefined;
						//JV3.log("previous-cp");
						save(p);
						// push new load
						this_._create_new_event(cpage.loc,cpage.title,cpage.host, function(cp) {
									    try {
										this_.last_viewed = cp;
										//JV3.log("new-cp");
										save(cp);
									    } catch (x) {
										JV3.log(x);
									    }
									});
					    });

		    } else {
			// still the same, "focus" just a click,  don't do anything
		    }		    
		} else {
		    // last_viewed is nothing, so the user REALLY was idle
		    //this.last_viewed = this._create_new_event(cpage.loc,cpage.title,cpage.host);
		    //JV3.log("watchme(): AWAKE=" + datum.type + " " + datum.location);
		    this._create_new_event(cpage.loc,cpage.title,cpage.host, function(p) {
					       this_.last_viewed = p;
					       //JV3.log("-p-");
					       save(p);
					   });
		}
		
	    } else  if (/*datum.type == FWS.PAGE_UNLOADED || */datum.type == FWS.USER_IDLE || datum.type == FWS.WINDOW_UNFOCUSED) {
		//JV3.log("watchme(): UNLOAD/IDLE=" + datum.type + " " + datum.location);
		try {
		    if (this.last_viewed !== undefined) {
			this_._extend_event(this.last_viewed,datum, function(p) { /*JV3.log("idle-p");*/ save(p); });
			this_.last_viewed = undefined;
		    }
		} catch(e) {   JV3.log(e);      }
	    }
	}
    };
})



 	    /* old fsm 
	    if (datum === null) {
		// then we're being called by not handleEvent --
		// check to see if we have a
		//JV3.log("watchme: no new events");
		JV3.log("watchme(): NULL=");
		if (this.last_viewed !== undefined) {
		    // update the last one
		    save( this_._recmaker_ed(this.last_viewed, datum) );
		    return;
		}
		// nothing new, we just return
		return;
	    }
	    // we're being called by FWS.handleEvent ->
	    if (datum.type == FWS.PAGE_LOADED || datum.type == FWS.TAB_SWITCHED || datum.type == FWS.WINDOW_FOCUSED || datum.type == FWS.USER_AWAKE) {
		// hack test .. if we get a second page load from the same key, just extend it
		JV3.log("watchme(): LOAD= " + datum.id + " " + datum.type + " " + datum.location );
		if (this.last_viewed && this.last_viewed.entity.id == datum.location) {
		    // JV3.log("extending -----> ");
		    try {
			save( this_._recmaker_ed(this.last_viewed, datum) );
		    } catch (e) {
			JV3.log(e + " " + e.lineNumber + " " + e.fileName);
		    }
		    // we got a double load! make end updated
		    return;
		}

		this.last_viewed = this_._recmaker_dd(datum,datum);
		save(this.last_viewed);
	    }
	    if (datum.type == FWS.PAGE_UNLOADED || datum.type == FWS.USER_IDLE || datum.type == FWS.WINDOW_UNFOCUSED) {
		JV3.log("watchme(): UNLOAD=" + datum.type + " " + datum.location);
		try {
		    if (this.last_viewed) {
			save(this_._recmaker_ed(this.last_viewed,datum));
			if (this.last_viewed.entity.id == datum.location) {
			    this.last_viewed = undefined;
			}		
		    }
		} catch(e) {
		    JV3.log(e + " " + e.lineNumber + " " + e.fileName);
		}
	    }	*/
