(function(JV3,ContextMaiden) {
    ContextMaiden.WatchMeContextProvider = {
	id: 'ContextMaiden.WatchMeContextProvider',
	type:'www',
	insteam_update:true, // when true, tries to run update() every push
	use_queue:false,	
	initialize:function(CMS, params) {
	    var this_ = this;
	    this.util = JV3.plumutil;
	    this.log = params.log;
	    this.entity_store = CMS.entity_store;
	    this.FWS = ContextMaiden.FWS;
	    this.FWS.initialize();
	    this.FWS.handleEvent = function(type,location,host,title,fulltext,event) {
		try {
		    //JV3.log("handle event : " + type + " " + location + " " + host);
		    if (!JV3.isPrivateBrowsing()){
			this_.dispatch_event.apply(this_,arguments);
			if (JV3.is_watchme_logging_enabled()) {
			    //JV3.log("beep beep");
			    // user in stealth mode? then we don't log
			    if (JV3.doEncryptActivities()) {
				this_.update_queue({id:new Date().valueOf(), type:type, location:JV3.salt_hash(location), host:JV3.salt_hash(host)});
			    } else {
				// if (title === undefined || title.length == 0) {
				//     JV3.log("___________ title undefined while trying to deal with " + location);
				// }
				this_.update_queue({ id:new Date().valueOf(), type:type, location:location, host:host, title:title });
			    }
			}
		    } 		    
		} catch (x) {
		    JV3.log(x);
		}
	    };	    
	},
	set_url_filter:function(fn) {   this.filter = fn; },
	eval_filter:function(url,host,title) {
	    if (this.filter !== undefined) { return this.filter(url,host,title); };
	    return true;
	},	
	shutdown:function() {
	    this.FWS.shutdown();
	},
	listeners:{},
	dispatch_event:function(event_type,location,host,title,text,event) {
	    try {
		var ltype = this.listeners[event_type];
		if (ltype) {
		    var tocall = (ltype.__all__ ? ltype.__all__ : []).concat( ltype[location] ? ltype[location] : [] ).concat( ltype[host] ? ltype[host] : [] );
		    tocall.map(function(ll) {  try {   ll(event_type,location,host,title,text,event);  } catch (x) { JV3.log(x);  }    });
		}		
	    } catch (x) {
		JV3.log(x);
	    }
	},
	add_listener:function(evttype,url_or_host,listener) {
	    if (url_or_host === undefined) { url_or_host = "__all__"; }
	    if (this.listeners[evttype] === undefined) { this.listeners[evttype] = {}; }
	    if (this.listeners[evttype][url_or_host] === undefined) { this.listeners[evttype][url_or_host] = []; }
	    this.listeners[evttype][url_or_host].push(listener);
	},
	remove_listener:function(evttype,url_or_host,listener) {
	    if (url_or_host === undefined) {url_or_host = "__all__"; }
	    if (this.listeners[url_or_host].indexOf(listener) >= 0) {
		JV3.plumutil.removeElement(this.listeners[url_or_host],listener);
	    }
	},
	/* "datums" look like { id:new Date().valueOf(), type:type, location:location, host:host, title:title } */
	/* "events" look like {
		type: "www-viewed",
		start: start, end: end,
		entity: entity_store.get_or_create({
		    type:"schemas.Webpage",
		    id: location,
		    name: location,
		    title:title,
		    host: host
		})
	    };
	*/

	_recmaker_idle: function(location,title,host) {
	    //JV3.log("idle " + location);
	    var entity_store = this.entity_store;
	    return ({
		type: "www-viewed",
		start: new Date(), end: new Date(),
		entity: entity_store.get_or_create({
		    type:"schemas.Webpage",
		    id: location,
		    name: location,
		    title:title,
		    host: host
		})
	    });
	},

	_recmaker_dd : function(startDatum, endDatum){
	    // return well-formed thingies we can feed directly to the watchme event store
	    //JV3.log("dd " + startDatum.location);
	    var start = new Date(startDatum.id);
	    var end = new Date(endDatum.id);
	    var title = startDatum.title;
	    //JV3.log("dd_title: " + title);
	    var host = startDatum.host;
	    var location = startDatum.location;
	    var newify = JV3.PROTOCROCK.newify;
	    var schemas = JV3.schemas;
	    var entity_store = this.entity_store;
	    return {
		type: "www-viewed",
		start: start, end: end,
		entity: entity_store.get_or_create({
		    type:"schemas.Webpage",
		    id: location,
		    name: location,
		    title: title,
		    host: host
		})
	    };
	},
	
	_recmaker_ed : function(startEvent, endDatum){
	    // return well-formed thingies we can feed directly to the watchme event store
	    //JV3.log("ed " + startEvent.entity.id);
	    var start = startEvent.start;
	    var end = new Date(endDatum.id);
	    var title = startEvent.entity.title;
	    //JV3.log("ed_title: " + endDatum.title + "           " + JV3.plumutil.toJSON(startEvent));
	    var host = startEvent.entity.host;
	    var location = startEvent.entity.id;
	    var newify = JV3.PROTOCROCK.newify;
	    var schemas = JV3.schemas;
	    var entity_store = this.entity_store;	    
	    return {
		type: "www-viewed",
		start: start, end: end,
		entity: entity_store.get_or_create({
		    type:"schemas.Webpage",
		    id: location,
		    name: location,
		    title:title,
		    host: host
		})
	    };
	},

	queue_timeout: 10000,

	update_queue:function(datum) {
	    if (!this.use_queue) { return this.update(datum);   }
	    
	    try {
		var this_ = this;
		if (this.__queue === undefined) { this.__queue = []; }
		this.__queue.push(datum);
		if (this.__queueTimer !== undefined) {
		    JV3.clearTimeout(this.__queueTimer);
		}
		this.__queueTimer = JV3.setTimeout(function() {
		    try {
			JV3.plumutil.interval_map( this_.__queue,
						   function(x) { this_.update(x); },
						   function() { /*JV3.log("flush completed.");*/},
						   function(x) { JV3.log(x); },
						   600, JV3 );
		    } catch(e) {
			JV3.log(e);
		    }
		    //this_.__queue.map(function(x) { this_.update(x); });
		    this_.__queue = [];
		},this_.queue_timeout);
	    } catch(e) {
		JV3.log(e);
	    }
	},

	minimum_threshold:200,

	get_current_focused_page:function() {
	    var doc = JV3.get_current_focused_page();
	    // if (doc.title === undefined || doc.title.length == 0) {
	    // 	JV3.log("___________title________________ is null for " + doc.title);
	    // }
	    if (doc && JV3.doEncryptActivities()) {
		return {
		    loc:JV3.salt_hash(doc.loc),
		    host:JV3.salt_hash(doc.host),
		    path:JV3.salt_hash(doc.path),
		    title:JV3.salt_hash(doc.title)
		};		
	    }
	    return doc;	    
	},

	update:function(datum) {
	    var event_store = JV3.CMS.event_store;
	    var this_ = this;
	    var FWS = this.FWS;
	    
	    var save = function(evt) {

		// -- debug --
		if (this_.eval_filter(evt.entity.id,evt.entity.host,evt.entity.title)) {
		    JV3.log("watchme: SAVE event " +  evt.entity.id + " -- " + (evt.end.valueOf()-evt.start.valueOf()) +  "msec " + evt.start.valueOf() + " " + evt.end.valueOf() );
		}
		// -- debug --

		if (this_.eval_filter(evt.entity.id,evt.entity.host,evt.entity.title) && evt.end - evt.start > this_.minimum_threshold) {
		    event_store.save( evt );	    		    
		}
	    };
	    if (datum === null || datum === undefined) { return; }
	    
	    if (datum.type == FWS.PAGE_LOADED) {
		// new page, let's hang on to it
		this.last_viewed = this_._recmaker_dd(datum,datum);		
	    } else if (datum.type == FWS.WINDOW_FOCUSED || datum.type == FWS.USER_AWAKE) {
		// then datum can't tell what the title is, so we have to seek it out for ourselves
		// replace it with our current observation ~		
		var cpage = this_.get_current_focused_page();

		if (this.last_viewed !== undefined) {
		    // user wasn't idle, we're just getting a "focus" event either due to page load
		    // or due to click on same page
		    if (this.last_viewed.entity.id != cpage.loc) {
			save(this_._recmaker_ed(this.last_viewed,datum));
			this.last_viewed = this._recmaker_idle(cpage.loc,cpage.title,cpage.host);
		    } else {
			// still the same, "focus" just a click,  don't do anything
		    }		    
		} else {
		    // last_viewed is nothing, so the user REALLY was idle
		    this.last_viewed = this._recmaker_idle(cpage.loc,cpage.title,cpage.host);
		}
		
	    } else  if (datum.type == FWS.PAGE_UNLOADED || datum.type == FWS.USER_IDLE || datum.type == FWS.WINDOW_UNFOCUSED) {
		//JV3.log("watchme(): UNLOAD=" + datum.type + " " + datum.location);
		try {
		    if (this.last_viewed !== undefined) {
			save(this_._recmaker_ed(this.last_viewed,datum));
			this.last_viewed = undefined;
		    }
		} catch(e) {   JV3.log(e);      }
	    }
	}
    };
})



 	    /* old fsm 
	    if (datum === null) {
		// then we're being called by not handleEvent --
		// check to see if we have a
		//JV3.log("watchme: no new events");
		JV3.log("watchme(): NULL=");
		if (this.last_viewed !== undefined) {
		    // update the last one
		    save( this_._recmaker_ed(this.last_viewed, datum) );
		    return;
		}
		// nothing new, we just return
		return;
	    }
	    // we're being called by FWS.handleEvent ->
	    if (datum.type == FWS.PAGE_LOADED || datum.type == FWS.TAB_SWITCHED || datum.type == FWS.WINDOW_FOCUSED || datum.type == FWS.USER_AWAKE) {
		// hack test .. if we get a second page load from the same key, just extend it
		JV3.log("watchme(): LOAD= " + datum.id + " " + datum.type + " " + datum.location );
		if (this.last_viewed && this.last_viewed.entity.id == datum.location) {
		    // JV3.log("extending -----> ");
		    try {
			save( this_._recmaker_ed(this.last_viewed, datum) );
		    } catch (e) {
			JV3.log(e + " " + e.lineNumber + " " + e.fileName);
		    }
		    // we got a double load! make end updated
		    return;
		}

		this.last_viewed = this_._recmaker_dd(datum,datum);
		save(this.last_viewed);
	    }
	    if (datum.type == FWS.PAGE_UNLOADED || datum.type == FWS.USER_IDLE || datum.type == FWS.WINDOW_UNFOCUSED) {
		JV3.log("watchme(): UNLOAD=" + datum.type + " " + datum.location);
		try {
		    if (this.last_viewed) {
			save(this_._recmaker_ed(this.last_viewed,datum));
			if (this.last_viewed.entity.id == datum.location) {
			    this.last_viewed = undefined;
			}		
		    }
		} catch(e) {
		    JV3.log(e + " " + e.lineNumber + " " + e.fileName);
		}
	    }	*/
