// Copyright (c) 2009,2008 Massachusetts Institute of Technology

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:

// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

__defn_module("context-maiden",function(JV3) { 
     JV3.ContextMaiden = {
	 entityid: function(thing) {
	     if (typeof(thing) == "object") { return thing.id; }
	     if (typeof(thing) == "string") { return thing; }
	     return undefined;
	 },
	 entitytype: function(thing) {
	     if (typeof(thing) == "object") { return thing.type; }
	     return undefined;
	 }	
     };
     JV3.ContextMaiden.rehydrate_entity = function(rehydrated) {
	 var entity_store = JV3.CMS.entity_store;
	 var plumutil = JV3.plumutil;
	 var clauses = {};
	 if (rehydrated.entityid) {   clauses.id = rehydrated.entityid;	 }
	 if (rehydrated.entitytype) {   clauses.type = rehydrated.entitytype;	 }
	 if (JV3.plumutil.objKeys(clauses).length > 0) {
	     var rehyd_ent = undefined; 
	     try { rehyd_ent = entity_store.getEntities(clauses);  } catch(e) { JV3.log(e);   }
	     if (rehyd_ent !== undefined && rehyd_ent.length > 0) {
		 return rehyd_ent[0];
	     }
	 }
	 return undefined; // undefined;
     };
     JV3.ContextMaiden.dehydrate_entity = function(hydrated){
	 var entity_store = JV3.CMS.entity_store;
	 entity_store.save(val.entity);
	 return { entityid:val.id,  entitytype:val.type };
     };     
 });