__defn_module("memdb",
	      function(JV3) {
		  JV3.ContextMaiden.MemDB = {
		      by_idtype:{},
		      initialize:function(stores) {
			  var this_ = this;
			  this.db = [];
			  if (stores) {
			      stores.map(function(stor) {
					     try { this_._loadFromDB(stor);    } catch (x) { JV3.log(x); }
					     stor.addStoreUpdateListener(undefined, function(rent) { this_.saveEntity(rent);  });
					 });
			  }
			  this._populate_types();
		      },
		      _populate_types:function() {
			  var this_ = this;
			  JV3.schemas.getTypes().map(function(t) {  this_.saveEntity(t); });
		      },					   
		      _loadFromDB:function(toimport) {
			  var this_ = this;
			  if (toimport.getEntities) {
			      toimport.getEntities({}).map(function(en) { this_.saveEntity(en);  });
			      return;
			  }
			  if (toimport.getEvents) {
			      toimport.getEvents().map(function(en) { this_.saveEntity(this_.event2entity(en));  });
			      return;
			  }
		      },		      
		      _idtypetoken:function(ent) {  return JSON.stringify({id:ent.id,type:ent.type}); },
		      saveEntity : function(ent) {
			  ent = JV3.plumutil.clone(ent);
			  this.db = this.db.filter(function(x) { return (x.id !== ent.id || x.type !== ent.type); });
			  this.db.push(ent);
			  if (ent.id && ent.type){  this.by_idtype[this._idtypetoken(ent)] = ent; }
		      },
		      _clone_results:function(c) {  return c.map(function(x) { return JV3.plumutil.clone(x); });   },
		      getEntities:function(template) {					       
			  if ( template === undefined || JV3.plumutil.objKeys(template).length == 0 ) { return this._clone_results(this.db); };					       
			  if (template.id && template.type && JV3.plumutil.objKeys(template).length == 2) {
			      return this._clone_results([this.by_idtype[this._idtypetoken(template)]]);
			  }
			  return this._clone_results(this.db.filter(function(candidate) { return JV3.plumutil.objKeys(template).map(function(p) { return template[p] == candidate[p]; }).reduce(JV3.plumutil.and); }));
		      },
		      event2entity:function(event) {
			  var oo = {
			      id  : event.type + "-" + event.start,
			      eventtype: event.type
			  };
			  JV3.plumutil.clone(event,oo);
			  oo.type = 'event';
			  return oo;
		      },
		      dumpJSON : function() { return JSON.stringify(this.db);  }
		  };
	      });