__defn_module("stats",
	      function(JV3) {

		  let events = JV3.CMS.event_store;
		  
		  // TODO: fix me. 
		  let implicit_subj = {id:"__ME__",type:"schemas.Person"};		  
		  JV3.ContextMaiden.Stats = {};
		  
		  JV3.ContextMaiden.Stats.StreamingStatistic = {
		      initialize:function(params) {
			  // JV3.log("_________________________________________________________________________________ Streaming");
			  /* requires: {name:stat_name, table: <table>>; optional: constrain_to_type} ... */
			  let this_ = this;
			  this.name = params.name;
			  this.table = params.table;
		      },
		      _selector_from_entity: function(entity) {
			  if (entity === undefined) {
			      return undefined;
			  }
			  return ({id:entity.id, type:entity.type});
		      },

		  };

		  JV3.ContextMaiden.Stats.ExpiringStreamingStatistic = {
		      superclass:JV3.ContextMaiden.Stats.StreamingStatistic,
		      initialize:function(params) {
			  // JV3.log("_________________________________________________________________________________ Expiry");
			  /* requires: {name:stat_name, table: <table>, expiry: <expiry>; optional: constrain_to_type} ... */
			  JV3.PROTOCROCK.superclass(this,"initialize", params);
			  this.updated_to = -1;
			  this.expiry = params.expiry;
		      }
		  };
		  
		  JV3.ContextMaiden.Stats.StreamingStatistic1D = {
		      superclass:JV3.ContextMaiden.Stats.ExpiringStreamingStatistic,
		      initialize:function(params) {
			  let this_ = this;
			  // JV3.log("_________________________________________________________________________________1D");
			  /* requires: {name:stat_name, table: <table>, expiry: <expiry>; optional: constrain_to_type} ... */
			  JV3.PROTOCROCK.superclass(this,"initialize", params);
			  if (params.dont_subscribe !== true) { this.subscribeToUpdates(this,params.constrain_to_type);}
		      },
		      subscribeToUpdates:function(who,type) {
			  let this_ = this;
			  events.addStoreUpdateListener(type,
							({
							     itemUpdated:function(event) {
								 try {
								     who.update(event);
								     //JV3.log('update' + event);
								     // todo: move this out to something so we don't resave the table every time!
								     //JV3.log('saving in subscribeToUpdates');
								     this_.table.soft_save();
								 } catch(e) { JV3.log(e); }
							     }
							 }));			  
		      },
		      expiry_callback:function(new_start,new_end) {
			  let this_ = this;
			  //JV3.log("EXPIRY CLEAN UP " + new Date(new_start) + " " + new Date(new_end));
			  JV3.CMS.event_store.getEventsIntersectionAsync(this_.constrain_to_type,
									 [new_start,new_end],
									 function(evts) {
									     // only count them when they've fully passed
									     evts.filter(function(x_evt) { return x_evt.end < new_end; }).map(
										 function(x_evt) {
										     try {
											 this_.expire(x_evt);
										     } catch (x) {  JV3.log(x); }
										 });
									 });
		      },
		      _make_selector: function(subj,pred,obj) {
			  return {subj:subj, pred:pred, obj:obj};
		      },
		      make_selector_from_event:function(event0) {
			  let subj0 = implicit_subj;
			  return this._make_selector(subj0, event0.type, this._selector_from_entity(event0.entity)); 
		      },		      
		      get_values_raw:function(subj,pred,obj) {
			  let compare = function(x,y) {
			      if (typeof(x) == 'string' || typeof(y) == 'string') { return x == y; }
			      return x && y && x.id !== undefined && y.id !== undefined && x.type !== undefined && y.type !== undefined && x.id == y.id && x.type == y.type; 
			  };
			  let filter = function(pair) {
			      // JV3.log(pair);
			      // JV3.log((subj === undefined || subj.id == pair[0].subj.id));			      
			      // JV3.log((obj === undefined || obj.id == pair[0].obj.id));
			      // JV3.log((pred === undefined || pred.id == pair[0].pred.id));
			      
			      return (subj === undefined || compare(subj,pair[0].subj)) &&  (obj === undefined || compare(obj,pair[0].obj)) && (pred === undefined || compare(pred,pair[0].pred));
			  };
			  // JV3.log(this.table.getAllRows(this.name).length);
			  return this.table.getAllRows(this.name).filter(filter);
		      },
		      get_values:function(subj_ent,event_type,obj_ent) {
			  if (subj_ent === undefined) {  subj_ent = implicit_subj;  }
			  return this.get_values_raw(this._selector_from_entity(subj_ent), event_type, this._selector_from_entity(obj_ent));
		      }
		  };

		  

		  JV3.ContextMaiden.Stats.TotalTime = {
		      superclass:JV3.ContextMaiden.Stats.StreamingStatistic1D,
		      initialize:function(params) {
			  /* requires: {table: <table>, expiry: <expiry>; optional: constrain_to_type} ... */
			  // JV3.log("_________________________________________________________________________________total time");
			  try {
			      JV3.PROTOCROCK.superclass(this,"initialize", JV3.plumutil.clone({name:"totaltime"},params));
			  } catch (x) {
			      JV3.log(x);
			  }
		      },
		      update:function(new_event) {
			  // JV3.log("________JV3.ContextMaiden.Stats.TotalTime_______________________________ ");
			  // JV3.log(new_event);
			  let table = this.table;
			  let row = this.make_selector_from_event(new_event);
			  let col = this.name;
			  let val = table.getEntry(row,col);
			  // time extended events are events that were updated with a new end time --- 
			  let new_time = new_event.timeextension === undefined ? (new_event.end - new_event.start) : new_event.timeextension;
			  table.setEntry(row,col,(val === undefined || val === null ? 0 : val) + new_time);
		      },
		      expire:function(expired_event) {
			  //JV3.log('expiring a total time event ' + expired_event.start);
			  let table = this.table;
			  let row = this.make_selector_from_event(expired_event);
			  let col = this.name;
			  let val = table.getEntry(row,col);
			  if (val === undefined || val === null){ return; }
			  let expired_time = expired_event.end - expired_event.start;
			  if (expired_event.type == "location") {
			      //JV3.log("_____________________________________________________________ TOTALTIME EXPIRING " + expired_event.entity.id + " " + val + "->" + Math.max(0,val - expired_time));
			  }
			  table.setEntry(row,col,Math.max(0,val - expired_time));
		      }		      
		  };
		  
		  JV3.ContextMaiden.Stats.Counts = {
		      superclass:JV3.ContextMaiden.Stats.StreamingStatistic1D,
		      initialize:function(params) {
			  /* requires: {table: <table>, expiry: <expiry>; optional: constrain_to_type} ... */
			  JV3.PROTOCROCK.superclass(this,"initialize", JV3.plumutil.clone({name:"counts"},params));
		      },
		      update:function(new_event) {
			  let table = this.table;
			  let row = this.make_selector_from_event(new_event);
			  let col = this.name;
			  let val = table.getEntry(row,col);
			  table.setEntry(row,col,(val === undefined || val === null ? 0 : val) + 1); // just add 1
		      },     
		      expire:function(expired_event) {
			  let table = this.table;
			  let row = this.make_selector_from_event(expired_event);
			  let col = this.name;
			  let val = table.getEntry(row,col);
			  if (val === undefined || val === null){ return; }
			  table.setEntry(row,col,Math.max(0,val - 1));
		      }		      

		  };
		  JV3.ContextMaiden.Stats.TimePerDOW = {
		      superclass:JV3.ContextMaiden.Stats.StreamingStatistic1D,
		      initialize:function(params) {
			  /* requires: {table: <table>, expiry: <expiry>; optional: constrain_to_type} ... */
			  JV3.PROTOCROCK.superclass(this,"initialize", JV3.plumutil.clone({name:"timeperdow"},params));
		      },
		      update:function(new_event) {
			  let table = this.table;
			  let row = this.make_selector_from_event(new_event);
			  let col = this.name;
			  let val = table.getEntry(row,col);
			  if (val === undefined || val === null) { 
			      val = JV3.plumutil.intRange(0,6).map(function(){return 0;});
			  }

			  let new_time = new_event.timeextension === undefined ? new_event.end - new_event.start : new_event.timeextension;
			  let weekday = new Date(new_event.end).getDay();	  
			  if (val[weekday]){
			      val[weekday] += new_time;
			  } else { 
			      val[weekday] = new_time;
			  }	
			  
			  table.setEntry(row,col,val);
		      },
		      expire:function(expired_event) {
			  //JV3.log("EXPIRE.");
			  //JV3.log(expired_event);
			  let table = this.table;
			  let row = this.make_selector_from_event(expired_event);
			  let col = this.name;
			  let val = table.getEntry(row,col);
			  if (val === undefined || val === null){ return; }
			  let new_time = expired_event.end - expired_event.start;
			  let weekday = new Date(expired_event.end).getDay();	  
			  val[weekday] -= new_time;
			  val[weekday] = Math.max(0,val[weekday]);
			  table.setEntry(row,col,val);			  
		      }		        
		  };
		  
		  JV3.ContextMaiden.Stats.TimePerHour = {
		      superclass:JV3.ContextMaiden.Stats.StreamingStatistic1D,
		      initialize:function(params) {
			  /* requires: {table: <table>, expiry: <expiry>; optional: constrain_to_type} ... */
			  JV3.PROTOCROCK.superclass(this,"initialize", JV3.plumutil.clone({name:"timeperhour"},params));
		      },
		      getHourTime:function(time) {
			  let dt = new Date(time);
			  dt.setMinutes(0);
			  dt.setSeconds(0);
			  dt.setMilliseconds(0);
			  return dt.valueOf();
		      },
		      getTimeSpentPerHour:function(start, end) {
			  // returns an array of objects, with hour and time spent that hour
			  let startHour = new Date(start).getHours();	
			  let endHour = new Date(end).getHours();
			  let startDate = new Date(start);
			  let results = [];
			  
			  let HRINMSECS = 1*60*60*1000;
			  
			  for (let t = start; t < end; t += HRINMSECS) {
			      if (t == start) {
				  let topofNextHour = this.getHourTime(t) + HRINMSECS; 
				  results.push({hour:startHour % 24, timeSpent: Math.min(end-start, topofNextHour - start) });
			      } else {
				  let topofThisHour = this.getHourTime(t); 
				  results.push({hour:startHour % 24, timeSpent: Math.min(HRINMSECS,end - topofThisHour) } );
			      }
			      startHour += 1;
			  }			  
			  return results;
		      },
		      update:function(new_event) {
			  let table = this.table;
			  let row = this.make_selector_from_event(new_event);
			  let col = this.name;
			  let val = table.getEntry(row,col);
			  if (val === undefined || val === null) { 
			      val = JV3.plumutil.intRange(0,23).map(function(){return 0;});
			  }
			  let start_time = new_event.timeextension === undefined ? new_event.start : new_event.end - new_event.timeextension;

			  this.getTimeSpentPerHour(start_time, new_event.end).map(
			      function(t){
				  // yugly code, should use row-selectors instead!
				  if (val[t.hour]) {
				      val[t.hour] += t.timeSpent;
				  } else { 
				      val[t.hour] = t.timeSpent;					
				  }
			      });

			  table.setEntry(row,col,val);
		      },	
		      expire:function(expired_event) {
			  //JV3.log("EXPIRE.");
			  //JV3.log(expired_event);
			  let table = this.table;
			  let row = this.make_selector_from_event(expired_event);
			  let col = this.name;
			  let val = table.getEntry(row,col);
			  if (val === undefined || val === null){ return; }

			  //JV3.log("EXPIREDOW ___________________________ ");
			  //JV3.log(val);
			  this.getTimeSpentPerHour(expired_event.start, expired_event.end).map(
			      function(t){
				  val[t.hour] -= t.timeSpent;
				  val[t.hour] = Math.max(0,val[t.hour]);
			      });
			  table.setEntry(row,col,val);
		      }		      
		  };

		  JV3.ContextMaiden.Stats.TimePerHourTwo = {
		      superclass:JV3.ContextMaiden.Stats.StreamingStatistic2D,
		      initialize:function(params) {
			  /* requires: {table: <table>, expiry: <expiry>; optional: constrain_to_type} ... */
			  JV3.PROTOCROCK.superclass(this,"initialize", JV3.plumutil.clone({name:"timeperhour",dont_subscribe:true},params));
			  // manually subscribe as a 1-Der.
			  JV3.ContextMaiden.Stats.StreamingStatistic1D.subscribeToUpdates(this,params.constrain_to_type);
		      },
		      getHourTime:function(time) {
			  let dt = new Date(time);
			  dt.setMinutes(0);
			  dt.setSeconds(0);
			  dt.setMilliseconds(0);
			  return dt.valueOf();
		      },
		      getTimeSpentPerHour:function(start, end) {
			  // returns an array of objects, with hour and time spent that hour
			  let startHour = new Date(start).getHours();	
			  let endHour = new Date(end).getHours();
			  let startDate = new Date(start);
			  let results = [];
			  
			  let HRINMSECS = 1*60*60*1000;
			  
			  for (let t = start; t < end; t += HRINMSECS) {
			      if (t == start) {
				  let topofNextHour = this.getHourTime(t) + HRINMSECS; 
				  results.push({hour:startHour % 24, timeSpent: Math.min(end-start, topofNextHour - start) });
			      } else {
				  let topofThisHour = this.getHourTime(t); 
				  results.push({hour:startHour % 24, timeSpent: Math.min(HRINMSECS,end - topofThisHour) } );
			      }
			      startHour += 1;
			  }			  
			  return results;
		      },
		      make_fake_event_from_hour:function(hr){
			 return {subj:{id:"time",type:"foo"},pred:"is", obj:{ id:(""+t.hour), type:"hour" }};
		      },
		      update:function(new_event) { // 1D, since we're a fake-2Der.
			  let this_ = this;
			  let table = this.table;
			  let col = this.name;
			  let start_time = new_event.timeextension === undefined ? new_event.start : new_event.end - new_event.timeextension;
			  this.getTimeSpentPerHour(start_time, new_event.end).map(
			      function(t){
				  let row = this_.make_selector_from_event(evt, this_.make_fake_event_from_hour(t.hour) );
				  let val = table.getEntry(row,col);
				  table.setEntry(row,col,(val === undefined ? 0 : val) + t.timeSpent);				  
			      }
			  );
		      },	
		      expire:function(expired_event) {
			  let this_ = this;
			  let table = this.table;
			  let col = this.name;
			  let start_time = new_event.timeextension === undefined ? new_event.start : new_event.end - new_event.timeextension;
			  this.getTimeSpentPerHour(start_time, new_event.end).map(
			      function(t){
				  let row = this_.make_selector_from_event(evt, { id:""+t.hour, type:"hour" });
				  let val = table.getEntry(row,col);
				  val = val === undefined ? 0 : val;
				  val -= t.timeSpent;
				  table.setEntry(row,col,Math.max(0,val));
			      }
			  );
		      }		      
		  };
		  

		  JV3.ContextMaiden.Stats.TotalTimePerDomain = {
		      domain_regex:  /\/\/([^/]+)\//,
		      superclass:JV3.ContextMaiden.Stats.StreamingStatistic1D,
		      initialize:function(params) {
			  /* requires: {table: <table>, expiry: <expiry>; optional: constrain_to_type} ... */
			  //JV3.log("_________________________________________________________________________________total time domain");
			  try {
			      JV3.PROTOCROCK.superclass(this,"initialize", JV3.plumutil.clone({name:"totaltimeperdomain"},params));
			  } catch (x) {
			      JV3.log(x);
			  }
		      },		      
		      update:function(new_event) {
			  if (new_event.entity.id && new_event.type == 'www-viewed' && new_event.entity.id.indexOf('://') > 0){			      
			      //JV3.log("________JV3.ContextMaiden.Stats.TotalTimePerDomain_______________________________ ");
			      try{				  
				  let domain = new_event.entity.id.match(this.domain_regex)[1];
				  if (domain){			     
				      let table = this.table;
				      let col = this.name;
				      let val = table.getEntry(domain,col);
				      let new_time = new_event.timeextension === undefined ? (new_event.end - new_event.start) : new_event.timeextension;
				      table.setEntry(domain,col,(val === undefined || val === null ? 0 : val) + new_time);
				  }
			      } catch (x) {
				  JV3.log(x + new_event.entity.id);
			      }			      
			  }
		      },
		      expire:function(expired_event) {
			  if (expired_event.entity.id && expired_event.type == 'www-viewed' && expired_event.entity.id.indexOf('://') > 0){			      
			      try{				  
				  let domain = expired_event.entity.id.match(this.domain_regex)[1];
				  if (domain){			     
				      let table = this.table;
				      let col = this.name;
				      let val = table.getEntry(domain,col);
				      if (val === undefined || val === null){ return; }
				      let expired_time = expired_event.end - expired_event.start;
				      table.setEntry(domain,col,Math.max(0,val - expired_time));
				  }		      
			      } catch (x) {
				  JV3.log(x + expired_event.entity.id);
			      }			      
			  }
		      }
		  };

		  // 2D -----
		  // used for pairwise

		  JV3.ContextMaiden.Stats.StreamingStatistic2D = {
		      superclass:JV3.ContextMaiden.Stats.ExpiringStreamingStatistic,
		      initialize:function(params) {
			  let this_ = this;
			  // JV3.log("_________________________________________________________________________________1D");
			  /* requires: {name:stat_name, table: <table>, expiry: <expiry>; optional: constrain_to_type} ... */
			  JV3.PROTOCROCK.superclass(this,"initialize", params);
			  
			  if (params.dont_subscribe !== true) {
			      // kind of a hack, this is so that "Faker" 2Ds like TimePerHour can subscribe manually. got it?
			      events.addStoreUpdateListener(params.constrain_to_type,
							    ({
								 itemUpdated:function(event) {
								     try {									
									 let new_start = event.timeextension ? (event.end.valueOf() - event.timeextension) : event.start.valueOf();
									 events.getEventsIntersectionAsync(undefined,
													   [new_start.valueOf(), event.end.valueOf()],
													   function(evts) {
													       try {
														   this_.update(event,evts);
														   // JV3.log('saving in StreatmingStatistic2D');
														   // todo: move this out to something so we don't resave the table every time!
														   params.table.soft_save();
													       } catch (x) {  JV3.log(x);  }
													   });
									 
								     } catch (x) { JV3.log(x); }								     
								 }
							     }));
			  }

		      },
		      expiry_callback:function(new_start,new_end) {
			  // expiry calls whenever it wants us to expire everything from new_start -> new_end
			  let this_ = this;
			  //JV3.log("2D EXPIRY callback " + this.name + " " + new Date(new_start) + " " + new Date(new_end));
			  JV3.CMS.event_store.getEventsIntersectionAsync(
			      undefined,
			      [new_start,new_end],
			      function(evts) {
				  // filter for only those events that hav completely passed
				  evts.filter(function(x) { return x.end < new_end; }).
				      map(function(x_evt) {
					      //JV3.log("2D EXPIRY ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ============================");
					      //JV3.log(x_evt);
					      // find all events intersecting with this.
					      JV3.CMS.event_store.getEventsIntersectionAsync(undefined, [x_evt.start,x_evt.end],
											     function(evts_that_overlap_with_it) {
											 	 try {
												     this_.expire(x_evt,evts_that_overlap_with_it);
												 } catch (x) { JV3.log(x); }
											     });
					  });
			      }
			  );			  
		      },
		      _make_selector: function(subj0,pred0,obj0,subj1,pred1,obj1) {
			  // reorders pairs so that 
			  let compare = function(x,y) {
			      if (typeof(x) == 'string') {
				  if (x == y) return 0;
				  if (x < y) return -1;
				  return 1;
			      }
			      if (typeof(x) == 'object') {
				  let ta = arguments.callee(x.type,y.type);
				  if (ta !== 0)  { return ta; }				  
				  return arguments.callee(x.id,y.id); 
			      }
			      return undefined;
			  };
			  let result = [[subj0,subj1],[pred0,pred1],[obj0,obj1]].map(function(xpair) { return compare.apply(undefined,xpair);}).filter(function(x) x != 0);

			  // they're identical! so it doesn't matter.
			  if (result.length == 0) {  return [{subj:subj0, pred:pred0, obj:obj0}];  }
			  return result[0] > 0 ? [{subj:subj0, pred:pred0, obj:obj0},{subj:subj1, pred:pred1, obj:obj1}] : [{subj:subj1, pred:pred1, obj:obj1},{subj:subj0, pred:pred0, obj:obj0}]; 
		      },		      
		      make_selector_from_event:function(event0,event1) {
			  let subj0 = implicit_subj;
			  let subj1 = implicit_subj;			  
			  return this._make_selector(subj0, event0.type, this._selector_from_entity(event0.entity),
						     subj1, event1.type, this._selector_from_entity(event1.entity));
		      },
		      get_values_raw:function(subj0,pred0,obj0,subj1,pred1,obj1) {
			  let filter = function(pair) {
			      let k = pair[0];			      
			      return (subj0 === undefined || subj0.id == k[0].subj.id) &&
				  (obj0 === undefined || obj0.id == k[0].obj.id) &&
				  (pred0 === undefined || pred0.id == k[0].pred.id) &&
				  (subj1 === undefined || subj1.id == k[1].subj.id) &&
				  (obj1 === undefined || obj1.id == k[1].obj.id) &&
				  (pred1 === undefined || pred1.id == k[1].pred.id);				  
			  };
			  return this.table.getAllRows(this.name).filter(filter);
		      },
		      get_values:function(subj_ent0,event_type0,obj_ent0,subj_ent1,event_type1,obj_ent1) {
			  if (subj_ent0 === undefined) {  subj_ent0 = implicit_subj;  }
			  if (subj_ent1 === undefined) {  subj_ent1 = implicit_subj;  }
			  return this.get_values_raw(this._selector_from_entity(subj_ent0), event_type0, this._selector_from_entity(obj_ent0),
						     this._selector_from_entity(subj_ent1), event_type1, this._selector_from_entity(obj_ent1));
		      }
		  };

		  
		  JV3.ContextMaiden.Stats.PairwiseTotal = {
		      superclass:JV3.ContextMaiden.Stats.StreamingStatistic2D,
		      initialize:function(params) {
			  /* requires: {table: <table>, expiry: <expiry>; optional: constrain_to_type} ... */
			  JV3.PROTOCROCK.superclass(this,"initialize", JV3.plumutil.clone({name:"pairwisetotal"},params));
		      },
		      update:function(new_event,overlapping_events) {
			  let this_ = this;
			  
			  // if (overlapping_events.length > 0) {
			  //JV3.log("(!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!)");
			  //     JV3.log(overlapping_events);
			  // }
			  // if (new_event.type == 'location') {
			  //     JV3.log("GGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG :: " + new_event.timeextension + " " + new_event.start + " " + new_event.end + " " + new_event.entity.id);
			  //     JV3.log(new_event);
			  //     JV3.log("::~~~~~~~~~~~~~~~~~~~~~:: overlapping " + overlapping_events.length);			      
			  // }
			  
			  let table = this.table;
			  let col = this.name;
			  overlapping_events.map(
			      function(x_event) {
				  let new_event_start = new_event.timeextension === undefined ? new_event.start : new_event.end - new_event.timeextension;
				  let row = this_.make_selector_from_event(new_event,x_event);
				  let val = table.getEntry(row,col);
				  table.setEntry(row,col, (val === undefined || val === null ? 0 : val) + JV3.plumutil.date_intersection(new_event_start,new_event.end,x_event.start,x_event.end));
			      });
		      },
		      expire:function(old_event,coincident_events) {

			  // old_event is called in order that events occurred...
			  //JV3.log("2D-EXPIRE +++++++ " + coincident_events.length);
			  let this_ = this;
			  let table = this.table;
			  let col = this.name;
			  
			  // find intersecting events :
			  // we filter events that start _before_ us to avoid double-counting overlap
			  //  |-----| 
			  //      |------|
			  // If we already counted the first interval, we're done with it.								 
			  coincident_events.filter(function(x) { return x.start >= old_event.start; }).map(
			      function(x_event) {
				  let row = this_.make_selector_from_event(old_event,x_event);
				  let val = table.getEntry(row,col);
				  table.setEntry(row,col, Math.max(0,val - JV3.plumutil.date_intersection(old_event.start,old_event.end,x_event.start,x_event.end)));
			      });
			  
		      }
		  };

		  JV3.ContextMaiden.Stats.Expirer = {
		      initialize:function(statistic,long_time) {
			  this.long_time = long_time;
			  this.stat = statistic;
			  this.table = statistic.table;
			  this._check();
			  this._set_timer(long_time);
		      },
		      _set_timer:function(interval) {
			  let this_ = this;
			  JV3.setInterval(function() { try { this_._check(); } catch (x) { JV3.log(x); } },interval);
		      },
		      _check:function() {
			  if (this.stat.expiry_callback === undefined) { return; }
			  let le = this._get_last_expired();
			  let now = (new Date()).valueOf();
			  let ne = now - this.long_time;
			  if (now - le  > this.long_time) {
			      // JV3.log("_______________ +++++ calling expiry callback for " + this.stat.name);
			      this.stat.expiry_callback(le,ne);
			      // JV3.log("<<<< done w/ expiry callback for " + this.stat.name);
			  }
			  this._set_last_expired(ne);
			  //JV3.log('saving stat table');
			  this.stat.table.save(); // very very very infrequent, so we don't worry about this guy
			  // not true!! this happens ~10x on startup && turning it off shaves ~45s off startup time
		      },
		      _get_last_expired:function() {
			  let exp = this.stat.table.expiries !== undefined ? this.stat.table.expiries : {};
			  // JV3.log("____get_last_expired " + exp);
			  if (exp[this.stat.name] === undefined) {
			      let now = new Date().valueOf();
			      // JV3.log("statistic " + this.stat.name + " has no expiry, giving it " + now);
			      this._set_last_expired(now);  // that way we will not check until a long itme from now
			      return now;
			  }
			  return exp[this.stat.name];	  // || 1260057600000;//0; //december 6 2009 so that for prev users it will not expire all early events
		      },
		      _set_last_expired:function(le) {
			  let exp = this.stat.table.expiries !== undefined ? this.stat.table.expiries : {};
			  exp[this.stat.name] = le;
			  this.stat.table.expiries = exp;
			  return le;
		      }
		  };

		  JV3.ContextMaiden.Stats.Recommender = {
		      posteriorGivenContext:function(subj,pred,context,s1,contextstats) {
			  // s1 -> typically TotalTime,
			  // spair -> typically PairwiseTotal
			  // 
			  // thingtype is like "www-viewed"
			  // context is like this [{subj:<ME> pred:location obj:{id:"MIT/StataCenter",type:schemas.Location},...]
			  // contextstats is an array of _statistics_ .. ONE FOR EACH of the above context elements.
			  //    FOR EXAMPLE,
			  //    (www-viewed -> { subj: me, pred: location, obj:MIT })   ->  PairwiseTotal
			  //    (www-viewed -> {subj:{id:"time",type:"foo"},pred:"is", obj:{ id:(""+t.hour), type:"hour" }}; -> Pairwise...
			  
			  // returns [[{id:"http://..},0.001],...]

			  let PI = function(x,y) { return y === undefined ? x : x*y; };
			  let SUM = function(x,y) { return y === undefined ? x : x*y; };
			  let MINLIKELIHOOD = 1e-14;			  
			  
			  let total = s1.get_values(subj,pred).map(function(pair) pair[1]);

			  let posteriorLikelihoods = s1.get_values(subj,pred).map(
			      function(pair) {
				  let page = pair[0];
				  let Ppage = pair[1]/(1.0*total);
				  let pContextGivenPage = context.map(
				      function(given) {
					  // p(given|page) (because we're taking the posterior.)  <- VERY CONFUSING. BE CAREFUL, mon.
					  let spair = contextstats[context.indexOf(given)];					  
					  return Math.max(MINLIKELIHOOD,spair.get_values(given.subj,given.pred,given.obj,page.subj,page.pred,page.obj)/Ppage);
				      }).reduce(PI);
				  return [page,Ppage*pContextgivenPage];
			      });

			  let totalLikelihood = posteriorLikelihoods.map(function(pair) pair[1]).reduce(SUM);
			  return posteriorLikelhoods.map(function(pair) [pair[0],pair[1]/totalLikelihood]);			  
		      }
		  }; 

		  // incremental-context statistics
		  JV3.ContextMaiden.Stats.set_up_incremental_context_statistics = function(daystats,weekstats) {

		      let stats = [
			  JV3.ContextMaiden.Stats.TotalTime,
			  JV3.ContextMaiden.Stats.Counts, // removing unused stats
			  JV3.ContextMaiden.Stats.TimePerDOW,
			  JV3.ContextMaiden.Stats.TimePerHour,
			  JV3.ContextMaiden.Stats.TotalTimePerDomain,
			  JV3.ContextMaiden.Stats.PairwiseTotal
		      ];			  

		      if (daystats === undefined) {  daystats = stats;  }
		      if (weekstats === undefined) { weekstats = stats; }
		      
		      try {
			  // now we can initialize		  
			  let table = JV3.CMS.entity_store.get_or_create({type:"schemas.StatisticsTable",id:"_24_hr_"});
			  JV3.ContextMaiden.Stats._24_hr_table_ = table;

			  if (JV3.ContextMaiden.Stats._24_hr_table_.createdTime === undefined){    JV3.ContextMaiden.Stats._24_hr_table_.createdTime = new Date().valueOf();	  }

			  let i = 0;
			  JV3.ContextMaiden.Stats._24hr_statistics_ =
			      daystats.map(function(stat) {
					       try {
						   i = i + 1;
						   let stati = JV3.newify(stat, {table:table});
						   let exp = JV3.newify(JV3.ContextMaiden.Stats.Expirer, stati, 24*60*60*1000);
						   return stati;							     
					       } catch (x) {
						   JV3.log("Death while trying " + stat + " " + i);
						   JV3.log(x);
					       }
					   });
			  
			  //JV3.log("creating 2week table");
			  try {
    			      let two_week_table = JV3.CMS.entity_store.get_or_create({type:"schemas.StatisticsTable",id:"_2_week_"});
			      JV3.ContextMaiden.Stats._2_week_table_ = two_week_table;
			      //JV3.log(two_week_table);
			      JV3.ContextMaiden.Stats._2week_statistics_ =
				  weekstats.map(function(stat) {
					    try {
						i = i + 1;
						let stati = JV3.newify(stat, {table:two_week_table});
						let exp = JV3.newify(JV3.ContextMaiden.Stats.Expirer, stati, 14*24*60*60*1000);
						return stati;							     
					    } catch (x) {
						JV3.log("Death while trying " + stat + " " + i);
						JV3.log(x);
					    }
					});
			  } catch (x) {
			      JV3.log(x);
			  }			  
			  /*
			   JV3.ContextMaiden.Stats.recweb = function() {			  
			   let totaltime = JV3.ContextMaiden.Stats._2week_statistics_[0];
			   let pairtime = JV3.ContextMaiden.Stats._2week_statistics_[5];
			   let dowtime = JV3.ContextMaiden.Stats._2week_statistics_[2];
			   let hourtime = JV3.ContextMaiden.Stats._2week_statistics_[3];

			   let context = JV3.ContextMaiden.Stats.get_current_context();
			   JV3.Stats.Recommender(implicit_subj,"www-viewed", context, totaltime, [pairtime,hourtime]);


			   // what we need to write:
			   // get_current_context( time, webpage, location )
			   // dowtime

			   // some day:)
			   // 2-order sequence_counts (page1,page2) = 1
			   // 3-order ?? sequence_counts (page1,page2,page3) = 1
			   };
			   */
			  
		      } catch (x) { JV3.log(x);    }		  
		  };

		  // two issues with activity log stuff:
		  // 1 - this framework is designed to work online/incrementally
		  //     but actlogs aren't designed to do this
		  // 2 - schemas don't fit.
		  //

		  // 
		  // current solution: make something
		  JV3.ContextMaiden.Stats.ActivityLogStats = {
		      stats1D: [
			  JV3.ContextMaiden.Stats.Counts, // removing unused stats
			  JV3.ContextMaiden.Stats.TimePerDOW,
			  JV3.ContextMaiden.Stats.TimePerHour
		      ],
		      stats2D: [
                          JV3.ContextMaiden.Stats.PairwiseTotal
		      ],
		      initialize:function(table) {
			  this.table = table;
			  this._stats1D = this.stats1D.map(function(sc) newify(sc,{table:table, dont_subscribe:true}));
			  this._stats2D = this.stats2D.map(function(sc) newify(sc,{table:table, dont_subscribe:true}));
		      },
		      _actlog_2_event:function(al, id_override) {
			  if (al.noteid === undefined || al.noteid === null) return undefined;
			  return {
			      entity: {id: id_override !== undefined ? id_override : al.noteid, type:'activitylog-entry' },
			      start: al.id,
			      end: al.id + 1,
			      type: al.type
			  };
		      },
		      update:function(from) {
			  var this_ = this;
			  var ONE_MINUTE = 60*1000;
			  JV3.actlog.loadIdsGreaterThan(from,function(actlogs) {

							    // individuals
							    let actlog_evts = actlogs.map(this_._actlog_2_event);
							    
							    // add copies of the events but with "aggregate" versions to get totals
							    actlog_evts = actlog_evts.concat(actlogs.map(function(a) { return this_._actlog_2_event(a,"__aggregate__"); }).filter(function(x) x !== undefined));
											     
							    JV3.log("---statistics.update." + actlogs.length);
							    // phase one: 1Ds.
							    try {
								actlog_evts.map(function(evt) {   this_._stats1D.map(function(si) { try{ si.update(evt);} catch (x) { JV3.log(x); }});});
							    } catch (yy) { JV3.log(yy); }							    

							    JV3.log("---2Dupdate.");
							    // phase two: 2Ds;
							    try {
								actlog_evts.map(function(evt) {
										    if (evt === undefined) { return; }
										    JV3.log(evt);
										    let start = evt.start - ONE_MINUTE;
										    let end = evt.end + ONE_MINUTE;
										    events.getEventsIntersectionAsync("www-viewed", [start, end],
														      function(hits) {
															  try {
															      JV3.log("www-hits : " + hits.length);
															      this_._stats2D.map(function(s) { try { s.update(evt,hits); } catch (z) { JV3.log(z); } });
															  } catch (y) {   JV3.log(y);  }
														      });
										    events.getEventsIntersectionAsync("location", [start, end],
														      function(hits) {
															  try {
															      JV3.log("location hits : " + hits.length);
															      this_._stats2D.map(function(s) { try { s.update(evt,hits); } catch (z) { JV3.log(z); } });
															  } catch (y) {   JV3.log(y);  }
														      });										    
										});
							    } catch (yy) { JV3.log(yy); }							    
							});
		      }
		  };

		  JV3.ContextMaiden.Stats.create_actlog_stats = function() {
		      // JV3.xuloadCB('chrome://listit/content/context/eventstats/statistic.js');
		      let table = JV3.CMS.entity_store.get_or_create({type:"schemas.StatisticsTable",id:"_actlog__" + (new Date().valueOf())});
		      JV3._actlog_table_ = table;
		      JV3.ContextMaiden._als_ = JV3.newify(JV3.ContextMaiden.Stats.ActivityLogStats,table);
		  };

		  JV3.ContextMaiden.Stats.actlog_update = function(since) {
		      JV3.ContextMaiden._als_.update(since);		      
		  };

});
