schemas.FullContextTable = {
    /*
     In this abstraction, a _context type_ defines a random variable
     and all the values that context variable can take defines its domain
    */
    superclass:schemas.Entity,
    type: "schemas.FullContextTable",
    id:"fulltable",
    name:"probability table",
    fields: ["id","domains","table","total"],
    missing_val:"*",
    initialize:function(props,entity_store,JV3) {
	PROTOCROCK.super(this,"initialize", props);
	this.util = JV3.plumutil;
	this.log = JV3.log;
	this.entity_store = entity_store;
    },
    getInstance:function(JV3, entity_store) {
	var preexisting = entity_store.getEntityById(this.id);
	if (preexisting) {
	    return newify(schemas.FullContextTable,{id:preexisting.id,domains:preexisting.domains,table:preexisting.table,total:preexisting.total},entity_store);
	}
	return newify(schemas.FullContextTable,{id:this.id,domains:{},table:{},total:0},entity_store);
    },
    register_domains:function(value) {
	// makes sure that this value has been represented in the domain this.dom
	var this_ = this;
	var type = this.getEventType(value);
	var val = this.getEntityId(value);
	if (this.domains[type] === undefined) { this.domains[type] = [this_.missing_val,val]; return; }
	if (this.domains[type].indexOf(val) < 0) {
	    this.domains[type].push(val);
	}
	// save later!
    },
    add: function(values,n) {
	var this_ = this;
	values.map(function(val) { this_.register_domains(val); });
	var rowname = this.row_name(values);
	this.table[rowname] = this._get(values) + n;
	this.total += n;
	this.save();
    },
    getTypes:function() { return this.util.objKeys(this.domains);  },
    missing_types:function(vals) {
	var this_ = this;
	var valtypes = vals.map(function(x) { return this_.getEventType(x); });
	return this.getTypes().filter(function(x) {
	    return valtypes.indexOf(x) < 0;
	});
    },
    getDomain:function(type) { console.log("get domain : " + type); return this.domains[type]; },
    _get:function(bindings) {
	var rowname = this.row_name(bindings);
	return this.table[rowname] ? this.table[rowname] : 0;
    },
    getP: function(values) {
	var this_ = this;
	// values may be missing some
	values.map(function(val) { this_.register_domains(val); });
	var total = 0;
	(function(types,bindings) {
	    var callee = arguments.callee;
	    if (types.length == 0) {
		total += this_._get(bindings);
		return;
	    } 
	    var d = this_.getDomain(types[0]);
	    this_.getDomain(types[0]).map(function(val) {
		var next_types = types.slice(1);
		var next_bindings = bindings.concat([ {type:types[0],entity:{id:val}}]);
		callee(next_types,next_bindings);
	    });	    
	})(this.missing_types(values), values);
	return total/this.total;

    },
    row_name:function(bindings) {
	var this_ = this;
	var f1 = function(binding) {
	    var val = this_.getEntityId(binding);
	    var type = this_.getEventType(binding);
	    if ( val == this_.missing_val ) { return ""; }
	    return type+"="+val;
	};	
	var bobj = {};
	bindings.map(function(binding) {
	    bobj[this_.getEventType(binding)] = binding;
	});
	console.log(bobj);
	var toret = this.getTypes().map(function(type) {
	    if (bobj[type]) {
		return f1(bobj[type]);
	    } else {
		return ""; 
	    }
	}).filter(function(x) { return x.length > 0; }).join("____");
	return toret;
    },
    save:function() { this.entity_store.save(this);   },
    getEntityId: function(x) {
	if (typeof x == "string") { return x; }
	if (typeof x == "object" && x.entity) { return x.entity.id; }
	if (typeof x == 'object' && x.entityid) { return x.entityid; }	
	this.util.assert(false, "Cannot get id for object : " + x + " " + this.util.toJSON(x));
    },
    getEventType: function(x) {	return x.type;  }    
};


