
__defn_module("newtabstats",
	      function(JV3) {
		  // the next 4 functions are
		  // to compute cached statistics and events
		  JV3.log("------------ newtabstats +++++++++++++++++++++++++++++++  ");
		  JV3.getHourTime = function(time) {
		      var dt = new Date(time);
		      dt.setMinutes(0);
		      dt.setSeconds(0);
		      dt.setMilliseconds(0);
		      return dt.valueOf();
		  };
		  JV3.getTimeSpentPerHour = function(start, end) {
		      // returns an array of objects, with hour and time spent that hour
		      var startHour = new Date(start).getHours();	
		      var endHour = new Date(end).getHours();
		      var startDate = new Date(start);
		      var results = [];
		      
		      var HRINMSECS = 1*60*60*1000;
		      
		      for (var t = start; t < end; t += HRINMSECS) {
			  if (t == start) {
			      var topofNextHour = this.getHourTime(t) + HRINMSECS; 
			      results.push({hour:startHour % 24, timeSpent: Math.min(end-start, topofNextHour - start) });
			  } else {
			      var topofThisHour = this.getHourTime(t); 
			      results.push({hour:startHour % 24, timeSpent: Math.min(HRINMSECS,end - topofThisHour) } );
			  }
			  startHour += 1;
		      }
		      
		      return results;
		  };
		  JV3.getContext = function(){
		      //var fp = JV3.get_current_focused_page(); 
		      return;
		  },
		  JV3.computeConditionalStats = function(data){
		      try {
		      // assumes data coming in as merged entity-data format
		      var this_ = this;
		      var recommendation_evttype = 'www-viewed';
		      var contexts = ['location', 'music'];
		      var recbyhour = [{},{},{},{},{},{},{},{},{},{},{},{},{},{},{},{},{},{},{},{},{},{},{},{}];
		      var contextTotals = {};
		      var recTotal = 0;
		      var recTotals = {};

		      // {"location" : {}, "music" : {}}
		      var recbycontext = {};
		      // broken: this.plumutil.dictzip(contexts,contexts.map(function(c) { return {}; }));
		      contexts.map(function(c) {   recbycontext[c] = {}; });
		      var current_context = [ ];   // [ cevt1, cevt2 ... ]


		      // need to blur the overlap by ~1 min
		      var intersection = function(d1,d2) { return Math.max(0, - Math.max(d1.start, d2.start) + Math.min(d1.end, d2.end));   };

		      // data has to be sorted by start
		      var lastrecobj = undefined;
		      var chaintable = {};

		      data.map(function(obj){
				   if (obj.entity === undefined) { return; }

				   // pop off dead contexts.
				   current_context = current_context.filter(
				       function(cevt) {
					   return cevt.end >= obj.start;
				       });
				   
				   if (obj.eventtype == recommendation_evttype) { // e.g., web page		     
				       // add to toal
				       
				       recTotal += obj.end.valueOf() - obj.start.valueOf();
				       recTotals[obj.entity.id] = (recTotals[obj.entity.id] === undefined ? 0 : recTotals[obj.entity.id])
					   + (obj.end.valueOf() - obj.start.valueOf());
				       
				       // measure overlap with Hour of Day
				       // { { http://web.mit.edu: 238239, http://www.foo.bar.com:2183 }, { .. } }
				       this_.getTimeSpentPerHour(obj.start, obj.end).map(function(t){
											     var slot = recbyhour[t.hour];
											     if (slot[obj.entity.id]) {
												 slot[obj.entity.id] += t.timeSpent;
											     } else {
												 slot[obj.entity.id] = t.timeSpent;		
											     }
											 });

				       // now measure overlap with each of the contexts that are happenin'

				       // recsbycontext : { "location" :
				       //                      { "Location//MIT..." : { "http://web.mit.edu" : 12938023, "http://www.":238 },
				       //                      { "StataCenter" : { "http://web.mit.edu" : 292992, "http://www.":11112 },
				       
				       current_context.map(function(c) {
							       var ctypes = recbycontext[c.eventtype];
							       var cidslots = ctypes[c.entity.id] || {};					     
							       cidslots[obj.entity.id] = (cidslots[obj.entity.id] || 0) + intersection(c,obj);
							       ctypes[c.entity.id] = cidslots;					 
							   });
				       
				       if (lastrecobj){			 
					   var chainslot = chaintable[lastrecobj.entity.id] || {};
					   if (chainslot[obj.entity.id]) {
					       chainslot[obj.entity.id] += 1;
					   } else {
					       chainslot[obj.entity.id] = 1;
					   }
					   chaintable[lastrecobj.entity.id] = chainslot;
				       }
				       lastrecobj = obj;
				   } else {				       
				       contextTotals[obj.eventtype] =
					   (contextTotals[obj.eventtype] === undefined ? 0 : contextTotals[obj.eventtype]) +
					   (obj.end.valueOf() - obj.start.valueOf());					   
				       
				       // it's a contextual type ........
				       current_context.push(obj);
				   }
			       });

			  // probabilities
			  //var recP = JV3.plumutil.objMap(function(recT) { return recT / (1.0*recTotal); }), recTotals);
			  
			  /*
			  var locPriors = JV3.plumutil.unzipdict(loc).map(function(loc){
									      return loc[1]/locTotal;						  
									  });
			  
			   */
			  return [recbyhour,recbycontext,chaintable];
			  
		      } catch (x) {
			  JV3.log(x);
		      }
		  };
	      });
