
				//this_.log("note-event-source(): next " + next.end + " " + next.start + " " + next.entityid );
				//this_.log("calling event_store " + (next.end.valueOf() - next.start.valueOf())/1000.0 + " seconds");
				//this_.log("ne_start: " + next.start.valueOf() + " " + " ne_end: " + next.end.valueOf());
				//{type: "note-edited", start : next.start.valueOf(), end: next.end.valueOf(),entityid: "note-"+object, entitytype:"note" }


(function(JV3,ContextMaiden) {

    // NoteEventSource:
    // a filter that transforms low level note events (stored in the JV3
    // to events that can be stored in the events store

    var plumutil = JV3.plumutil;

    ContextMaiden.NoteEventSource = {
	initialize:function(CMS) {
	    var this_ = this;
	    this.queue = [];
	    this.log = JV3.log;	
	    // instrument actlog
	    var actLogFn = JV3.logAction;
	    var event_store = CMS.event_store;
	    // hijack!! and then update in like, real time
	    var note_edit_iter = this._transform_actlog_entries_to_note_durations();
	    JV3.logAction = function(actType, object, contents, search) {
		try {
		    this_.queue.push({id: new Date().valueOf(), type: actType, noteid: object, search: search});
		    var next = note_edit_iter.next();
		    while (next !== undefined) {
			try { event_store.save(next); } catch(e) { this_.log("Errorz in actlog saving : " + e + " " + e.lineNumber + " " + e.fileName); 	}
			next = note_edit_iter.next();
		    }
		    return actLogFn.apply(JV3,arguments);
		} catch(e2) {
		    this_.log(e2 + " " + e2.lineNumber + " " + e2.fileName);
		}
	    };
	},
	_transform_actlog_entries_to_note_durations: function(entries) {
	    // returns: map of { note_id_i : [context_struct_i...], ... }
	    var by_note = {};
	    var entry_hold = undefined;
	    // now we wish to transform these events into events pertaining to notes
	    while (true) {
		try { 
		    if (this.queue.length == 0) { yield(undefined); continue; }
		    var entry = this.queue.shift();
		    
		    //plumutil.assert(entry.noteid !== undefined, "ERROR entry.noteid MISSING  " + entry.id + " " + entry.type);
		    plumutil.assert(entry.id !== undefined, "ERROR entry.id (date) MISSING " + entry.type + " " + entry.noteid + " " );
		    //JV3.ENT = [entry_hold, entry];
		    
		    if (entry.type == 'note-save' && entry_hold && entry_hold.type == 'note-edit' && entry_hold.noteid == entry.noteid) {
			this.log("noteevent -- note-edit + note-save ------- associating note " + entry.noteid + " with time " + entry_hold.id + " - " + entry.id);
			// var evt_test = this.makeEvent(entry.noteid,ContextMaiden.TimeStruct.makeDuration(entry_hold.id, entry.id));
			yield ( this.makeEvent(entry.noteid,ContextMaiden.TimeStruct.makeDuration(entry_hold.id, entry.id)) );
			entry_hold = undefined;
			continue;
		    }
		    if (entry.type == 'note-add' && entry_hold && entry_hold.type == "notecapture-focus") {
			this.log("noteevent -- notecap-focus + note-save ------- associating note " + entry.noteid + " with time " + new Date(entry_hold.id) + " - " + new Date(entry.id));
			// this.log("actlog_dur case 2 note-add after notecapture-focus length:" + ContextMaiden.TimeStruct.makeDuration(entry_hold.id, entry.id).length());
			var toreturn = this.makeEvent(entry.noteid,ContextMaiden.TimeStruct.makeDuration(entry_hold.id, entry.id));
			entry_hold = undefined;
			yield(toreturn);
			continue;
		    }
		    if (entry.type == 'note-edit') {
			this.log("noteevent -- notecap-edit instantaneous " + entry.noteid + " with time " + new Date(entry.id));
			entry_hold = entry;
			yield(this.makeEvent(entry.noteid,ContextMaiden.TimeStruct.makeInstant(entry.id))); 
			continue;
		    }
		    if (entry.type == 'note-save' || entry.type == 'note-add') {
			this.log("note save or note add 4 instantaneous ------- associating note " + entry.noteid + " with time " + new Date(entry.id));
			// didn't match so we just do an instant
			entry_hold = undefined;
			yield(this.makeEvent(entry.noteid,ContextMaiden.TimeStruct.makeInstant(entry.id)));
			continue;
		    }
		    if (entry.type == 'notecapture-focus') {
			this.log("noteevent -- actlog_dur case 5 : notecap focus");
			entry_hold = entry;
			continue;
		    }
		    if (entry.type == 'note-add') {
			this.log("noteevent -- instant note-add ------- associating note " + entry.noteid + " with time " + new Date(entry.id));
			// this.log("actlog_dur case 6: note add no front");
			yield(this.makeEvent(entry.noteid,ContextMaiden.TimeStruct.makeInstant(entry.id)));
			continue;
		    }
		    // this.log("actlog_dur fall through");
		} catch(e) {
		    yield(undefined);
		    this.log("Error inside _transform_actlog_entries_to_note_durations : " + e + " " + e.lineNumber + " " + e.fileName);
		    continue;
		}
	    }
	},
	makeEvent: function(noteid, ts) {
	    var td = ts.asDuration();
	    //return { type:"note-edit", entityid: "note-"+noteid, entitytype:"note", start: td.start.valueOf(), end: td.end.valueOf() };
	    
	    return { type:"note-edited", entityid: ""+noteid, entitytype:"note", start: td.start.valueOf(), end: td.end.valueOf() };
	}
    };
    try {
	// add special query handler for notes, since notes are notj
	// stored in the entity database
	ContextMaiden.EntityStore.addSpecialQueryHandler(function(template) {
	    if (template === undefined || template.id === undefined || template.type === undefined || template.type !== 'note') return;
	    if (template.id !== undefined) {  // ^^ && template.id.indexOf("note-")==0) {
		// we have to extract the bloody note id from note-923729 -> 9223
		// make agree with above ^^ var tid = parseInt(""+template.id.substring("note-".length));
		var tid = parseInt(template.id);
		var result = JV3.getNoteById(tid);
		return [ JV3.getNoteById(tid) ];
	    }
	});
    } catch(e) {
	JV3.log(e);
    }
})
