__defn_module("schemas",
	      function(JV3)  {
		  var PROTOCROCK = JV3.PROTOCROCK;
		  var newify = JV3.newify;
		  var plumutil = JV3.plumutil;
		  var schemas = {};

		  schemas._serialize_stoplist = ['__super__','__class__'];
		  
		  schemas.getType = function(tname) {
		      if (tname === undefined) {   return undefined;	}
		      if (typeof(tname) == 'object') { return tname; }
		      if (typeof(tname) == 'string') {
			  var toret = this.getTypes().filter(function(x) x.id == tname);
			  if (toret.length > 0) { return toret[0]; }
		      }

		      // infinite recursion // 
		      // // modified 21.04.2010 to allow saved types ~~ for if someone extends
		      // // and defines their own types (e.g., groceries .. and mappings) they 
		      // // should be allowed to save them
		      // JV3.log("getType("+tname+")");
		      // var ents = JV3.CMS.entity_store.getEntities({id:tname,type:"type"});
		      // if (ents.length > 0) {
		      // 	  return ents[0];
		      // }
		      // return undefined;
		  };
		  schemas.getTypes = function() {
		      // walks through the schemas structure for all definitions and returns matching ones
		      return JV3.plumutil.objVals(JV3.schemas).filter(function(x) { return typeof(x) == 'object' && x.type !== undefined && x.initialize !== undefined; });
		  };
		  schemas.getPublicFields = function(entity) {
		      var this_ = this;
		      return JV3.plumutil.objKeys(entity).filter(function(x) {
								     return this_._serialize_stoplist.indexOf(x) < 0 && typeof(entity[x]) !== 'function' &&
									 (entity.__class__ === undefined || entity.__class__[x] === undefined || entity[x] !== entity.__class__[x]);
								 });
		  };		  

		  /* entities */
		  schemas.Entity = {
		      commonenglish: "thing",
		      id: "schemas.Entity",
		      type:"type",
		      /* fields : [], override me */
		      initialize:function(params) {
			  // switcheroo  from {id:"schemas.Person",type:"type"} -> {id:blah,type:"schemas.Person""}
			  var type = this.id;
			  this._copyfieldsto(params,this);
			  this.type = type;
		      },
		      _copyfieldsto: function(src,dst,omit_fields) {
			  if (dst === undefined) { dst = {} ; }
			  // changed for event store 2
			  // this.fields.map( function(field) { if (omit_fields === undefined || omit_fields.indexOf(field) < 0) { dst[field] = src[field]; }} );
			  JV3.plumutil.objKeys(src).map( function(field) { if (omit_fields === undefined || omit_fields.indexOf(field) < 0) { dst[field] = src[field]; }} );
			  return dst;
		      },
		      toString: function()  {
			  //if (this.name) { return this.name; } // could be the source of problems
			  return "schemas.Entity [" + this.id + "] // " + this.type; 
			  // "Event \""+this.title+"\" [" + (this.dates.map(function(pair) { return pair[0].toString()+"-"+pair[1].toString(); }).join(",")) + "]";
		      },
		      equals:function(f) {
			  return this.type == f.type && this.id == f.id;
		      }
		  };
		  
		  schemas.String = {
		      id:"schemas.String",
		      type:"type",
		      superclass: schemas.Entity,
		      initialize:function(params) {
			  // switcheroo  from {id:"schemas.Person",type:"type"} -> {id:blah,type:"schemas.Person""}
			  var type = this.id;
			  this._copyfieldsto(params,this);
			  this.type = type;
		      },
		      valueOf:function() { return this.val;  },
		      toString:function() { return "\"" +this.val + "\""; },
		      validate:function(f) {
		  	  this.name = "\""+f+"\"";
			  this.val = f;			  
			  JV3.Atomate._db.saveEntity(this);									 
			  return this;
 		      }		      
		  };

		  schemas.Number = {
		      id:"schemas.Number",
		      type:"type",
		      superclass: schemas.Entity,
		      initialize:function(params) {
			  // switcheroo  from {id:"schemas.Person",type:"type"} -> {id:blah,type:"schemas.Person""}
			  var type = this.id;
			  this._copyfieldsto(params,this);
			  this.type = type;
		      },
		      valueOf:function() {  return this.val; },
		      toString:function() {  if (this.val !== undefined) {return this.val + " (number)";} else { return "(number)";} },
		      validate:function(f) {
		  	  if (!isNaN(parseInt(f))) {
		  	      this.name = "(number) "+f;
		  	      this.val = f;			      
		  	      JV3.Atomate._db._update_entity(this);									 
		  	      return this;			      
		  	  }
		  	  this.name = "number";
		  	  delete this.val;
			  JV3.Atomate._db._update_entity(this);			  
		  	  return false;
		      }		      
		  };		  

		  schemas.Webpage = {
		      commonenglish: "web page",
		      id:"schemas.Webpage",
		      type:"type",
		      superclass:schemas.Entity,
		      aliases:['name','title'],
		      toString:function() { 
			  if (this.title && this.title !== undefined ) {
			      return this.title;} 
			  else if (this.name !== undefined ) {
			      return this.name;} 
			  else if (this.url !== undefined ) {
			      return this.url; }
			  return this.id;
		      },
		      initialize:function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
		      }
		  };

		  schemas.GenericEntity = {
		      commonenglish: "thing",
		      id:"schemas.GenericEntity",
		      type:"type",
		      superclass:schemas.Entity,    
		      initialize:function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
		      }
		  };

		  schemas.MusicTrack = {
		      commonenglish: "song",
		      id:"schemas.MusicTrack",
		      type:"type",
		      superclass:schemas.Entity,
		      aliases:['name'],
		      toString: function() {
			  if (this.song  !== undefined){ return this.song + " by " + this.artist; }
			  else { return this.id; }
		      },
		      initialize:function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
		      }
		  };

		  schemas.Event = {
		      commonenglish: "event",
		      id:"schemas.Event",
		      type:"type",
		      superclass:schemas.Entity,
		      aliases:['name','title'],
		      toString: function() { return this.name; },
		      initialize:function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
		      },    
		      fromGCal:function(entry, calendar, start, end) {
			  return {
			      type:"schemas.Event",
			      id: entry.id.$t,			  
			      name: entry.getTitle().getText(),
			      link: entry.getHtmlLink() ? entry.getHtmlLink().getHref() : undefined,
			      calendar: calendar,
			      "start time": start, 
			      "end time": end,
			      authors: entry.getAuthors().map(function(x){ if(x.email) {return " " + x.email.getValue()} }),
			      participants: entry.getParticipants().map(function(x){ return " " + x.email }),
			      locations: entry.getLocations().map(schemas.Location.fromGWhere),
			      location: entry.getLocations().map(schemas.Location.fromGWhere).length > 0 ? entry.getLocations().map(schemas.Location.fromGWhere)[0] : undefined,			     
			      geoLocation: entry.getGeoLocation()
			  };
		      },
		      compareTo:function(e2) {
			  // define some norm here for events.
			  if (this.id == e2.id) { return 1.0; }
			  // FINISH THIS.
		      }
		  };

		  schemas.Trip = {
		      commonenglish: "Dopplr trip",
		      id:"schemas.Trip",
		      type:"type",
		      superclass:schemas.Entity,
		      aliases:['name','title'],
		      toString: function() { return "trip to: " + this.name; },
		      initialize:function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
		      }    
		  };

		  schemas.Vislet = {
		      commonenglish: "mini-visualization",
		      id:"schemas.Vislet",
		      type:"type",
		      superclass:schemas.Entity,
		      aliases:['name','title'],
		      toString: function() { return this.name; },
		      initialize:function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
		      }    
		  };

 
		  schemas.Purchase = {
		      commonenglish: "purchase",
		      id:"schemas.Purchase",
		      type:"type",
		      superclass:schemas.Entity,
		      aliases:['name','amount'],
		      toString: function() { return this.name + " for " + this.amount; },
		      initialize:function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
		      }    
		  };
		  
		  
		  schemas.EventType = {
		      commonenglish: "concert",
		      id:"schemas.EventType",
		      type:"type",
		      superclass:schemas.Entity,
		      toString: function() { if (this.name){ return this.name; } else { return this.id; } },			  
		      initialize:function(params) {
		  	  PROTOCROCK.superclass(this,"initialize",params);
		      }
		  };
		  

		  schemas.NewsArticle = {
		      commonenglish:"news article",
		      id:"schemas.NewsArticle",
		      type:"type",
		      superclass:schemas.Entity
		  };


		  /** 
		   NC represents a note's associations with other notes. 
		   NC id = "note-"+note.id
		   NC associations = { <entity.id> :  assoc_strength }, <entity.id> : assoc_strength,  ... }
		   NC total = sum { { ... } }
		   */   
		  schemas.NoteContext = {
		      superclass:schemas.Entity,
		      id: "schemas.NoteContext",
		      type:"type",
		      // fields: ["id","associations","lastupdatetimes"],
		      toString:function() { return this.getNoteId; },
		      initialize:function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
		      },
		      // factory/static
		      makeForNote:function(nid) {
			  return newify(schemas.NoteContext, { id: ("note-"+nid), associations: {}, lastupdatetimes: {}, total: 0 });
		      },
		      getForNoteID:function(nid,entity_store) {
			  var target_id = "note-"+nid;
			  var prev_assoc = entity_store.getEntityById(target_id);
			  if (prev_assoc === undefined)  {
			      return this.makeForNote(nid);
			  }
			  return prev_assoc;
		      },
		      getNoteId: function() { return this.id.substring("note-".length);   },
		      getAssociation:function(entity) {
			  return this.associations[entity.id] ? this.associations[entity.id] : 0;
		      },
		      /*    addAssociation:function(entity,amt,updatedTime) {
		       this.associations[entity.id] = this.getAssociation(entity) + amt;
		       this.total = this.total + amt;
		       if (updatedTime) { this.updatedTime = Math.max (this.updatedTime.valueOf(), updatedTime.valueOf()); }
		       },
		       */
		      updateAssociation:function(entity,interval) {
			  // only happens if we in the middle of upgrading an existing model 
			  if (this.lastupdatetimes === undefined) { this.lastupdatetimes = {} };
			  // ------------------------------------------------------------
			  var lastupdate = this.lastupdatetimes[entity.id] ? this.lastupdatetimes[entity.id] : 0;
			  var prev_strength = this.getAssociation(entity);
			  var start = Math.max(interval.start.valueOf(),lastupdate);
			  var end = Math.max(start,interval.end.valueOf());	// that way we will never add a negative number

			  this.associations[entity.id] = prev_strength + (end-start);
			  this.lastupdatetimes[entity.id] = end;
		      }
		  };

		  schemas.Location = {
		      commonenglish: "place",
		      id: "schemas.Location",
		      type:"type",
		      superclass:schemas.Entity,
		      aliases:['name','description','address'],
		      toString: function(){ return this.name; },
		      initialize: function(props) {
			  PROTOCROCK.superclass(this,"initialize",props);
		      },
		      // @static
		      fromGWhere: function(gwhere) {
			  return newify(schemas.Location,
					{ id: gwhere.label,
					  name : gwhere.label,
					  description : gwhere.valueString,
					  significance: gwhere.meaning  });
		      },
		      getLabel:function() {
			  var labels = [this.name,this.id,this.description,this.address].filter(function(X) { return X !== undefined; });
			  if (labels.length > 0) { return labels[0]; }
		      }
		  };

		  schemas.Photo = {
		      commonenglish: "photo",
		      id:"schemas.Photo",
		      type:"type",
		      superclass:schemas.Entity,
		      aliases:['name'],
		      toString: function(){ return this.name; },
		      initialize:function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
		      }
		  };

		  
		  schemas.Message = { 
		      commonenglish: "message",
		      superclass:schemas.Entity,
		      id:"schemas.Message",
		      type:"type",		      
		      initialize: function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
		      },
		      toString:function() {
			  try {
			      return (this.kind ? this.kind : "") + " " +
				  (this.direction ? this.direction : "") + " " +
				  (this.person ? this.person.toString() : "");			      			      
			  } catch (x) {
			      JV3.log(x);
			  }
		      }
		  };


		  schemas.Email = {
		      commonenglish: "e-mail",
		      superclass:schemas.Entity,
		      id:"schemas.Email",
		      type:"type",		      
		      initialize: function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
		      },
		      toString:function() {
			  try {
			      // need to make sure the subject is a string -- sometimes such as for apartment hunting / craglists subj is a number
			      return (this.subject ? String(this.subject).substring(0,33) + " ": "") + 
				  (this.sender ? this.sender.toString() + " " : " ") + 
				  (this.summary ? String(this.summary).substring(0,33) : "");
			  } catch (x) {
			      JV3.log(x);
			  }
			  return "some email";
		      }
		  };
		  
		  schemas.Tweet = {
		      commonenglish: "tweet",
		      superclass:schemas.Entity,
		      id:"schemas.Tweet",
		      type:"type",		      
		      getAuthor:function() { return this.sender;  },
		      toString: function() { if (this.text !== undefined){ return this.text; } return ""; },
		      initialize: function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
		      }
		  };


		  schemas.StatusUpdate = { // used for Facebook wall posts
		      commonenglish: "status update",
		      superclass:schemas.Entity,
		      id:"schemas.StatusUpdate",
		      type:"type",		      
		      getAuthor:function() { return this.sender;  },
		      toString: function() { if (this.text !== undefined){ return this.text; } return ""; },
		      initialize: function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
		      }

		  };


		  schemas.Person = {
		      commonenglish: "person",
		      id: "schemas.Person",
		      type:"type",
		      superclass:schemas.Entity,    		      
		      aliases:["firstname", "lastname", "emails", "twitter_id", "twitter_username"],		      
		      initialize: function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
		      },
		      fromGWho:function(gwho) {
			  return newify(schemas.Person, {
					    id: gwho.getEmail(),
					    email: gwho.getEmail(),
					    name: gwho.getName()
					});
		      },
		      getLabel:function() {
			  var names = [];
			  if (this.firstname !== undefined) {	names.push(this.firstname); }
			  if (this.lastname !== undefined) {	names.push(this.lastname); }
			  if (names.length == 0 && this.emails !== undefined && this.emails.length > 0) { names.push("<"+this.emails[0]+">"); };
			  if (names.length == 0 && this.twitterid !== undefined) { names.push("@"+this.twitterid); };
			  if (names.length == 0 && this.url !== undefined) { names.push(this.url); };
			  return names.join(" ");
		      },
		      toString:function() {
			  var label = "";
			  //if (this.id == JV3.USER_THIS_ID) { label = "Me ";  }  // this causes problems
			  if (this.special_pronoun) { return this.special_pronoun;  }
			  if (this["first name"] !== undefined && this["last name"] !== undefined) { return label + this["first name"] + " " + this["last name"];	}
			  if (this["first name"] !== undefined) {  return label + this["first name"];	}
			  if (this["name"] !== undefined) {  return label + this["name"];	}
			  if (this["email"] !== undefined) { return label + this["email"]; }
			  return label + this.id;
		      }
		  };

		  schemas.AbstractBaseDateType = {
		      id:"schemas.AbstractBaseDateType",
		      type:"type",
		      superclass:schemas.Entity,
		      initialize: function(params) {  PROTOCROCK.superclass(this,"initialize",params);      },
		      setDate:function(d) { this.val = d.valueOf(); },
		      setFields:function(fields) {
			  // for use by teacal ~ sets our fields to those specified in the passed in obj
			  var setter = {
			      dow: function(d,dow) { 				  
				  if (d.getDay() >= dow) {
				      d.setDate( d.getDate() + dow-d.getDay() );
				  } else {
				      d.setDate( d.getDate() + 7 - d.getDay() + dow );
				  }
			      }, 
			      min: function(d,l) { JV3.log("setting minutes " + l); d.setMinutes(l); }, 
			      hour: function(d,l) { d.setHours(l); },
			      day: function(d,l) { d.setDate(l); },
			      month: function(d,l) { d.setMonth(l); },
			      year: function(d,l) { d.setYear(l); }
			  };
			  var d = this.getDate();
			  if (d === undefined) { d = new Date(); }
			  JV3.plumutil.objKeys(fields).map(function(ff) {  if (setter[ff] !== undefined) { setter[ff](d,fields[ff]); } });
			  this.setDate(d);
			  return d;
		      },
		      compareTo:function(d) {
			  try { return this.getDate().valueOf() - d.getDate().valueOf(); } catch(E) { JV3.log("COULD NOT COMPARE TO ", d); JV3.log(E); } 
			  return undefined;
		      },		      
		      valueOf:function() {
			  try { return this.getDate().valueOf(); } catch (x) { JV3.log(x); }
			  return undefined;
		      },
		      getDate:function() {
			  if (this.reloffset !== undefined) {
			      var nd = new Date();
			      return new Date(nd.valueOf() + this.reloffset);
			  }
			  if (this.val !== undefined && JV3.plumutil.isDateLike(this.val)) { return new Date(this.val.valueOf()); }
			  if (this.val !== undefined && typeof(this.val) == 'number') { return new Date(this.val);  }
			  if (typeof(this.val) == 'object') {
			      // barabara time -> together time
			      var nd = new Date();
			      nd.setMonth(this.val.month);
			      nd.setYear(this.val.year);
			      nd.setDate(this.val.day);
			      nd.setHours(this.val.hour);
			      nd.setMinutes(this.val.min);
			      nd.setSeconds(0);
			      return nd;
			  }
			  return undefined;			  
		      },
		      toString:function() {
			  var d = this.getDate();
			  if (d) { return d.toString(); }
			  return "a date/time";
		      },
		      widget:function(window,jQuery,callback) {
		      	  // this widget needs to be constructed in the UI space, 
		      	  try {
		  	      var this_ = this;
		      	      var component =  jQuery("<div/>");
		      	      var teahelper = JV3.newify(window.teacal, component, this.teacaltype, function(val) {
		  					     try {
								 JV3.log("value from tecal >> " , val);
								 // this_.val = val;
								 this_.setFields(val);
		  						 this_.name = ""+this_.toString();
		  						 this_.widget_override = true;
		  						 JV3.Atomate._db.saveEntity(this_);								 
		  						 callback(this_);
		  					     } catch (x) {   JV3.log(x);	}
		  					 });
		      	      return component;				      
		      	  } catch (x) {
		      	      JV3.log(x);
		      	  }
			  return undefined;
		      }		      
		  };

		  schemas.SpecificDateTime = {
		      id:"schemas.SpecificDateTime",
		      type:"type",
		      name:"date time",
		      commonenglish:"a date/time",
		      superclass:schemas.AbstractBaseDateType,
		      editable:false, // ui checks this flag before editing
		      toString: function(){
			  if (this.reloffset == 0){ return 'now'; }
			  //JV3.log("--tostring ", this.id, ":", this.val);
			  if (this.val !== undefined) { return new Date(this.val).toString(); }
			  return "some date/time";
		      },
		      initialize: function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
			  // JV3.log(params);
			  if (params.val !== undefined) { this.setDate(params.val); }
		      },
		      validate:function(s) {
		      	  // an INSTANCE method.
		  	  if (s.trim().length == 0 && this.widget_override) { return this; }
		  	  if (s.trim().length > 0 && this.widget_override) { delete this.widget_override; }					     
		      	  var this_ = this;
		      	  if (!isNaN(new Date(s))) {
			      JV3.log("validate " + s);
		      	      this.name = "" + (new Date(s)).toString(); 
		      	      this.val = (new Date(s));
			      JV3.Atomate._db.saveEntity(this_);			  
		      	      return this;
    		      	  }
		      	  delete this.name;
		      	  delete this.val;
			  JV3.Atomate._db.saveEntity(this_);			  
    		      	  return false;
    		      },
		      teacaltype:"calendartime"
		  };

		  schemas.SpecificDate = {
		      id:"schemas.SpecificDate",
		      superclass:schemas.AbstractBaseDateType,
		      type:"type",
		      name: "a date",
		      commonenglish:"a date",
		      initialize: function(params) {  PROTOCROCK.superclass(this,"initialize",params);      },
		      _clear:function(nd) {
			  nd.setHours(0);
			  nd.setMinutes(0);
			  nd.setSeconds(0);
			  nd.setMilliseconds(0);
			  return nd;
		      },
		      getDate:function() {
			  if (this.reloffset == 0) { return 'today'; }
			  if (this.reloffset == 1) {  return 'tomorrow'; }

			  if (this.reloffset !== undefined) {
			      var nd = this._clear(new Date());
			      nd.setDate(nd.getDate() + this.reloffset);
			      return nd;
			  }
			  if (this.val && JV3.plumutil.isDateLike(this.val)) {
			      return new Date(this.val.valueOf());
			  }
			  if (this.val && typeof(this.val) == 'number') {
			      return this._clear(new Date(this.val));
			  }
			  if (this.val && typeof(this.val) == 'object') {
			      // barabara time -> together time
			      var nd = this._clear(new Date());
			      nd.setMonth(this.val.month);
			      nd.setYear(this.val.year);
			      nd.setDate(this.val.day);
			      return nd;
			  }			  
			  return undefined;
		      },
		      compareTo:function(d2) {
			  var this_ = this;
			  var c = function(d) {
			      return this_._clear(new Date(d.valueOf()));
			  };			  
			  return c(this.getDate()).valueOf() - c(d2.getDate()).valueOf();
		      },		      
		      valueOf:function() {
			  try {  return this.getDate().valueOf(); } catch (x) {   JV3.log(x); }
		      },
		      toString:function() {
			  try {			  
			      if (this.reloffset == 0){ return 'today'; }
			      //JV3.log("the current to string >>>>>>>>>>>>>>>>>>>>>>> ");		      
			      if (this.special_pronoun !== undefined) { return this.special_pronoun; }
			      if (this.getDate() !== undefined) {
				  return this.getDate().toDateString();   
			      }			      
			  } catch (x) {
			      // JV3.log(x);
			  }
			      
			  return "some day";
		      },
		      validate:function(s) {
		      	  // an INSTANCE method.
		  	  var this_ = this;
		  	  if (s.trim().length == 0 && this.widget_override) { return  this; }
		  	  if (s.trim().length > 0 && this.widget_override) { delete this.widget_override; }
		      	  if (!isNaN(new Date(s))) {
		      	      this.name = "" + (new Date(s)).toString(); 
		      	      this.val = (new Date(s));
			      JV3.Atomate._db.saveEntity(this_);
		      	      return this;
    		      	  }
		      	  delete this.name; // we can uncover the 
		      	  delete this.val;
			  JV3.Atomate._db.saveEntity(this_);
    		      	  return false;
    		      },
		      teacaltype:'calendar'
		  };		  
		  
		  schemas.SpecificTime = {
		      id:"schemas.SpecificTime",
		      type:"type",
		      //name:"a time",
		      commonenglish:"a time",
		      superclass:schemas.AbstractBaseDateType,
		      editable:false,
		      initialize: function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
		      },
		      toString:function() {
			  try {
			      if (this.reloffset == 0){ return 'the current time of day'; }  
			      var val = this.getDate();
			      return val ? "time: " + (val.getHours() > 12 ? val.getHours()-12 : val.getHours()) + ":" +  (val.getMinutes() < 10 ? "0" + val.getMinutes() : val.getMinutes()) + "" + (val.getHours() > 12 ? 'pm' : 'am') : " some time";			      
			  } catch (x) {  }
			  return "some time";
		      },
		      compareTo:function(d2) {
			  var c = function(d) {
			      var D = new Date(d);
			      D.setDate(0);
			      D.setMonth(0);
			      D.setYear(0);
			      return D;
			  };
			  return c(this.getDate()).valueOf() - c(d2.getDate()).valueOf();
		      },
		      validate:function(s) {
		      	  // an INSTANCE method
		  	  if ((s === undefined || s.trim().length == 0) && this.widget_override) { return  this; }
		  	  if (s.trim().length > 0 && this.widget_override) { delete this.widget_override; }
		      	  var this_ = this;
		      	  if (!isNaN(new Date(s))) {
		      	      this.name = "" + (new Date(s)).toString(); 
		      	      this.val = (new Date(s));
		  	      JV3.Atomate._db.saveEntity(this);									 			      
		      	      return this;
    		      	  }
		      	  delete this.name; // we can uncover the 
		      	  delete this.val;
			  JV3.Atomate._db.saveEntity(this_);			  
    		      	  return false;
    		      },
		      teacaltype:'time'
		  };		  
		  
		  schemas.SpecificDOW = {
		      id:"schemas.SpecificDOW",
		      type:"type",
		      superclass:schemas.AbstractBaseDateType,		      
		      commonenglish:"a day of the week",
		      weekdays: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
		      editable:false,
		      initialize: function(params) {  PROTOCROCK.superclass(this,"initialize",params);    },
		      setDate:function(dO) {
			  var d = new Date(dO.valueOf());
			  // since we're only concerned with times we're going to clear out the date and year
			  d.setHours(0);
			  d.setMinutes(0);
			  d.setMilliseconds(0);
			  PROTOCROCK.superclass(this,"setDate",d);
		      },		      
		      compareTo:function(d) {
			  try { return this.getDate().getDay() - d.getDate().getDay(); } catch(E) { JV3.log("COULD NOT COMPARE TO ", d); JV3.log(E); } 
			  return undefined;
		      },
		      toString:function() {
			  try {			      
			      if (this.reloffset == 0){ return this.name; }  
			      if (this.getDate() === undefined) { return "some day of the week"; }
			      return this.weekdays[this.getDate().getDay()];
			  } catch (x) {  }
			  return "some day of the week";			  
		      },
		      validate:function(s) {
		      	  // an INSTANCE method.
		      	  var this_ = this;
			  if (s.trim().length == 0 && this.widget_override) { return this; }
			  if (s.trim().length > 0 && this.widget_override) { delete this.widget_override; }					     					     
		      	  if (this.weekdays.map(function(x) x.toLowerCase()).indexOf(s.trim().toLowerCase()) >= 0) {
			      this.name = s;
			      this.setFields({dow:this_.weekdays.map(function(x) x.toLowerCase()).indexOf(s.trim().toLowerCase())});
    		      	  }
		      	  delete this.name; // we can uncover the 
		      	  delete this.val;
			  JV3.Atomate._db.saveEntity(this_);
    		      	  return false;
    		      },
		      teacaltype:'dow'
		  };

		  schemas.SpecificDateTimeRange = {
		      id:"schemas.SpecificDateTimeRange",
		      type:"type",
		      superclass:schemas.Entity,
		      initialize: function(params) {
			  PROTOCROCK.superclass(this,"initialize",params);
			  if (params.id === undefined && params.start !== undefined && params.end !== undefined) {
			      this.id = "specificdatetimerange-"+params.start+"-"+params.end;
			  } else if (params.id == undefined) {
			      this.id = "specificdatetimerange-"+JV3.plumutil.guid();
			  }
		      },
		      toString:function() {
			  try {  return "DateTimeRange : " + new Date(this.start).toString() + "-" + new Date(this.end).toString(); } catch (x) {  }
			  return "Some time range";
		      },
		      intersects:function(X) {
			  // X should be a SpecificDateTime
			  if (this.start === undefined || this.end === undefined) { return false; }
			  try {
			      return this.start.valueOf() <= X.getDate().valueOf() && this.end.valueOf() > X.getDate().valueOf();
			  } catch (x) { JV3.log(x); }
			  return false;
		      }
		  };	     

		  /* non entities */
		  schemas.DateTime = {
		      id:"schemas.DateTime",
		      type:"type",
		      // fields:["id", "anchor"],
		      DAYSOFWEEK : ['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday'],
		      GRANULARITIES : [ 'DATETIME', // e.g., "3:00pm 28 Feb 2009",
					'DATE', // "28 Feb 2009",
					'TIME', // "3:00pm",
					'DAYOFWEEK', // "Thurs",
					'DAYOFWEEK_TIME' // "3:00pm Thurs"
				      ],
		      REPEATS : ["NONE", "EVERY_MIN", "EVERY_HOUR", "EVERY_DAY", "EVERY_WEEK"],
		      toString: function(){
			  if (this.val.dow){
			      return this.DAYSOFWEEK[this.val.dow]; };
			  if (this.val && this.val.hour && this.val.day && this.val.year && this.val.month) { 
			      return new Date(this.val.hour + ":" +this.val.min + " " +this.val.day + " " + this.val.month + " " + this.val.year); };
			  if (this.val && this.val.day && this.val.year && this.val.month) { 
			      return new Date(this.val.day + " " + this.val.month + " " + this.val.year); };
		      },
		      initialize:function(anchor, granularity, repeat) {
			  // "anchor" - a js Date object representing the time we are tlaking about
			  // "granularity" - a string from GRANULARITIES above declaring what is represented in this time
			  // 
			  this.anchor = anchor;
			  this.granularity = granularity ? plumutil.trim(granularity.toUpperCase()) : 'DATETIME';
			  plumutil.assert( this.GRANULARITIES.indexOf(this.granularity) >= 0, "Illegal granularity specifier, must be one of " + plumutil.toJSON(this.GRANULARITIES));
			  this.repeat = repeat ? plumutil.trim(granularity.toUpperCase()) : 'NONE';
			  plumutil.assert( this.REPEATS.indexOf(this.repeat) >= 0, "Illegal repeat specifier, must be one of " + plumutil.toJSON(this.REPEATS));	    
		      },
		      // @static
		      fromGDateTime: function(gdt) { 	    
			  return newify(schemas.DateTime, gdt.getDate(), gdt.isDateOnly() ? "DATE" : "DATETIME");
		      },
		      _fromJSON: function(s) {
			  var obj = plumutil.fromJSON(s);
			  this.anchor = parseInt(obj.jsDTval);
			  this.granularity = obj.granularity;
			  this.repeat = obj.repeat;
			  
			  //	    plumutil.assert(obj.type == this.type, "Object was corrupt or not of appropriate type");
			  //	    return newify(schemas.DateTime, new Date(parseInt(obj.jsDTval)), obj.granularity, obj.repeat);
		      },
		      _toJSON:function() {
			  
			  //return plumutil.toJSON( { jsDTval : this.anchor.valueOf(), granularity: this.granularity, repeat: this.repeat } );
		      },
/*		      toString:function(military) {

			  var s = "";
			  var pn = this._padNumber;
			  if (this.granularity.indexOf("DAYOFWEEK") >= 0) {
			      // add "mon/tues/thurs" ??
			      s += this.DAYSOFWEEK[new Date(this.anchor).getDay()] + " ";
			  }
			  if (this.granularity.indexOf("TIME") >= 0) {
			      var hrs = new Date(this.anchor).getHours();
			      var mins = new Date(this.anchor).getMinutes();
			      if (military) {
				  // 00:00->23:59
				  s += pn(hrs) + ":" + pn(mins);
			      } else {
				  s += hrs < 13 ? (hrs + ":" + pn(mins) + "am") : ( (hrs-12) + ":" + pn(mins) + "pm" );
			      }
			      // s += this.anchor.toLocaleTimeString();
			      s += " ";
			  }
			  if (this.granularity.indexOf("DATE") >= 0) {
			      s += new Date(this.anchor).toLocaleDateString();
			  }
			  return s;
		      },*/
		      _padNumber: function(num) {
			  if (num <= 9) { return "0" + num; }
			  return num;
		      },
		      hasDate:function() { return this.GRANULARITIES[this.granularity].indexOf('DATE') >= 0; },
		      hasTime:function() { return this.GRANULARITIES[this.granularity].indexOf('TIME') >= 0; },
		      isToday : function() {
			  plumutil.assert(this.hasDate(), "DateTime doesn't have a date component.");
			  return this.midnight().getDate().valueOf() == newify(new Date(), "DATETIME").midnight().getDate().valueOf();
		      },
		      getDate: function() { return new Date(this.anchor); },
/*		      valueOf: function() {
			  try{
			      return this.anchor.valueOf();		
			  } catch (x) {
			      JV3.log(x);
			  }
			  return 0;
		      },
 */
		      getEffectiveBegin: function() {
			  try {
			      if (this.hasDate() && this.hasTime()) { return [this.anchor]; }
			      if (this.hasDate()) {
				  return [ this.midnight().getDate(),  this.plusDays(1).midnight().getDate() ];
			      }
			      // only hastime,
			      return [this.anchor];
			  } catch (x) {
			      JV3.log(x);
			  }	    
		      },
		      midnight : function() {
			  // returns a jsDate anchored at the top of midnight
			  plumutil.assert(this.hasDate(), "DateTime doesn't have a date component.");
			  return newify(schemas.DateTime, this._topOfHour(0), "DATETIME");
		      },	
		      noon : function() {
			  // returns a jsDate anchored at high noon
			  return newify(schemas.DateTime, this._topOfHour(12), "DATETIME");
		      },
		      plusDays : function(d) {
			  // returns a jsDate with anchor offset by d days
			  var daymsec = d*24*60*60*1000;
			  return newify(schemas.DateTime, new Date(this.valueOf() + daymsec));
		      },
		      isBefore : function(dtime) {
			  if (dtime.type == 'schemas.DateTime') {  dtime = dtime.getEffectiveBegin()[0];	}	    
			  return this.getEffectiveBegin()[0] <= dtime.valueOf();
		      },
		      _topOfHour : function(h) {
			  var v = new Date(this.anchor.valueOf());
			  v.setHours(h);
			  v.setMinutes(0);
			  v.setSeconds(0);
			  v.setMilliseconds(0);
			  return v;
		      },
		      compareTo: function(t) {
			  if (minwindow === undefined) { minwindow = 5; }
			  return Math.max( 0,1.0 - ((t.valueOf() - this.anchor.valueOf())/(1000*60*minwindow)));
		      }
		  };
		  
		  /** 
		   * from JV3.ContextMaiden.Stats */
		  schemas.StatisticsTable = {
		      superclass:schemas.Entity,	
		      id: "schemas.StatisticsTable",
		      type:"type",

		      // contains data:
		      //  data -> { "col_1" : { j"<s1>" : <r1>, j"{s2}" : <r2>, ... }, "col_2" : .. .]
		      //  j"{sN}" is a json-encoded object serving as a key to the dict
		      //  <r1> might be an object, list etc
		      initialize:function(params) {
			  JV3.PROTOCROCK.superclass(this,"initialize", params);
			  if (this.data === undefined || this.data.length == 0) {  this.data = {}; }  
			  this._data = this.data;
			  this.data = JV3.plumutil.toJSON(this.data);
		      },		      
		      getAllRows:function(col) {
			  // for a particular column, returns a list [ [rowid,val] ... [] ]
			  let dT = this._data[col];
			  if (dT === undefined) { return []; }
			  let results = [];
			  JV3.plumutil.objKeys(dT).map(
			      function(kJ) {
				  let k = JV3.plumutil.fromJSON(kJ);
				  results.push([k,dT[kJ]]);
			      });
			  return results;			  
		      },
		      setEntry:function(row,col,val) {
			  JV3.plumutil.assert(typeof(val) != "number" || !isNaN(val), "TRIED TO SET A NAN ");
			  if (this._data[col] === undefined) {  this._data[col] = {};  }
			  this._data[col][JV3.plumutil.toJSON(row)] = val; // no comment.
		      },
		      getEntry:function(row,col) {
			  if (this._data[col] === undefined) {  return undefined;  }
			  return this._data[col][JV3.plumutil.toJSON(row)]; // no comment.
		      },
		      save:function() {
			  //JV3.log("Saving context table fo' real at " + (new Date()).valueOf());
			  this.data = JV3.plumutil.toJSON(this._data);
			  this.lastsaved = new Date().valueOf();
			  JV3.CMS.entity_store.saveAsync(this, function(){});
		      },
		      soft_save:function() { // like soft-serve ice cream!
			  // saves after every N minutes or saves or we've attempted to write N times
			  var Ntime = 30*60*1000;
			  var Nwrites = 50;
			  
			  if (this.lastsaved === undefined || (this._nwrites && this._nwrites > Nwrites && ((new Date()).valueOf() - this.lastsaved > Ntime))) {
			      this.save();
			      this._nwrites = 0; // FYI: things that start with _ are not saved by our db.
			      return;
			  } 
			  this._nwrites = this._nwrites === undefined ? 0 : this._nwrites + 1;
		      }
		  };

		  
		  JV3.schemas = schemas;
	      });
