// Copyright (c) 2008,2009 Massachusetts Institute of Technology
// Copyright (c) 2008,2009 Nokia

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:

// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

// this is ##DEPRECATED

// requires: plum-util.js for correct array functionality

const WATCHME_DB_FILENAME = 'watchme-please.csail.mit.edu.sqlite';
const WATCHME_DB_LOG_TABLE = 'log2';
const WATCHME_DB_CONFIG_TABLE = 'config';

(function(JV3,ContextMaiden) {
    // exported for all of us to see

    ContextMaiden.WatchMe = {
	whitelist:[],
	debug: true,
	initialize:function(params) {
	    // this should be called once _per_ _browser_ not _per_browser_frame_ or
	    var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	    this.log = params.log ? params.log :function(x) { if (this.debug) aConsoleService.logStringMessage(x); };
	    this.log("WatchMe.initialize");
	    this.store = params.store ? newify(WatchmeStore,{filename:params.store.filename,table:params.store.table,debug:false,ask:false,log:this.log}) : undefined;
	    this.config = params.config ? newify(PlumTripleStore,{filename:params.config.filename,table:params.config.table,debug:false,ask:false,log:this.log}) : undefined;
	    this._init_whitelist();
	    this.FWS = ContextMaiden.FWS;
	    this.plumutil = JV3.plumutil;
	    this.FWS.initialize();
	    this.isAllowed = this.whitelist_allowed;
	    var _this = this;

	    this.FWS.handleEvent = this._makeQueuingHandleEvent();
	    this.log("... WatchMe starting ... ");
	    
	    if (params !== undefined && params.isAllowed !== undefined) {
		// replace whitelist-check function?
		this.isAllowed = params.isAllowed;
	    } else {
		this.log("watchme initit .params is " + params);
	    }
	},
	listeners:{},
	all_listeners:[],
	addListener: function(type,l) {
	    this.plumutil.assert(l !== undefined, "Listener must be defined");
	    if (type !== undefined) {
		if (this.listeners[type] !== undefined) {
		    if (this.listeners.indexOf(l) < 0) {
			this.listeners[type].push(l);
		    }
		}
		else this.listeners[type] = [l];
		return;
	    }
	    if (this.all_listeners.indexOf(l) < 0) {
		this.all_listeners.push(l);
	    }
	},
	_makeTimeoutHandleEvent: function(event_save_cont) {
	    var this_ = this;
	    if (!event_save_cont) { event_save_cont = this._saveEvtToStore; } 
	    return function() {
		var args = _this.plumutil.arguments2array(arguments);
		//for some reason timeStamp is rarely defined
		// var time = (event !== undefined && event.timeStamp !== undefined && event.timeStamp.valueOf !== 0) ? event.timeStamp.valueOf() : (new Date()).valueOf();
		var time = (new Date()).valueOf();
		args = [time].concat(args);
		JV3.setTimeout(function() {
		    _this.fireListeners.apply(_this,args);
		    var evt = _this.makeEvent.apply(_this,args);
		    event_save_cont.apply(this_,[evt]);
		},250); // delay so we don't freak out
	    };	    
	},
	_saveEvtToStore: function(evt) {
	    this.store.save(evt);
	},    
	_makeQueuingHandleEvent: function(event_save_cont) {
	    if (!event_save_cont) { event_save_cont = this._saveEvtToStore; } 
	    var queue = [];
	    var flush_threshold = 25; // flush after 25 events
	    var this_ = this;
	    return function() {
		var args = this_.plumutil.arguments2array(arguments);
		var time = (new Date()).valueOf();
		args = [time].concat(args);
		this_.fireListeners.apply(this_,args);
		var evt = this_.makeEvent.apply(this_, args.slice(0,args.length-1));
		queue.push(evt);	    
		this_.log("... watchme queueing["+queue.length+"] ... " + plumutil.toJSON(args) + " :::::: \n " + plumutil.toJSON(queue));

		if (queue.length > flush_threshold) {
		    this_.log("... watchme flushing to database ... " + queue.length);
		    var q = queue.concat();
		    queue = [];
		    this.plumutil.interval_map(q,function(evt) {
			event_save_cont.apply(this_,[evt]);
		    },250);		
		}
	    };	    
	},    
	_init_whitelist: function(){
	    var whitelist_els = [];
	    if (!this.config) { return; }
	    var els = this.config.load({type:"whitelist_domain"});
	    for (var v_i = 0; v_i < els.length; v_i++) {
		var urlpattern = els[v_i].urlpattern;
		if (urlpattern && urlpattern.length > 0 && this.whitelist.indexOf(urlpattern) < 0) {		
		    this.whitelist.push(els[v_i].urlpattern);
		}
	    }
	},
	all_allowed:function() {
	    return true;
	},
	whitelist_allowed: function(url) {
	    // override me if you want blanket
	    if (url === undefined) return false;
	    var matcher = function(x,target) {
		return (x == target);
	    };
	    for (var v_i = 0; v_i < this.whitelist.length; v_i++) {
		var m = matcher(url,this.whitelist[v_i]);
		if (m) return true;	    
	    }
	    return false;
	},
	isAllowed: undefined,
	addToWhiteList:function(candidate) {
	    if (this.whitelist.indexOf(candidate) < 0) {
		this.whitelist.push(candidate);
		this.config.save({id:encodeURIComponent(candidate),type:"whitelist_domain",urlpattern:candidate});
	    }
	},    
	setAllAllowed:function() {
	    this.isAllowed = this.all_allowed;
	},
	removeFromWhiteList:function(candidates) {
	    if (!plumutil.isArrayLike(candidates)) candidates = [candidates];
	    for (var i = 0; i < candidates.length; i++) {
		var ci_label = candidates[i].label;
		var indx = this.whitelist.indexOf(ci_label);
		if (indx >= 0) this.whitelist.remove(indx);
		var id = encodeURIComponent(ci_label);
		this.config.deletebyID(id);
	    }
	},
	fireListeners:function(time,type,location,host,title,fulltext,event) {
	    var ls = this.listeners[type] !== undefined ? this.listeners[type].concat(this.all_listeners) : this.all_listeners;
	    if (ls) {
		for (var i = 0; i < ls.length; i++) {
		    try {
			ls[i](time,type,location,host,title,event);
		    } catch(e) {
			//console.log('fireListeners: ' + e);
			alert('fireListeners ' + e);
		    }
		}
	    }
	},
	makeEvent:function(time,type,location,host,title,fulltext,event) {
	    if ((type == this.FWS.PAGE_LOADED || this.FWS.PAGE_UNLOADED || type == this.FWS.TAB_SWITCHED || type == this.FWS.WINDOW_FOCUSED)) {
		if (host && this.isAllowed(host)) {		
		    var rec = {id:time, location:location, host:host, type:type};
		    if (title) rec.title = title;
		    this.log("makeEVENT: " + new Date() + " " + type + " :: " + location + " :: " + host + " :: " + title );
		    return rec;
		} else {
		    var rec = {id:time, type:type};
		    this.log("makeEVENT: " + new Date() + " " + type + " :: other details forbidden ");
		    return rec;
		}
	    } else if ((type == this.FWS.USER_IDLE || type == this.FWS.USER_AWAKE)) {
		// idle things
		var rec = undefined;
		this.log("makeEVENT: " + new Date() + " " + type + " :: " + event);
		if (event !== undefined)
		    rec = {id:time, type:type, time:event};
		else
		    rec = {id:time, type:type};	    
		return rec;
	    };
	},
	logIDs:function() {
	    return this.store.find.apply(this.store,arguments);
	},
	loadEventID:function(id) {
	    return this.store.loadbyID(id);	
	},
	removeLogEvent:function(id) {
	    return this.store.deletebyID(id);
	}
    };
})

