// Copyright (c) 2008, 2009 Massachusetts Institute of Technology

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:

// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

(function(JV3) {
     JV3.FloatyViewController = {
	 grace_period:3600,
	 history:2*3600,
	 N:10,
	 threshold:1e-10,
	 showing:false,
	 refresh_interval:5000,
	 type2mode: {
	     "time":"time",
	     "note-edited":"note-edited",
	     "www-viewed": "site",
	     "location": "place",
	     "music-listened": "magic",
	     "schemas.Event":"magic"
	 },
	 initialize:function(scroll, $j, JV3, log,spinner) {
	     var document = scroll.document;
	     this.$j = $j;
	     this.mode = [];
	     this.queue = [];
	     this.prepend_nids = [];
	     this.ordering = undefined;
	     
	     this.scroll = scroll;
	     this.JV3 = JV3;
	     this.util = JV3.plumutil;
	     this.TS = JV3.ContextMaiden.TimeStruct;
	     this.log = JV3.log;
	     this.util = JV3.plumutil;
	     JV3.log("innnnnnnnnnit FloatyViewController : " + JV3.plumutil + " " + JV3.CMS);
	     this.stats = JV3.CMS.pstats;
	     this.current_context = {};
	     this._preload_context();
	     
	     this.showSpinner = function() {
		 spinner.setAttribute("hidden",false);
	     };
	     this.hideSpinner = function() {
		 spinner.setAttribute("hidden",true);
	     };
	     

	     var old_hasOrder = scroll.viewController.ensureHasOrder;
	     /*
	      scroll.viewController.ensureHasOrder = function(n) {
	      if (this.ordering) {
	      this.ordering = [n.id].concat(this.ordering);
	      }
	      old_hasOrder.apply(scroll.viewController, arguments);
	      };
              */
	     
	     this.orderer = this._makeOrderer();
	     this.start();

	     var this_ = this;
	     this.timer = window.setInterval(function() {
						 if (this_.isEngaged() && !this_.scroll.viewController.isEditing()) {//this_.queue.length && this_.isEngaged() && !this_.scroll.viewController.isEditing()) {
						     this_.showSpinner();
						     window.setTimeout(function() {
									   try {
									       this_._resetOrder();
									       this_.scroll.viewController.update();
									       this_.hideSpinner();
									   } catch(e) {
									       this_.log(e + " " + e.lineNumber + " " + e.fileName);
									   }
								       },1000);
						 }
					     },this.refresh_interval);
	     this._sub(JV3,document);
	     JV3.log("fvc - done init");
	 },
	 shutdown:function() {
	     if (this.timer) {   clearInterval(this.timer); }
	 },
	 _sub:function(JV3,document) {
	     var $j = this.$j;
	     var oservice = JV3._getObserverService();
	     var this_ = this;
	     var addf = function(noteid) {
		 this_.log("PREPENDING " + noteid);
		 this_.prepend_nids = [noteid].concat(this_.prepend_nids);
	     };
	     var observer = {
		 observe:function(subject,topic,data) {
		     addf.apply(this_,[data]);
		     return true;
		 }
	     };	
	     oservice.addObserver(observer, "add-note", false);
	     $j(document).unload(function() {
				     oservice.removeObserver(observer,"add-note");
				 });	
	 },
	 isEngaged:function() { return this.mode.length > 0; },
	 start:function() {

	     // AUTOMATICALLY starts looking for notes and repopulates according
	     // to changes in context
	     var this_ = this;
	     var TS = this.TS;
	     this.JV3.CMS.event_store.addStoreUpdateListener(undefined,{
								 itemUpdated: function(event) {
								     try {
									 JV3.log("--------updating current context");
									 this_._update_current_context(event);
									 this_.queue.push(event);
								     } catch(e) { JV3.log(e); }
								     //this_._resetOrder();
								     // -- do NOT do this because this will create catastrophic failure. :(  this_.scroll.viewController.update();
								 }
 							     });
	 },
	 _makeOrderer: function() {
	     var this_ = this;
	     return function(m) {
		 // what we do is sort by the order we've remembered in
		 var ordering = this_._getOrdering();
		 if (ordering === undefined) {
		     // rerank goes and sets the ordering
		     ordering = this_.rerank(m);
		     this.ordering = ordering;
		 }
		 return this_.scroll.viewController._sortNotes(m,ordering);
	     };
	 },
	 _getOrdering: function() { return this.ordering;   }, 
	 _resetOrder: function() { this.ordering = undefined; },    
	 _update_current_context : function(event) {
	     var TS = this.TS;
	     var now = this._getNowTS();	
	     //if (TS.makeDuration(event.start,event.end).intersection(now)) {
		 //this.log("setting_current_context : " + this.stats.getEventType(event) + " " + event.entity.id);
		 this.current_context[this.stats.getEventType(event)] = event;
	/*     } else {
		 JV3.log("--------not intersect now");
	     }
	 */
	 },
	 flush_queue:function() {
	     this.queue = [];
	 },
	 _datescore:function(note) {
	     var this_ = this;
 	     try {
		 var util = this.util;
		 var log = this.log;
		 var now = new Date();
		 var analysis = this_.JV3.analysis;
		 var plumdate = this_.JV3.analysis.PlumDate;
		 var v = analysis.getAnalysis(note);
		 if (v === undefined) {   /* not analyzed yet */ return { note:note, p:0 };   }
		 var count = 0;
		 var sum = util.mapsum(function(parse) {
					   //log(util.toJSON(parse.value));
					   if (parse && parse.value) {
					       count++;
					       return plumdate.compareTo({parse: parse.value}, now, new Date(note.created));
					   }
					   return 0;
				       }, util.objVals(v.hits));
		 if (count > 0) { return {note:note, p:sum/(1.0*count)}; }
		 return { note:note, p:0 };
	     }
	     catch(e) {
		 this_.log(e + " " + e.lineNumber + " " + e.fileName);
	     }
	 },
	 rerank:function(candidates) {
	     // computes a new ordering given 
	     // speedyrank notes
	     this.flush_queue();
 	     var this_ = this;	
	     var store = this.JV3.CMS.entity_store;
	     var note_rank = {};
	     var N = this.N;
	     var log = this.log;
	     var util = this.util;
	     var stats = this.stats;

	     var dateRank = function(notes) {
		 // computes the date rank for each note >> 
		 var now = new Date();
		 var analysis = this_.JV3.analysis;
		 var plumdate = this_.JV3.analysis.PlumDate;
		 if (!analysis) { return []; }
		 // extract ranks to now
		 var scores = notes.map(function(note) { return this_._datescore(note);});
		 return scores;
	     };

	     var speedyRank = function(notes,givens,minval) {
		 var PI = function(l) {
		     return l.reduce(function(x,y) { if (y === undefined) { return x; } return x*y; });
		 };
		 var SIGMA = function(l) {
		     return l.reduce(function(x,y) { if (y === undefined) { return x; } return x+y; });
		 };
		 
		 
		 // notes -> note event 
		 notes = notes.map(function(x) {
				       return { type:"note-edited", entity:{id:""+x.id, type:"note", note:x} };
				   });

		 return notes.map(function(val) {
				      return {
					  note:val.entity.note,
					  p:(SIGMA(givens.map(function(given) { return stats.getCoCount(val,given); })))
				      };
				  });
		 

		 /*

		 var denominator = PI(
		     givens.map(function(given) {
				    var given_T = stats.getTime(given); /// gets amount of time the given was true
				    if (given_T === 0) { this_.log("Given : " + given + " was 0"); return 0; }
				    return 1.0/given_T;
				}));

		 return notes.map(function(val) {
				      return {
					  note:val.entity.note,
					  p:(PI(givens.map(function(given) {
 							       var overlap = stats.getCoTime(val,given)/2.0;
							       JV3.log(val.type + "/" +
								       typeof(val.entity.id) + " " + given.type + "/" +
								       given.entity.id + overlap);
							       if (overlap === 0 && minval) { overlap = minval; }
							       return overlap;
							   })))*denominator
				      };
				  });
		  */
	     };

	     var givens = this._givens_based_on_current_context();
	     // if (!candidates) { candidates = this.util.objVals(this.scroll.viewController.getMatches()); }
	     this.log("givens : " + givens.map(function(x) { return x.type + " " + (x.entityid); }).join(","));

 	     var rankings = givens.length > 0 ? speedyRank(candidates,givens,1e-40) : [];
	     var ps = rankings.map(function(x) { JV3.log(x.p); return x.p; });
	     var current_order = this.scroll.viewController.getExplicitOrdering(); //this._getOrdering().concat();
	     
	     if (this._checkMode("time")) {
		 // mix time with other values
		 var date_rankings = dateRank(candidates);
		 ps = ps.length > 0 ?
		     util.multimap(function(x,y) { return x*y.p; }, ps, date_rankings) :
		     date_rankings.map(function(x) { return x.p; }); // no context rankings... just party with date rankings
	     }
	     
	     var topN = this.prepend_nids.map(function(nid) {
					     nid = parseInt(nid);
					     this_.util.removeElement(current_order, nid);
					     return nid;
					 });
	     
	     var topRankPs = [];
	     // here we surgically replace current ordering
	     for (var i = 0; i < Math.min(rankings.length,N); i++) {
		 var topval = Math.max.apply(undefined,ps);
		 var topidx = ps.indexOf(topval);
		 try {
		     var ith_top_note = rankings[topidx].note;
		     if (topval <= this.threshold) { break; }
		     topN.push( ith_top_note.id );
		     topRankPs.push( topval );
		     this_.util.removeElement(current_order, ith_top_note.id);
		     this_.util.removeIndices(ps,topidx);
		     this_.util.removeIndices(rankings,topidx);
		 } catch(e3) {
		     this_.log(e3 + " " + e3.lineNumber + " " + e3.fileName + " " + i + " topval:" +  topval + " idx:" + topidx);
		 }
	     }
	     current_order = topN.concat(current_order);

	     if (this.scroll.viewController) {
		 // rework this to only highlight entities -- maybe we can ask scroll to do that.
		 this.scroll.viewController.removeClassFromEntries("autorank"); // get rid of highlight
		 this.scroll.viewController.addClassToEntries("autorank",0,topN.length); // add highlight
	     }
	     
	     this.log("floaty-scroll rerank: returning " + current_order);
	     this.log("floaty-scroll reranked ps: " + topRankPs);
	     this._logRank(topN,topRankPs,givens);
	     
	     return current_order;
	 },
	 highlightTop:function(n)  {
	     if (this.scroll.viewController) {
		 this.scroll.viewController.removeClassFromEntries("autorank"); // get rid of highlight
		 this.scroll.viewController.addClassToEntries("autorank",0,n === undefined? 1 : n); // add highlight
	     }
	 },
	 deHighlight:function()  {
	     if (this.scroll.viewController) {
		 this.scroll.viewController.removeClassFromEntries("autorank"); // get rid of highlight
	     }
	 },
	 _logRank:function(topIDs,topPs,givens) {
	     var util = this.util;
	     var mode = this.mode;
	     var _encode = function(ids,ps,gs) {
		 var givens = gs.map(function(x) {
					 var ret = {};
					 ret[x.type] = x.entityid || x.entity.id;
					 return ret;
				     });
		 var rank = {};
		 util.multimap(function(id,p) { rank[id] = Math.round(p*100)/100.0; }, topIDs, topPs);
		 return({ mode:mode, givens: givens, rank: rank });
	     };
	     var data = _encode(topIDs,topPs,givens);
	     if (this._last_logged_rank == data) {
		 return;
	     }
	     this._last_logged_rank = data;
	     //this.JV3.logAction("rerank-result", undefined, undefined, undefined, window, data);			   	
	 },
	 _givens_based_on_current_context:function() {
	     
	     // determine givens based on current context
	     var this_ = this;
	     var givens = {};	
	     this.util.objKeys(this.current_context).map(function(contexttype) {
							     if (this_._checkMode(contexttype)) {
								 givens[contexttype] = this_.current_context[contexttype];
							     }
							 });
	     givens['www-viewed'] = { start:new Date().valueOf(), end: new Date().valueOf(),
				      type:"www-viewed", entityid:this.JV3.get_current_focused_page().loc, entitytype: "www-viewed" };
	     
	     if (givens) { delete givens["note-edited"]; }
	     return this.util.objVals(givens);
	 },
	 showNoteInElement:function(note,element) {
	     if (element.id == note.id) { return; }
	     this.$j(element).find(".note-display-text").html(note.text);
	     element.id = note.id;
	 },    
	 empty:function(note,element) {this.$j(element).find(".note-display-text").remove();    },
	 _preload_context:function() {
	     var c = this.stats;
	     var store = this.JV3.CMS.event_store;
	     var types = this.stats.getTypes();
	     var nowTS = this._getNowTS();
	     var current_context = {};
	     types.map(function(type) {
			   var evts = store.getEvents(type,nowTS);
			   var evt = evts.length > 0 ? evts[0] :undefined;
			   if (evts.length > 1) {
			       evts.sort(function(x,y) { return x.end < y.end; });
			       evt = evts[evt.length-1];
			   }
			   if (evt) {	current_context[c.getEventType(evt)] = evt;   }
		       });
	     return current_context;
	 },
	 setMode:function(dim,isEnabled) {
	     var mode = this.mode;
	     if (isEnabled) {
		 mode.push(dim);
		 mode.sort();
	     } else {
		 this.util.removeElement(mode,dim);
	     }
	     // this.log("floaty: setting mode to " + mode.join(","));
	     if (mode.length > 0) {
		 //this._resetOrder();
		 //this.log("floaty: setting orderer to us");
		 this.prepend_nids = [];
		 this.scroll.viewController.setOrderer(this.orderer);
		 this.scroll.viewController.update();
	     } else {
		 //this.log("floaty: resetting orderer to byExplicitOrdering " + mode.join(","));
		 this.scroll.viewController.removeClassFromEntries("autorank"); // get rid of highlight	    
		 this.prepend_nids = [];
		 this.scroll.viewController.setOrderer(this.scroll.viewController.NoteOrderers.byExplicitOrdering);
		 this.scroll.viewController.update();
	     }
	     //this.JV3.logAction("rerank-mode-switch", undefined, undefined, undefined, window, { mode: mode.length > 0 ? mode : "normal"});
	 },
	 _checkMode:function(event_type) {


	     // checks to see if, given our current mode, we should include this context_type
	     this.util.assert(this.type2mode[event_type], "No mode for " + event_type + ". Fail");
	     
	     return this.mode.indexOf(this.type2mode[event_type]) >= 0;
	 },
	 _getNowTS:function() {
	     var TS = this.TS;
	     var nowdate = new Date().valueOf();
	     return TS.makeDuration(nowdate-this.history,nowdate);
	 }
     };
 });



/**

	// hijack the update -- HOSTILE TAKEOVER of update code
	var this_ = this;
	var oldupdate = scroll.viewController.update;
	scroll.viewController.update = function() {
	    this_.log("floaty-scroll:update()");
	    this_._resetOrder();
	    oldupdate.apply(scroll.viewController, arguments);
	};
	


*/

/*
    addNote:function(n) {
	this.log("floaty-scroll -- addnote:: " + n.id);
	var nd = this._makeNoteDisplay(n);
	var node = this.element;//this.element.find("ul");
	if (nd) { node.append(nd);}
	this.visibleNotes[n.id] = nd;
	this.noteShowTime[n.id] = new Date();

	var this_ = this;
	var $j = this_.scroll.viewController.$j;
	$j(nd).click(function() {
	    try {
		this_.hide();
		var entry = this_.scroll.viewController.getEntryFor(n);
		if (entry) {
		    this_.hide(function() {
			try {
			    this_.log("scroll is " + this_.scroll + " " + $j(entry)  + " " + $j(entry).offset().top);
			    this_.scroll.window.scrollTo(0, $j(entry).offset().top );
			} catch(e) {
			    this_.log(e + " " + e.lineNumber + " " + e.fileName);
			}
			
		    });
		}
	    } catch(e) {
		this_.log(e + " " + e.lineNumber );
	    }
	});
    },
    removeNote:function(n) {
	if (typeof n != 'object') {   n = { id: n };} // check if someone gave us the id instead	
	this.$j(this.visibleNotes[n.id]).remove();
	delete this.visibleNotes[n.id];
	delete this.noteShowTime[n.id];
    },
    getShowingNoteIds: function() { return this.util.objKeys(this.visibleNotes); },
    getShowingNotes:function() {
	var this_ = this;
	return this.getShowingNoteIds().map(function(x) {
	    return this_.JV3.getNoteById(x);
	});
    },
    _makeNoteDisplay: function(note) {
	var text = note.text;
	var this_ = this;
	if (!note.text) { return; }
	var document = this.scroll.document;
	var noteDisplay = document.createElement('div');
	noteDisplay.setAttribute('class', "note-display");
	noteDisplay.id = note.id;
	
	var markerSpan = document.createElement('ul');
	markerSpan.setAttribute('class','note-display-list');
	
	var textSpan = document.createElement('li');
	textSpan.setAttribute('class', "note-display-text");
	textSpan.innerHTML = this.JV3.util.defang(text);
	
	var sinkSpan = document.createElement('div');
	sinkSpan.setAttribute('class', "sink-button");
	
	markerSpan.appendChild(textSpan);
	noteDisplay.appendChild(sinkSpan);
	noteDisplay.appendChild(markerSpan);
	
	sinkSpan.addEventListener('click', function(e)  {
            var entry = e.target.parentNode.parentNode;
	    this_.$j(entry).fadeOut("slow", function () {
	// JV3.deleteNote(entry.id); 
	    });
	    e.cancelBubble = true; // stop propagation
	}, false);
	return noteDisplay;
    },


awesome slider version

// init:

    getContextValueElement:function(type) {
	if (this.current_context_element) {
	    return this.current_context_element.find("#context-state-"+type).find(".value");
	} 
    },


    this.visible = false;

    init_slider:function(){
	try {
	    this.log("floatyview init elements : " + $j(document).find("#floaty-overlay").find("ul").length);
	    this.buildDOM($j(document).find("#floaty-overlay"), undefined); // $j(document).find("#context-overlay"));
	    //this.hide();
	    this.start();
	    this.log("floaty: done initializing  ");
	} catch(e) {
	    this.log(e + " " + e.lineNumber + " " + e.fileName);
	}	
    },
    show:function(cont) {
	var this_ = this;
	try {
	    var height = this_.element.parent().height();
	    this.element.animate({ top:0, bottom:-(height+this_.element.height()), left:0, right:0 }, 500, "linear", function() {
		this_.showing = true;
		if (cont) { cont(); }
	    });
	} catch(e) {
	    this_.log(e + " " + e.lineNumber + " " + e.fileName);
	}
    },
    hide:function(cont) {
	var this_ = this;
	this.element.animate({ top:0, bottom:0, left:"-100%", right:"100%" }, 500, "linear", function() {
	    this_.showing = false;
	    if (cont) { cont(); }
	});
    },
    buildDOM:function(entries_element,context_element) {
	var $j = this.$j;
	this.element = entries_element;
	this.current_context_element = context_element;
	// populate the context provider
	this.stats.getTypes().map(function(type) {
	    $j("<div class=\"context-state\" id=\"context-state-"+type+"\">"+type+":<span class=\"value\"></span></div>").
		click(function(x) { $j(this).toggleClass("context-disabled"); }).
		appendTo(context_element);
	});
    },


*/

/*
jQuery(document).ready(function() {
    Components.utils.import("resource://listit/share.jsm");
    self.JV3 = share.JV3;

    var size = self.JV3.prefs.getIntPref('general.fontSize');
    if (size === 0) {size = "100%";}
    var entries = document.getElementById("entries");
    jQuery(entries).css('font-size',size);
    try {
	self.view = self.JV3.newify(FloatyViewController,self.JV3);
    } catch(e) {
	self.JV3.log(e + " " + e.lineNumber + " " + e.fileName);
    }
    self.view.buildDOM(entries, jQuery("#context"));
    self.view.start();
    self.view._update_display();
});
*/

	/*this._map = this.util.interval_map( ,
	    function(note) {
		try{
 		    if (note.deleted || note.text.length == 0) { return {note: note, p:0};    }
		    var ret = {note: note, p:stats.getConditionalPTime({ type:"note-edited", entity:{id:"note-"+note.id} },this_.util.objVals(givens), 1e-2)};
		    this_.log("evaluating " + note.id + " " + ret.p);
		} catch(e)  {  this_.log(e + " " + e.lineNumber + " " + e.fileName);	}
	    },
	    function(rankings) {
		try {		    
		    
		} catch(e) {
		    this_.log(e + " " + e.lineNumber + " " + e.fileName);
		}
	    },this_.log,100);
*/


/*
	    //
	    if (!this_.getContextValueElement(contexttype) ||
		!this_.getContextValueElement(contexttype).parent().hasClass("context-disabled")) {
		
	    } else {
		this_.log("skipping context element : " + contexttype);
	    }
	});
	
	if (this.getContextValueElement()) {
	    this_.log("context elements included in givens : " + this.util.objKeys(givens));	
	    this.JV3.givens = givens;
	    stats.getTypes().map(function(type) {
		if (givens[type]) {
		    this_.getContextValueElement(type).html( givens[type].entity ? givens[type].entity.id : givens[type].entityid );
		} else {
		    this_.getContextValueElement(type).html("none");
		}
	    });
	}
	
	if (givens) { delete givens["note-edited"]; }
	if (this.util.objKeys(givens).length == 0) {  this.empty();    return;	}

	this_.log("||| context elements included in givens : " + this.util.objKeys(givens));

	var displayRankedNotes = function(rankings) {
	    // let's see how many of the top N
	    this_.element.find(".note-display:gt("+(rankings.length-1)+")").remove();
	    var displays = this_.element.find(".note-display");
	    displays = this_.element.find(".note-display");
	    rankings.map(function(noterank) {
		var rank = rankings.indexOf(noterank);
		if (rank >= displays.length) {
		    this_.addNote(noterank.note);
		} else {
		    this_.$j(displays[rank]).hide("slow", function() {
			this_.showNoteInElement(noterank.note,displays[rank]);
			this_.$j(displays[rank]).show("slow");
		    });
		}
	    });
	};
	if (this._map) { this._map.stop();}
*/
