// document.getElementById("view").addEventListener("pageshow", function() {      jSidebar.init();                            }, false);
// document.getElementById("view").addEventListener("pageshow", function() {      jSidebar.init();                            }, false);
window.addEventListener("load", function() { jSidebar.init(); }, false);

function consoleLog(message) {
    // invoke me only when JV3 is not available
    var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
    aConsoleService.logStringMessage(message);
}    
function xuload(scriptpath) {
    // thanks to http://www.getbooksmarts.org/news/2007/03/13/how-to-do-dynamic-javascript-imports-in-xul-chrome/ (!)
    try {
	var jsLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Components.interfaces.mozIJSSubScriptLoader);
	return jsLoader.loadSubScript(scriptpath,self);
    } catch(e) {
	consoleLog(e);
    }
}
function getJV3() {
    if (self.JV3 === undefined) {
	self.JV3 = Components.classes['@electronic.max/listit;1'].getService().wrappedJSObject;
    }
    return self.JV3;	
}
jSidebar = {};

jSidebar.make_observer_handlers = function(JV3) {
    var this_ = this;
    var wrappify = function(f) {
	return {
	    observe: function(subject,topic,data) {
		return f.apply(this_,[data]);
	    }
	};
    };

    return {	    
	"add-note":wrappify(function(id) {
				try {
				    var view = this.getView();
				    if (view && view.viewController) {
					var note = JV3.getNoteById(id);
					if (!note.deleted) {
					    view.viewController.insertNote(note, true);
					    view.viewController.applySortability();
					}
				    }
				    return true;
				} catch (e) {
				    JV3.log(e + " " + e.lineNumber + " " + e.fileName);
				}
			    }),

	"remote-add-note":wrappify(function(id) {
				       try {
					   var view = this.getView();
					   if (view && view.viewController) {
					       var note = JV3.getNoteById(id);
					       if (!note.deleted) {
						   view.viewController.insertNote(note);
						   view.viewController.applySortability();
					       }
					   }
					   return true;
				       } catch (e) {
					   JV3.log(e + " " + e.lineNumber + " " + e.fileName);
				       }
				   }),	

	"delete-note":wrappify(function(id) {
				   var view = this.getView();
				   if (view && view.viewController) {
				       var note = JV3.getNoteById(id);
				       view.viewController.removeNote(note);
				   }
				   return true;
			       }),
	
	"save-note":wrappify(function(id) {
				 var view = this.getView();
				 if (view && view.viewController) {
				     // var note = JV3.getNoteById(id);
				     // view.viewController.updateNote(note);
				     if (id == this_.CONFIG_NOTE_ID) {
				      	 // re-order notes x
				      	 JV3.log(" blowing away note ordering ---------------> ");
				      	 delete view.viewController.__ordering__;
				      	 view.viewController.update();
				     } else {
					 var note = JV3.getNoteById(id);
					 view.viewController.updateNote(note);
				     }
				 }
				 return true;
			     }),
	
	"note-undelete":wrappify(function(id) {
				     var view = this.getView();
				     if (view && view.viewController) {
					 var note = JV3.getNoteById(id);
					 view.viewController.insertNote(note, true);
					 view.viewController.applySortability();
				     }
				     return true;
				 }),

	"notes-reordered":wrappify(function(id) {
				       var view = this.getView();
				       if (view && view.viewController) {  view.viewController.update();  }		
				   }),

	"sync-start":wrappify(function(id) {
				  window.document.getElementById("toolbarSync").disabled = true;
				  this.setSpinner();
				  return true;
			      }),
	
	"login-success":wrappify(function(id) {
				    window.document.getElementById("toolbarError").setAttribute("hidden",true);
				    window.document.getElementById("toolbarLogin").setAttribute("hidden",true);
				}),

	"sync-success":wrappify(function(id) {
				    window.document.getElementById("toolbarSync").disabled = false;
				    window.document.getElementById("toolbarError").setAttribute("hidden",true);
				    window.document.getElementById("toolbarLogin").setAttribute("hidden",true);
				    this.errorMessage("sync success");
				    this.removeSpinner("sync complete");
				    return true;
				}),
	
	"sync-error":wrappify(function(msg) {
				  window.document.getElementById("toolbarSync").disabled = false;
				  if (msg.indexOf("401") > -1) {
				      window.document.getElementById("toolbarError").setAttribute("hidden",false);
				  }
				  this.removeSpinner(msg);
				  this.errorMessage(msg);
				  return true;
			      })
    };
};

jSidebar.init = function() {
    var JV3 = getJV3();
    var _start = (new Date());
    JV3.log("listit-xul.js > init()START  ----->" + _start.toString());
    JV3.set_last_opened(new Date());
    JV3.log("listit-xul.js > setlastopened  ----->" + (new Date().valueOf() - _start));
    
    try {
	var this_ = this;
	var document = window.document;
	var _view = undefined;
	var $j = jQuery.noConflict();
        jSidebar.noteInput = document.getElementById('note-input-textbox');
        jSidebar.searchbar = document.getElementById('jsearchbar'); // not the textbox!
	jSidebar.searchbar.addEventListener('focus', function() {
						JV3.logAction('searchbar-focus', undefined, undefined, undefined, this_.getView()._logActionHelper());
					    }, false);
	
	jSidebar.setPrefs = function() {
	    var backgroundImage = JV3.prefs.getCharPref("general.background");
	    if (!(backgroundImage.indexOf('file://') === 0 ||
		  backgroundImage.indexOf('chrome://') === 0)) {
		backgroundImage = "file://"+backgroundImage;
	    }
	    if (backgroundImage) {
		var halign = JV3.prefs.getCharPref("general.halignBackground");
		var valign = JV3.prefs.getCharPref("general.valignBackground");
		var center = halign + " " + valign;
		var mainBox = document.getElementById('mainBox');
		mainBox.style.backgroundImage = 'url("'+backgroundImage+'")';
		mainBox.style.backgroundPosition = center;
	    }
            var fontSize = JV3.prefs.getIntPref("general.fontSize");
            this.noteInput.style.setProperty('font-size',fontSize+"px","");
	};
	jSidebar.getView = function() {
	    if (_view === undefined) {
		_view = document.getElementById('view').contentWindow.QueryInterface(Components.interfaces.nsIDOMWindow);		
	    }
	    return _view;
	};
	jSidebar.getViewController = function() {
	    try {
		return this.getView().viewController;
	    } catch (e) { JV3.log(e + " " + e.lineNumber + " " + e.fileName); }
	};	
	jSidebar.newNote = function() {
	    if (this.noteInput.value === "") {
		return;
	    }
	    try{
		JV3.addNote(this.noteInput.value, this_.getView().get_active_queries_and_filters(), this_.getView()._logActionHelper());
	    } catch(e) {
		JV3.log(e);
		JV3.addNote(this.noteInput.value, undefined, {window_id:JV3.getWindowId(window)});
	    }
	    this.noteInput.value = "";
	};	
	jSidebar.setSearchState = function(text) {
	    // call me to set my search state ~ 
	    this.searchbar._textbox.value = text;
	    this.searchbar.searchCommand();
	    this.search(text);
	};
	jSidebar.focusSearch = function() {
	    this.searchbar._textbox.focus();	    
	};
	jSidebar.search = function(textValue) {
	    try {
		var this_ = jSidebar;
		var view = this_.getView();
		var vc = this_.getViewController();
		view.setQuery(textValue);
		var logquery = function(q,matches) {
 		    try {
			var meta = {window_id:JV3.getWindowId(window)};
			if (q) {
			    if (vc) { meta = view._logActionHelper(); }
			    // JV3.log("logging Search --- " + q + " " + JV3.plumutil.toJSON(meta));
			    meta.hits = matches.map(function(x) { return x.id; });
			    JV3.logAction('search', undefined, undefined, q, meta);
			} else {
			    JV3.logAction('clear-search', undefined, undefined, "", meta);
			}
			delete this_._last_query;
		    } catch (x) {
			JV3.log(x);
		    }		
		};		
		view.viewController.update(function(matches) {
					       var delay = 5000;		
					       if (jSidebar.searchDelay) { JV3.clearTimeout(this_.searchDelay); }
					       // outstanding query...					       
					       if (textValue && (!this._last_query || JV3.plumutil.edit_distance(this._last_query,textValue) < textValue.length)) { //  this._last_query == textValue || textValue.indexOf(this_._last_query) >= 0)) {
						   // refinement
						   // JV3.log("refinement! " + textValue);
						   this_._last_query = textValue;
						   this_.searchDelay = JV3.setTimeout(function() {  logquery(textValue,matches);  }, delay);
					       } else {
						   // JV3.log("not refinement/clear! " + textValue);
						   var lq = this._last_query;
						   delete this._last_query;		    
						   if (lq) { logquery(lq,matches); }
						   if (!textValue){
						       logquery("",matches);
						   } else {
						       this_.searchDelay = JV3.setTimeout(function() {  logquery(textValue,matches);  }, delay);
						   }
					       }});		
	    } catch(e) {
		JV3.log(e);
	    }
	},

//	jSidebar.sync = function() {
//	    JV3.sync_now();
//	};	    
		
	jSidebar.errorMessage =  function(text) {
	    try {
		var error = document.getElementById('error');
		var errorLabel = document.getElementById('errorLabel');
		var mainBox = document.getElementById('mainBox');
		errorLabel.value = text;
		$j(mainBox).animate({ paddingBottom: 0 }, 300);
		$j(error).show(480);
		setTimeout(function() {
			       $j(mainBox).animate({ paddingBottom: "10px" }, 300);
			       $j(error).hide(480);
			   }, 2000);
	    } catch(e) {
		JV3.log(e + " " + e.lineNumber + " " + e.fileName);
	    }
	};

	var SPINNER = "chrome://listit/skin/sidebar/arrowstill.png";
	var SPINNER_RUN = "chrome://listit/skin/sidebar/arrowspinner.gif";	

	var resetSpinner = function() {
	    var spinner = document.getElementById('spinner');
	    spinner.src = SPINNER;
	};		
	var spinSpinner = function() {
	    var spinner = document.getElementById('spinner');
	    spinner.src = SPINNER_RUN;
	};	
	jSidebar.spinnerTimeout = function(timeout_msg) {
	    setTimeout(function() {  resetSpinner();   }, 1000);
	};
	jSidebar.setSpinner = function(timeout_msec, timeout_msg) {
	    spinSpinner();
	    jSidebar.timeoutID = setTimeout(function() { jSidebar.spinnerTimeout(timeout_msg); }, timeout_msec || JV3.syncTimeoutMsec);
	};
	jSidebar.removeSpinner = function(text) {
	    clearTimeout(jSidebar.timeoutID);
	    resetSpinner(); 
	};

	var observer_hs = jSidebar.make_observer_handlers(JV3);	
	jSidebar._cb_sidebarOpen = function() {
	    // now attach observer listeners
	    var oservice = JV3._getObserverService();	    
	    for (var topic in observer_hs) {
		var observer = observer_hs[topic];
		oservice.addObserver(observer, topic, false);
	    }
	    JV3.logAction("sidebar-open",undefined,undefined,undefined,{ window_id:JV3.getWindowId(window) });

	    this._restore_Leftovers();
	};
	jSidebar._restore_Leftovers = function() {
	    // now restore text that wasn't saved
	    try {
		var lo = JV3.prefs.getCharPref("leftover_input");
		if (lo.length > 0) {
		    window.document.getElementById("note-input-textbox").value = lo;
		    // clear
		    JV3.prefs.setCharPref("leftover_input","");
		}
	    } catch (x) { JV3.log(x);  }  
	};
	jSidebar._save_Leftovers = function () {	    
	    try {
		var t =  window.document.getElementById("note-input-textbox").value;
		if (t.length > 0) {
		    var cp = JV3.prefs.getCharPref("leftover_input");
		    JV3.prefs.setCharPref("leftover_input",JV3.plumutil.trim(cp + "\n" + t));
		}
	    } catch (x) {  JV3.log(x); }	    
	};
        jSidebar.startup_focus = function(focusTarget){
	    try {
		JV3.log("focusTarget: ",focusTarget);
		if (focusTarget == 'search') {
		    return this.focusSearch();
		} 
		this_.noteInput.focus();
		if (highlight_on_focus) {
		    this_.noteInput.selectionStart = 0;
		    // used to be noteInput[0], but that was throwing an exception
		    this_.noteInput.selectionEnd = this_.noteInput.value.length;
		    this_.noteInput.focus();
		}
	    } catch (x) { /*JV3.log(x);*/ }
	};
		
	jSidebar._cb_sidebarClose = function(event) {
	    // now attach observer listeners
	    //JV3.log("_cb_sidebarClose");
	    if (event.target.location == "chrome://listit/content/listit/listit.xul") {
		//JV3.log("_cb_sidebarClose() : detaching relevant observers -- ");
		// first check for text in the input box

		this._save_Leftovers();
		try {
		    var oservice = JV3._getObserverService();
	            for (var topic in observer_hs) {
			var observer = observer_hs[topic];
			try {
		            oservice.removeObserver(observer, topic);
			} catch (e) {
		            JV3.log("tried to detached non-attached observer, but that's okay. I still love you.");
			}
	            }		    
		    // we really want window id
                    JV3.logAction("sidebar-close",undefined,undefined,undefined,{ window_id:JV3.getWindowId(window) });
		} catch (x) {
		    JV3.log(x);
		}
	    }
	    try {
                if (jSidebar.getView() !== undefined &&
		    jSidebar.getView().viewController !== undefined &&
		    jSidebar.getView().viewController.floatyController !== undefined) {
		    jSidebar.getView().viewController.floatyController.shutdown();
		}
	    }
	    catch(e) {    JV3.log(e + " " + e.lineNumber + " " + e.fileName);    }
	};

        jSidebar.openPrefs = function() {
	    var Application = Components.classes["@mozilla.org/fuel/application;1"].
		getService(Components.interfaces.fuelIApplication);
	    var preferences = Application.activeWindow.open(JV3.util.url("chrome://listit/content/about/about.html#preferences"));
	    preferences.focus();
	    home.focus();
       };

        jSidebar.openHelpPrefs = function() {
	    var Application = Components.classes["@mozilla.org/fuel/application;1"].
		getService(Components.interfaces.fuelIApplication);
	    var home = Application.activeWindow.open(JV3.util.url("chrome://listit/content/about/about-help.html"));
	    home.focus();
       };

//        jSidebar.openDustbin = function() {
//	    var Application = Components.classes["@mozilla.org/fuel/application;1"].
//		getService(Components.interfaces.fuelIApplication);
//	    var dustbin = Application.activeWindow.open(JV3.util.url("chrome://listit/content/dustbin.html"));
//	    dustbin.focus();
 //       };

 //       jSidebar.openAbout = function() {
//	    var Application = Components.classes["@mozilla.org/fuel/application;1"].
//		getService(Components.interfaces.fuelIApplication);
//	    var about = Application.activeWindow.open(JV3.util.url("chrome://listit/content/about/about.html"));
//	    about.focus();
//        };

  //      jSidebar.openLogin = function(mode) {
//	    var login = document.getElementById("login");
//	    document.getElementById("loginBox").setAttribute("hidden","false");
//	    login.contentWindow.QueryInterface(Components.interfaces.nsIDOMWindow).switchMode(mode);
 //       }

        jSidebar.closeLogin = function(time) {
	    if (time) {
                setTimeout(function() {
			       document.getElementById("loginBox").setAttribute("hidden","true");
			   },time);
	    } else {
                document.getElementById("loginBox").setAttribute("hidden","true");
	    }
	    if (JV3.prefs.getBoolPref("sync.support") || !JV3.prefs.getBoolPref("sync.annoy")) {
                document.getElementById("toolbarLogin").setAttribute("hidden",true);
	    }
	    document.getElementById("toolbarError").setAttribute("hidden",true);
        };

        jSidebar.openLink = function(url) {
	    var Application = Components.classes["@mozilla.org/fuel/application;1"].
		getService(Components.interfaces.fuelIApplication);
	    var link = Application.activeWindow.open(JV3.util.url(url));
	    link.focus();
        };
// jSidebar.openPrint used
        jSidebar.openPrint = function() {
	    var view = this.getView();
            view.viewController.getPrintInfo(function(printInfo) {
						 // save this guy
						 JV3.printInfo = printInfo;
						 jSidebar.openLink("chrome://listit/content/print/print.html");
					     });
        };

        jSidebar.copy = function(event) {
            //JV3.log(event.originalTarget.toString());
            Components.classes["@mozilla.org/widget/clipboardhelper;1"]
            .getService(Components.interfaces.nsIClipboardHelper)
            .copyString(event.originalTarget.toString());
        };

	jSidebar.toggleCollapsed = function() {
	    try {    
		var collapsed = this.getViewController().toggleCollapsed();
		document.getElementById("img_collapsed").setAttribute("src", collapsed ? "chrome://listit/skin/p-arrow-left.png" :
								      "chrome://listit/skin/p-arrow-down.png");
	    } catch (x) {
		JV3.log(x);
	    }	    
	};

	// attach teardown
	// now finish initializing!
	// jSidebar.setPrefs();

	
	var highlight_on_focus = true;

        jSidebar.loadResearchbar = function() {
	    // load previous values //
	    jsidebar.getSearchFavs().map(function(x) { jsidebar.addSearchToBar(x); });
	    $j("#researchbar").attr("hidden",false);
	    $j("#researchbar").css("display","block");
	};

	jSidebar.hideResearchbar = function() {
	    $j("#researchbar").attr("hidden",true).children().remove().css("display","none");
	};

	// searchin'
	var searchbar = document.getElementById("jsearchbar");
	jSidebar.getSearchFavs = function() {
	    var prevs = JV3.prefs.getCharPref("researchbar.savedfavs");
	    var opts = [];
	    if (prevs) {
		try {
		    opts = JV3.plumutil.fromJSON(prevs);
		} catch(e) {
		    JV3.log(e + " " + e.lineNumber + " " + e.fileName); 
		}
	    }
	    return opts.map(function(x) { return JV3.plumutil.trim(x); });
	};
	jSidebar.saveSearchFavs = function(favs) {
	    if (favs) {
		return JV3.prefs.setCharPref("researchbar.savedfavs",JV3.plumutil.toJSON(favs));
	    }
	    return undefined;
	};
	jSidebar.addSearchTextToBarAndSave = function() {
	    var search = searchbar._textbox.value !== undefined ? JV3.plumutil.trim(searchbar._textbox.value) : "";
	    if (JV3.plumutil.trim(search).length > 0 && this.getSearchFavs().indexOf(search) < 0) {
		jSidebar.addSearchToBar(search);
		jSidebar.saveSearchFavs(jSidebar.getSearchFavs().concat([search]));
	    }
	};
	jSidebar.addSearchToBar = function(search) {
	    var bel = document.createElement("button");
	    var id = "filter_"+JV3.plumutil.guid();
	    bel.setAttribute("label", search);
	    bel.setAttribute("id", id);
            bel.setAttribute("context","researchmenu");
	    bel.checked = false;
	    bel.setAttribute("class","inactive_button");
	    bel.setAttribute("oncommand", "jSidebar._toggleFilter(\""+search+"\",\""+id+"\"); this.blur();");
	    document.getElementById("researchbar").appendChild(bel); 
	};
	jSidebar.deleteSearchFromBar = function(event) {
            var search = document.popupNode;
            var bar = search.parentNode;
            var term = search.label;
            var searchFavs = jSidebar.getSearchFavs();
            searchFavs.splice(searchFavs.indexOf(term),1);
	    jSidebar.saveSearchFavs(searchFavs);
            bar.removeChild(search);
	};
	jSidebar._toggleFilter = function(s, id) {
	    var term = document.getElementById(id);
	    JV3.logAction("toggle-search",undefined,!term.checked,s,{ window_id:JV3.getWindowId(window) });
	    if (term.checked) {
		term.setAttribute("class", "inactive_button");
		jSidebar.removeFilter(s);
		term.checked = !term.checked;
		return;
	    }
            term.setAttribute("class", "active_button");
	    jSidebar.addFilter(s);
            term.checked = !term.checked;
            
	};
	jSidebar.addFilter = function(s) {
	    var view = this.getView();
	    view.viewController.addTextMatchFilter(s);
	    view.viewController.update();
	}; 
	jSidebar.removeFilter = function(s) {
	    var view = this.getView();
	    view.viewController.removeTextMatchFilter(s);
	    view.viewController.update();
	};	

	jSidebar.noteInput.addEventListener('focus',
					    function() {
						try {
						    JV3.logAction('notecapture-focus', undefined, undefined, undefined, this_.getView()._logActionHelper());
						} catch (x) {
						    JV3.log(x);
						}						    
					    }, false);
	jSidebar.noteInput.addEventListener('keypress', function(event) {
						if (event.keyCode === 13) {
						    var shift = event.shiftKey;
						    var need = JV3.prefs.getBoolPref("general.shiftReturn");
						    if ((shift && need) || (!shift && !need)) {
							event.preventDefault();
							event.cancelBubble = true;
							jSidebar.newNote();
						    }
						}
					    }, false);
        jSidebar.noteInput.addEventListener('keyup', function(event) {
						// JV3.log("client: "+jSidebar.noteInput.clientHeight + " scroll: " + jSidebar.noteInput.scrollHeight);
						if (jSidebar.noteInput.clientHeight < jSidebar.noteInput.scrollHeight) {
						    try {
							jSidebar.noteInput.style.height = jSidebar.noteInput.scrollHeight;
							// JV3.log("client: " + jSidebar.noteInput.clientHeight);
							// JV3.log("height: " + jSidebar.noteInput.style.height);
						    } catch(e) {
							JV3.log(e);
						    }
						}
					    }, false);
	
        JV3.log("listit-xul.js > setting up time ----->" + (new Date().valueOf() - _start));
	let w = window;
	let d = document;
	let jsidebar = jSidebar;
	JV3.setTimeout(function() {
			   try {
                               JV3.log("listit-xul.js > timer running ----->" +  (new Date().valueOf() - _start));
			       jsidebar.setPrefs();
			       w.parent._listit_lambda_queue.map(function(f) { try { f(window,$j);  } catch(e) { JV3.log(e); } });
			       w.parent._listit_lambda_queue = [];

			       try {
			           this_.noteInput.focus();
			           if (highlight_on_focus) {
				       this_.noteInput.selectionStart = 0;
				       // used to be noteInput[0], but that was throwing an exception
				       this_.noteInput.selectionEnd = this_.noteInput.value.length;
				       this_.noteInput.focus();
			           }
			       } catch (x) {
                                   JV3.log("disregard --");
                                   JV3.log(e);                                   
			       }				   

                               
                               JV3.log("listit-xul.js > loadresearcbar ----->" + (new Date().valueOf() - _start));
			       if (JV3.prefs.getBoolPref("researchbar.enabled")) {
				   jsidebar.loadResearchbar();
			       }
			       // 
			       this_._cb_sidebarOpen();
			       // pop up annoyance
			       if (!JV3.prefs.getBoolPref("sync.support") && JV3.prefs.getBoolPref("sync.annoy")) {
				   d.getElementById("toolbarLogin").setAttribute("hidden",false);
			       }
			       w.addEventListener("pagehide", function(event) { this_._cb_sidebarClose(event);   return true; }, true);
                               JV3.log("listit-xul.js > cb sidebar open sync ----->" + (new Date().valueOf() - _start));

			       JV3.setTimeout(function() {
                                                  JV3.log("double timeout sync ----->" + (new Date().valueOf() - _start));
						  if (JV3.sync === undefined) { JV3.login(); } else {
						      w.document.getElementById("toolbarError").setAttribute("hidden",true);
						      w.document.getElementById("toolbarLogin").setAttribute("hidden",true);	    
						  }
					      }, 5000);
			   } catch(e) {   JV3.log(e);   }
			   
			   JV3.log("autorank enabled" + JV3.prefs.getBoolPref("autorank.enabled"));			   
			   if (JV3.prefs.getBoolPref("autorank.enabled")) {
			       // add a button
			       try {
				   // 
  				   var rbar = document.getElementById("recommendbar");
				   rbar.setAttribute("hidden",false);	    
				   // initialize de scroll-extension
				   xuload("chrome://listit/content/listit/floaty-scroll.js")(JV3);
				   JV3.log("floaty scroll is " + JV3.FloatyViewController);
				   var recommend_engine  = JV3.newify(JV3.FloatyViewController,
								      jsidebar.getView(), $j, JV3, JV3.log, document.getElementById("rank_spinner"));
				   
				   // JV3.fdebug = recommend_engine;
				   jsidebar.getView().viewController.floatyController = recommend_engine;
				   jsidebar.toggleRecommend = function(mode) {
				       try { 
					   var buttonName = "recommend_"+mode ;			
					   var button = document.getElementById(buttonName);
					   if (button.toggle) { button.toggle = false; } else { button.toggle = true; }
					   button.setAttribute("class", button.toggle ? "active_button" : "inactive_button" );
					   recommend_engine.setMode(mode,button.toggle);
				       } catch(e) {
					   JV3.log("++++++++++++++++ " + e + " " + e.lineNumber + " "  + e.fileName);
				       }
				   };

				   // WARNING: DEMO/DEBUG only;
				   JV3.fc = recommend_engine;
			       } catch(e2) {
				   JV3.log("++++++++++++++++++++" + e2 + "  " + e2.lineNumber);
			       }
			   }

			   /* user activity timer */
			   (function () {
				// watch notifications of user idleness/activity to decide how to handle them		
				var our_id = JV3.getWindowId(window);
				var active_in_this_window_since = undefined; 		
				var user_active = function() {
				    try {
					jsidebar.getView().logger.user_active();
					var now = new Date().valueOf();
					if (active_in_this_window_since == undefined) { active_in_this_window_since = new Date().valueOf(); } 										
				    } catch (x) {  }
				};
				var user_inactive = function() {
				    try {
					jsidebar.getView().logger.user_inactive();
					if (active_in_this_window_since !== undefined) {
					    var now = new Date().valueOf();
					    if (active_in_this_window_since !== undefined) {
						JV3.logAction("user-active-near-open-listit", undefined, undefined,
							      undefined, ({start:self.active_in_this_window_since,
									   end:now,
									   window_id:our_id,
									   window_id:JV3.getWindowId(window) }));
						active_in_this_window_since = undefined;
					    }
					    
					}
				    } catch (x) { }
				};		
				(function(wid) {
				     ["window-idle","window-awake"]
					 .map(function(x) {
						  try {
						      //JV3.log("adding observer for " + x);
						      var obs = ({
								     observe:function(source,topic,data) {
									 if (data == wid) {
									     if (x == "window-idle") { 
										 user_inactive();
									     } else {
										 user_active();
									     }
									 } 
								     }
								 });
						      JV3._getObserverService().addObserver(obs, x, false);
						      window.addEventListener("pagehide",function(event) {
										  try {
										      if (event.target.location == "chrome://listit/content/listit/listit.xul") {
											  user_inactive();		   
											  JV3._getObserverService().removeObserver(obs,x,false);							 
										      }
										      window.removeEventListener("pagehide",arguments.callee,false);								      
										  } catch (x) {
										      JV3.log(x);
										  }
									      },false);//
						  } catch (x) {   JV3.log(x);	  }});	    
				 })(our_id);
				// open so active!
				user_active();
			    })();
		       },100);
	} catch(eee) { JV3.log(eee); }
};
