
viewController = {
    query: "", // holds the current active search query
    query_filters : {},
    active_filters : {},
    orderer: undefined,
    initialize:function(JV3) {
	this.log = JV3.log;
	this.JV3 = JV3;
	this.setOrderer(JV3.NoteOrderers.byExplicitOrdering);	
	this.update();
    },
    insertNote:function(n,fromTop,matches) {
	try {
	    var this_ = this;
	    this.JV3.ensureHasOrder(n); // ensure this guy has an ordering.
	    if (matches)  {
		this._insertNoteHelper(n,fromTop,matches); 
	    } else {
		this.getMatches(function(matches) {
				    this_._insertNoteHelper(n,fromTop,matches); 
				});
	    }
		
	} catch(e) {
	    this.JV3.log("insertNote error: " + e + " " + e.fileName + " " + e.lineNumber);
	}
    },
    _insertNoteHelper:function(note, animate, matches) {
	animate = animate && note.text.length > 0;
	// insertnote helper helper
	var this_ = this;
	var entries = document.getElementById('entries');
	var entry = document.createElement('li');
	entry.setAttribute("class", "entry");
	entry.setAttribute("id", note.id);
	entry.appendChild(display.create(note));
        entry.addEventListener('click', function() { return edit.click.apply(edit,arguments); }, false);
	var insert_point = matches.indexOf(note);

	if (insert_point < 0) {
	    // as of 0.4.0, we make all new notes comply with active
	    // filters, so insert_point < 0 means that it's been added
	    // from a different instance (e.g, browser window)
	    // than ours, and we've got a filter that is different
	    // from that one. safe to drop!
	    return;
	    // previously we just appended it on the top
	    // insert_point = 0;
	}
	
	// now our note "belongs", find the right insert_point
	var before = entries.childNodes.item(insert_point);
	var cont_cb = function() {  viewController.noteInserted(note,entry);  };
	
	if (before){
	    if (animate) { $j(entry).hide(); }
	    entries.insertBefore(entry, before);
	    if (animate) { $j(entry).show("slow",cont_cb); } else { cont_cb(); }
	} else   {
	    if (animate) { $j(entry).hide(); }
	    entries.appendChild(entry);
	    if (animate) { $j(entry).show("slow",cont_cb); } else { cont_cb(); }
	}
    },

    _ni_listeners : [],
    noteInserted:function(note,entry) {
	viewController._ni_listeners.map(function(l) { try{ l(note,entry,viewController,viewController._ni_listeners); } catch (x) { JV3.log(x); } });
    },
    getMatches:function(cb) {
	if (cb === undefined) { throw new Error("NO CB on getMatches"); }
	this.JV3.getMatches(viewController,cb);
    },
    update: function(callback) {
	try {
	    var this_ = this;
	    this_.closeAndSaveAll();
	    this.getMatches(
		function(matches) {
		    try {
			// var D1 = new Date();
			this_._updateView(matches);
			// JV3.log(" update View ", (new Date()).valueOf() - D1.valueOf());
			this_.applySortability();
			// JV3.log(" apply sortability at ", (new Date()).valueOf() - D1.valueOf());
			logger.check();
			// JV3.log(" logger at ", (new Date()).valueOf() - D1.valueOf());
			if (callback !== undefined) {
			    // JV3.log(" calling back at ", (new Date()).valueOf() - D1.valueOf());
			    callback(matches);
			} else {
			    // JV3.log(" done at ", (new Date()).valueOf() - D1.valueOf());
			}
		    } catch(ee) {
			this_.log(ee);
		    }
		});
	} catch(e) {
	    this.log(e + " " + e.lineNumber + " " + e.fileName);
	}
    },
    getEntryFor:function(note) {
	var entries = document.getElementById("entries");
	var entryArray = entries.childNodes;	
	for (var j=0; j<entryArray.length; j++)  {
	    if (entryArray[j] && entryArray[j].getAttribute("id") == note.id) {
		return entryArray[j];
	    }
	}
    },
    addClassToEntries: function(classname,from,to) {
	try{ 
	    var entries = document.getElementById("entries");
	    var entryArray = entries.childNodes;
	    if (from === undefined) { from = 0; }
	    if (to === undefined) { to = entryArray.length; }
	    for (var i=Math.min(from,entryArray.length); i<Math.min(to,entryArray.length); i++)  {
		var attrs = entryArray[i].getAttribute("class");
		var attributes = attrs ? attrs.split(" ") : [];
		attributes = [classname].concat(attributes); // prepend
		entryArray[i].setAttribute("class",attributes.join(" "));
	    }
	} catch(e) {
	    this.log(e + " " + e.lineNumber + " " + e.fileName);
	}
    },
    removeClassFromEntries:function(classname,from,to) {
	var JV3 = this.JV3;
	JV3.log("removeClassFromEntries " + classname);
	try{
	    var entries = document.getElementById("entries");
	    var entryArray = entries.childNodes;
	    if (from === undefined) { from = 0; }
	    if (to === undefined) { to = entryArray.length; }
	    for (var i=Math.min(from,entryArray.length);i<Math.min(to,entryArray.length); i++)  {
		var attrs = entryArray[i].getAttribute("class");
		if (attrs) {
		    var attributes = attrs.split(" ");
		    JV3.plumutil.removeElement(attributes,classname);
		    entryArray[i].setAttribute("class",attributes.join(" "));
		}
	    }
	} catch(e) {
	    JV3.log(e + " " + e.lineNumber + " " + e.fileName);
	}
    },
    isEditing : function() {
	// returns true if the editor is active
	var entries = document.getElementById("entries");
	var entryArray = entries.childNodes;	
	for (var j=0; j<entryArray.length; j++)  {
	    if (entryArray[j].getAttribute("class").indexOf("editing") >= 0) {
		return true;
	    }
	}
	return false;
    },

    _updateView : function(matches) {
	/* Walks through current list of entries, replacing old ones with
           the new ones in place. If it runs out of new entries before
           it runs out of old entries, it deletes the rest of the old
           entries. If it runs out of old entries first, it creates new
           entries and tacks them onto the bottom.
        */

	var entries = document.getElementById("entries");
	var entryArray = entries.childNodes;
	
	for (var j=matches.length; j<entryArray.length; )  {
	    entries.removeChild(entryArray[matches.length]);
	}
	
	// Walk through old entries.
	for (var i=0; i<entryArray.length; i++) {
	    var entry = entryArray[i];
	    if (entry.getAttribute("id") != matches[i].id) {
		entry.setAttribute("id",matches[i].id);
		entry.innerHTML = "";
		entry.appendChild(display.create(matches[i]));
	    }	    
	    $j(entry).css({height:""});
	}

	viewController.speedAppendNotes(matches.slice(entryArray.length));
	
	// for (var k=entryArray.length; k< matches.length;  k++) {
	//     viewController.insertNote(matches[k], false, matches);
	// }
    },

    speedAppendNotes:function(matches) {
	var entries = document.getElementById('entries');
	var make_note_html = function(note) { return '<li class="entry" id="'+note.id+'" onclick="edit.click(event);"><div class="note-display"><div class="handle-span"></div><div class="close-button" onclick="display.close(event)"></div><div class="note-display-list"><div class="note-display-text">'+JV3.util.defang(note.text !== null && note.text !== undefined ? note.text : '')+'</div></div></li>'; };
	$j(entries).append(matches.map(make_note_html).join(""));
    },

    updateNote: function(note) {
	// edit the contents of a note without animation by id
        var entry = findEntry(note);
	if (entry && entry.getAttribute("class").indexOf("editing") >= 0) {
	    // emax's terrible hack for enabling client-side merging
	    var new_text = note.text;
	    closeAndSave(entry,false);
	    note.text = note.text + " " + new_text; // merge!
	    note.modified = true;
	    note.edited = new Date().valueOf();
	    this.updateNote(note);
	    // entry being edited
	} else if (entry) {
	    display.update_entry_text(entry,note);
	    /*
	    var new_entry = display.create(note);
            entry.replaceChild(new_entry,entry.childNodes[0]);
            // entry.setAttribute('id',note.id);
	    entry.setAttribute("class", "entry");
	    $j(entry).css({height:""});
	     */
        }
    },
    removeNote: function(note) {
	// remove note without animation and only with note id
        var entry = findEntry(note);
        if (entry) {  entry.parentNode.removeChild(entry);       }
    },    
    closeAndSaveAll: function() {
	var entries = document.getElementById('entries');
	for (var i = 0; i<entries.childNodes.length; i++) {
	    closeAndSave(entries.childNodes[i], false);
	}
    },


    /* ------------------ orderers and orderings */
    setOrderer:function(orderer) { this.orderer = orderer;},
    getOrderer:function() { return this.orderer;  },
    getIndexOf : function(notes,n) {
	return this.getOrderer()(notes).indexOf(n);
    },
    disapplySortability:function() { jQuery("#entries").sortable("disable"); },
    applySortability : function() {
	let this_ = this;
	//this.disapplySortability();
	//jQuery("#entries").removeClass("ui-sortable-disabled");
	//jQuery("#entries").removeClass("ui-state-disabled");
	if (this.getOrderer() !== this.JV3.NoteOrderers.byExplicitOrdering) {  return ;	}
	//this_.JV3.log("Apply sortability");

	jQuery("#entries").sortable( {
	    axis:'y',
	    handle:".handle-span",
	    forceHelperSize:true,
					 stop:function(evt,ui) {
					     evt.stopPropagation();  
					 },
	    deactivate:function(evt, ui) {
		try {
		    evt.stopPropagation();
		    this_.JV3._dragged_ = {
			item:ui.item[0],
			time:new Date().valueOf()
		    };
		    var dragged_note_id = parseInt(ui.item[0].getAttribute("id"));
		    this_.JV3.plumutil.assert(dragged_note_id !== undefined, "Drag note error -- undefined id");
		    var ordering = this_.JV3.getExplicitOrdering();
		    this_.JV3.plumutil.assert(ordering !== undefined, "Ordering null");		    
		    var new_index_of_note = jQuery("#entries").sortable("toArray").map(function(x) parseInt(x)).indexOf(dragged_note_id);
		    var new_ordering = undefined;
		    if (new_index_of_note == 0) {
			// our note is first
			// this_.JV3.log("Our note is first ");
			new_ordering = [dragged_note_id].concat( this_.JV3.plumutil.elementRemoved(ordering,dragged_note_id) );
			this_.JV3.saveExplicitOrdering(new_ordering);
		    } else {			
			// find where to put it -- 
			// find id of entry immediately previous to it
			// insert it right afterwards			
			
			var id_of_previous_note = parseInt(jQuery("#entries li")[new_index_of_note - 1].getAttribute("id"));			
			this_.JV3.plumutil.assert(id_of_previous_note !== undefined, "ID of previous note undefined");

			var removed_ordering = this_.JV3.plumutil.elementRemoved(ordering,dragged_note_id);
			this_.JV3.plumutil.assert( removed_ordering.indexOf(id_of_previous_note) >= 0, "index of previous note from id < 0" );

			removed_ordering.splice( removed_ordering.indexOf(id_of_previous_note) + 1, 0, dragged_note_id );
			new_ordering = removed_ordering;
			this_.JV3.saveExplicitOrdering(new_ordering);			
		    }
		    this_.JV3.informObservers("notes-reordered", this_.JV3.plumutil.toJSON(new_ordering));
		    // setTimeout(function() { applySortability(); }, 500);
		} catch(e) {
		    this_.JV3.ERROR = e;
		    this_.JV3.log("deactivate error: " + e);
		    this_.JV3.log(e);
		}
	    }
	});
    },
    getPrintInfo : function(cb) {
        viewController.getMatches(function(matches) {
				      ids = [];
				      for (var i=0; i<matches.length; i++)  {
					  ids.push(matches[i].id);
				      }
				      cb({
					     query : viewController.query,
					     ids : ids
					 });
				  });
	
        
    },
    getCollapsedHeight:function() {
	if (this._collapsedHeight === undefined){
	    var min = undefined;
	    jQuery(".entry").map(function() {
				     try {
					 min = min === undefined ? jQuery(this).height() : Math.min(min,jQuery(this).height());				     
					 
				     } catch (x) {
					 JV3.log(x);
				     }

				 });
	    this._collapsedHeight = (min === undefined ? 15 : min);   
	}	
	return this._collapsedHeight; // JV3.prefs.getIntPref("collapsed.height");
    },
    isNoteDisplayCollapsed:function(notedisplay) {
	return notedisplay.getAttribute("precollapsedHeight") !== null;
    },
    toggleCollapsed:function() {
	this.closeAndSaveAll();		
	this.collapsed = !this.collapsed;
	var this_ = this;	
	try {

	    if (this.collapsed) {
		var bh = this.getCollapsedHeight();
		JV3.log("collapseheight ", bh);
		jQuery(".note-display").map(function() { this.setAttribute("precollapsedHeight",jQuery(this).height());    });
		jQuery(".note-display").animate({height:bh});	    
	    } else {		
		jQuery(".note-display").map(function(i) {
						try {
						    var jdisp = jQuery(this);
						    var id = this.parentNode.getAttribute("id");						    
						    var height = parseInt(this.getAttribute("precollapsedHeight"));
						    if (!isNaN(height)) {
							this.removeAttribute("precollapsedHeight");
							jdisp.animate( { height: height },
							    {
								complete:   function() { jdisp.css("height","");  }
							    }
							);						 														
						    } else {
							jdisp.css("height",""); 
						    }

						    
						} catch (x) {
						    JV3.log(x);
						}						 
					    });
	    }
	} catch (XX) {
	    JV3.log(XX);
	}
	return this.collapsed;	
	
    }
};

