

viewController.query = "";
viewController.query_filters = {};
viewController.active_filters = {};

setQuery = function(s) {
    try {
	viewController.query = s;
	viewController.query_filters = viewController._compileQuerytoFilters(s);	
    } catch(e) { this.JV3.log("ERROR in setQuery" + e + " " + e.lineNumber + " " + e.fileName); }
};

getQuery = function() {   return viewController.query;  };

function get_active_queries_and_filters() {
    var query = getQuery();
    var q = query && query.length > 0 ? query : "";
    var active_filters = viewController ? viewController.getActiveFilters() : {};
    return JV3.plumutil.objKeys(active_filters).concat(q);
}


/* filter stuff ======================================== */    
viewController.getActiveFilters = function() {
    if (this.JV3.plumutil.objVals(this.active_filters).length >= 0) {
	return this.active_filters;
    }
    return undefined;
};


viewController.addTextMatchFilter = function(s) {
    this.active_filters[s] = filterFactory.makeTextRequiredFilterCI(s);
};

viewController.removeTextMatchFilter = function(s) {
    delete this.active_filters[s];
};

viewController.evaluateFilters = function(note) {
    var JV3 = this.JV3;
    var ntext = note.text;
    return JV3.plumutil.accumulate_and(
	JV3.plumutil.objVals(this.active_filters).concat(JV3.plumutil.objVals(this.query_filters)),
	function(fn) { return fn.test(ntext); }
    );
};

viewController._compileQuerytoFilters = function(query) {	
    // first extract quoted things
    var str_trim = function(stringToTrim) {
	if (stringToTrim === null || stringToTrim === undefined) { return stringToTrim; }
	return stringToTrim.replace(/^\s+|\s+$/g,"");
    };

    var query_filters = {};
    var quoted_regions = new RegExp('[\+\-]?\"([^\"]+)\"',"g");
    var excluders = [];
    var includers = [];
    
    var leftovers = "";
    var lastIndex = 0;

    if (query === undefined) { return {}; }
    
    var qhit = quoted_regions.exec(query);	
    
    while ( qhit !== null ) {
	var start_idx = quoted_regions.lastIndex - qhit[0].length;
	if (qhit[0][0] == '-') {  excluders.push(qhit[1]); }
	else {
	    includers.push(qhit[1]);
	}
	leftovers += query.substring(lastIndex,start_idx);
	lastIndex = quoted_regions.lastIndex;
    	qhit = quoted_regions.exec(query);		
    }
    leftovers += query.substring(lastIndex);
    leftovers = str_trim(leftovers);
    // now tokenize the rest by space
    leftovers.split(' ').map(function(token) {
	token = str_trim(token);
	if (token.length == 0) return;
	if (token[0] == '+') {  includers.push(str_trim(token.substring(1)));return;} 
	if (token[0] == '-') {  excluders.push(str_trim(token.substring(1)));return;}	
	includers.push(str_trim(token));
    });
    includers.map(function(x) {
	query_filters[x] = filterFactory.makeTextRequiredFilterCI(x);
    });
    excluders.map(function(x) {
	query_filters[x] = filterFactory.makeTextExclusionFilterCI(x);
    });
    return query_filters;
};


/* ====== filter stuff ============ */
filterFactory = {
    makeTextRequiredFilterCI: function(s) {
	s = s.toLowerCase();
	return {
	    test: function(m) {   return m.toLowerCase().indexOf(s) >= 0; },
	    makeStringComply: function(test_s) { if (!this.test(test_s)) return "("+s+") " + test_s; }
	};
    },
    makeTextExclusionFilterCI: function(s) {
	s = s.toLowerCase();
	return {
	    test: function(m) {   return m.toLowerCase().indexOf(s) < 0; },
	    makeStringComply: function(test_s) { return test_s; } /* not used */
	};
    }
    /* add other types of filters too */
};

