
// uses protocrock pattern

// hang on to a reference!

var PlumStore =  {
    DEBUG: true,
    ASKFORPERMISSION:false,
    PlumStoreTypeNames: PlumStoreTypeNames,
    PlumStoreTypeHandler: PlumStoreTypeHandler,
    plumutil:plumutil,
    newify : PROTOCROCK.newify,
    logger:function(x) { log(x);},
    log: function(x) { if (this.DEBUG) { this.logger(x);} },
    initialize: function (params) {
	this.filename = params.filename;
	if (params.ask !== undefined) { this.ASKFORPERMISSION = params.ask; }
	if (params.log !== undefined) { this.logger = params.log; }
	this.DEBUG = params.debug || params.DEBUG;	   	    
	if (!this.filename) { this.filename = "plum.store.sqlite";  }
	var file = Components.classes["@mozilla.org/file/directory_service;1"].
	getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
	file.append(this.filename);	
	var storageService = Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);	
	this._db = storageService.openDatabase(file);
	this.plumutil = plumutil;
	this.log('done initialize. this._db is ' + this._db);
    },
    count: function(table) {
	var results = this.getIntResults('SELECT count(*) FROM ' + table + ';');
	if (results.length > 0) { return results[0]; }
    },
    createTable: function(tname, schema) {
	this.execute("CREATE TABLE " + tname + " " + schema + ";");
    },
    getTables: function() {
	return this.getStringResults("SELECT name FROM sqlite_master WHERE type=\'table\' ORDER BY name;");
    },
    execute: function(stmt_str) {
	this.log(stmt_str);
	return this._db.executeSimpleSQL(stmt_str);
    },
    dumpResult: function(query,n_cols) {
	var out = "";
	var results = this._getResults(query,this.getStringResults,this.plumutil.intRange(0,n_cols));
	results.map(function(row) {
	    if (this.plumutil.isArrayLike(row))  {
		row.map(function(x) { out += "" + x + " " ; });
		out += "\n";
	    } else {
		out += ""+ row + "\n";
	    }	    
	});
	return out;
    },
    _getResults: function(stmt_str,stmt_fn,cols) {
	if (cols === undefined) cols = [0];
	var db = this._db;
	this.log(stmt_str);
	var statement = db.createStatement(stmt_str);
	var results = [];	
	try {            
	    while(statement.executeStep()) {
		if (cols.length == 1) {
		    results.push(stmt_fn(statement,cols[0]));
		} else {
		    var row = [];
		    for (var  ci = 0; ci < cols.length; ci++) {
			row.push(stmt_fn(statement,cols[ci]));
		    }
		    results.push(row);
		}		
	    }
	} catch (e) {
	    this.log("getIntResults() error in statement " + statement + " " + e); //alert(e);
	} finally {
	    statement.reset();
	}
	return results;
    },
    getDoubleResults: function(stmt_str) {
	return this._getResults(stmt_str,function(x,i) { return x.getDouble(i); });
    },
    getIntResults: function(stmt_str) {
	return this._getResults(stmt_str,function(x,i) { return x.getInt64(i); });
    },
    getStringResults: function(stmt_str) {
	return this._getResults(stmt_str,function(x,i) { return x.getUTF8String(i); });
    },
    close:function() {
	this._db.close();
	this._db = undefined;
    },
    // 
    getIntResultsAsync: function(stmt_str,callback) {
	var statement = this._db.createStatement(stmt_str);
	var results = [];
	var this_ = this;
	if (statement.executeAsync === undefined) {
	    this_.log("resorting to synchronous execute");
	    // FF 3.0
	    try { statement.reset(); } catch(e) { }
	    return callback(this.getIntResults(stmt_str));
	}
	this_.log("async execute");	
	return statement.executeAsync({
					  handleResult:function(resultSet) {
					      try {
						  for (let row = resultSet.getNextRow(); row; row = resultSet.getNextRow()) {
						      results.push(row.getResultByIndex(0));
						  }
					      } catch (x) { this_.log(x); }
					  },
					  handleError:function(err) {
					      this_.log(err);
					      if (callback !== undefined) {callback({error:err});}		    
					  },
					  handleCompletion:function(aReason) {
					      if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED) {
						  return callback({error:"query canceled or aborted"});				
					      }
					      if (callback !== undefined) {  callback(results);	      };
					      try {  statement.reset();   } catch (x) {  this_.log(x);     }
					      return undefined;
					  }
				      });				   
    }				     
};

