
// Copyright (c) 2009 Massachusetts Institute of Technology

// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:

// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.

// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//

Components.utils["import"]("resource://gre/modules/XPCOMUtils.jsm");
var nsISupports = Components.interfaces.nsISupports;

// You can change these if you like
var CLASS_ID = Components.ID("67f0196b-0495-45f6-b250-d072c551d602");
var CLASS_NAME = "listit";
var CONTRACT_ID = "@electronic.max/listit;1";

// This is your constructor.
// You can do stuff here.
function Listit() {
    // you can cheat and use this
    // while testing without
    // writing your own interface
    this.wrappedJSObject = this;
    this.startup();
}

// This is the implementation of your component.
Listit.prototype = {
    className:CLASS_NAME,
    classID : CLASS_ID,
    contractID: CONTRACT_ID,
    classDescription:"list-it core component",
    
   // QueryInterface implementation, e.g. using the generateQI helper  
    QueryInterface: XPCOMUtils.generateQI([Components.interfaces.nsISupports]),
    
	/*
	[Components.interfaces.nsIObserver,  
	 Components.interfaces.nsIMyInterface,  
	 "nsIFoo",  
       "nsIBar" ]),
    */
    
    /*QueryInterface: function(aIID)
    {
	// add any other interfaces you support here
	if (!aIID.equals(nsISupports))
            throw Components.results.NS_ERROR_NO_INTERFACE;
	return this;
    },*/
    
    DEBUG:true,
    log: function() {
	var aConsole = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("listit.");
	pref.QueryInterface(Components.interfaces.nsIPrefBranch);
	var arg2arr = function(v) {
	    var tmp = [];
	    for (var i = 0; i < v.length; i++) { 
		tmp.push(v[i]);
	    }
	    return tmp;
	};	
	return function() {
	    var this_ = this;	    
	    if (!pref.getBoolPref("debug")) { return; }
	    var buf = arg2arr(arguments).map(function(x) {
						 if (x !== null && typeof(x) == 'object' && (x.fileName || x.lineNumber || x.message || x.stack)) {
						     this._LASTERROR_ = x;
						     return "error " + x.fileName + ":" + x.lineNumber + ":: " + x.message + " " + x.stack;
						 } else if (typeof(x) == 'object') {
						     try { return this_.plumutil.printObj(x); } catch (x) { return "error printing object : " + this_.plumutil.printObj(this_.plumutil.objKeys(obj)); }
						 }  else {  return x;  }
					     }).join(" ");	    
	    dump(buf + "\n");
	    aConsole.logStringMessage(buf+"\n");
	};
    }(),
    autoCommitCb: null,
    syncTimeoutMsec:15*60*1000, // 15 mins
    errors : [],
    prefs: null,
    accelKey: "",

    /* synchronization-related ---------------------------------------------------------------------- */
    setUser : function(username, password) {
	this.prefs.setBoolPref("sync.support",true);
        // nsILoginManager is the Gecko 1.9 version of nsIPasswordManager
        var myLoginManager = Components.classes["@mozilla.org/login-manager;1"]
        .getService(Components.interfaces.nsILoginManager);
        // make our new LoginInfo
        var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1",
            Components.interfaces.nsILoginInfo,
            "init");
        // Note that I use "chrome://listit" and "list.it sync" to find the login later, so this can't change
        var loginInfo = new nsLoginInfo("chrome://listit", null, "list.it sync", username, password, "", "");
        // Gets all listit entries (should only be 1)
        var logins = myLoginManager.findLogins({}, "chrome://listit", null, "list.it sync");

        if (logins.length === 0) {
            // adds if first one
            myLoginManager.addLogin(loginInfo);
        } else {
            // modifies if it existed before
            myLoginManager.modifyLogin(logins[0],loginInfo);
        }
    },
    getUser : function() {
        // Get Login Manager
        var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
        // There should only be one result
	try {
	    var loginInfo = myLoginManager.findLogins({}, "chrome://listit", null, "list.it sync")[0];
            if (loginInfo !== undefined) {
		return loginInfo;
	    }
	} catch (x) {   this.log(x);	}
	// fall back to old method; this should never be necessary.
	// try {  return { username: this.prefs.getCharPref('sync.username'), password: this.prefs.getCharPref('sync.password') };	   } catch (x) {  this.log(x); }
	return {  };
    },    
    login: function(success_cb,error_cb) {
	try {
	    var this_ = this;
	    var error = "";
	    if (this.isSyncEnabled()) {
		var username = this.getUser().username;
		var password = this.getUser().password;
		var server   = this.prefs.getCharPref('sync.server');
		if (!username) {  username=""; error = "No username provided";  }
		if (!password) {  password=""; error = "No password provided";  }	
		if (!server)   {  server = "https://listit.nrcc.noklab.com/listit"; }
		var ownerId = 1;
		if (username !== undefined && username.length > 0 & password !== undefined && password.length > 0 && server !== undefined) {
		    var sync = this.newify(this.Synchronize,server,ownerId,null,this.store,this.actlog,username,password);
		    sync.log = this_.log;
		    sync.login(function(data) {
				   try {
				       this_._getObserverService().notifyObservers(null, "login-success", undefined);			   
				       this_.sync = sync;
				       if (data.couhes.study1 === undefined || data.couhes.study2 === undefined) {
					   return;
				       }
				       this_.setScienceMode(data.couhes.study1, data.couhes.study2);
				       if (success_cb) { success_cb(); }
				   } catch (X) {
				       this_.log(X);
				   }
			       }, function(data) {
				   this_._getObserverService().notifyObservers(null, "login-fail", undefined);			   
				   this_.sync = undefined;
				   // we failed, we should alert someone
				   if (error_cb) { error_cb.apply(this_, arguments); }
			       });
		    return;
		}
	    }
	    this.sync = undefined;
	    if (error_cb) {
		error_cb(undefined, -1, error || "sync disabled");
	    }
	} catch (x) { this.log(x); error_cb(undefined, -1, "sync error: " + x); }
    },    
    setScienceMode:function(study_1,study_2){
	// enables logging features for user study participants
	this.log("SETTING SCIENCE MODE: " + study_2);

	this.prefs.setBoolPref("sync.contextLog",study_2);
	//this.prefs.setBoolPref("context.wifi",study_2);
	//this.prefs.setBoolPref("context.watchme",study_2);

	// now unload/reload appropriately
	if (study_2 !== undefined && this.prefs.getBoolPref('context.watchme') && this.ContextMaiden.WatchMeContextProvider === undefined) {
	    this.load_watchme();
	} 
	if (study_2 && this.ContextMaiden.WiFiLocation === undefined && this.prefs.getBoolPref('context.wifi') ) {
	    this.load_wifi();
	}	
    },    
    is_wifi_logging_enabled:function() { return this.prefs.getBoolPref("context.wifi"); },
    is_watchme_logging_enabled:function() { return this.prefs.getBoolPref("context.watchme"); },
    evaluate_page:function() {return true;  },    
    getScienceMode:function() {	 return this.prefs.getBoolPref("sync.contextLog");  }, //  && this.prefs.getBoolPref("context.watchme");   
    salt_hash:function(str, max_digits) {
	 if (str === undefined) { return undefined; }
	 if (max_digits === undefined) {
	     max_digits = 10;
	 }
	 return this.plumutil.crypto_hash(str+this.getPrivateSalt()).slice(0,max_digits);
    },    
    _genClientId: function() { return this.plumutil.guid() + "__" + new Date().valueOf(); },
    getClientId: function() {
	// returns a unique identifier corresponding to this browser_system_install
	var id = this.prefs.getCharPref("client_id");
	if (id.length == 0) {
	    id = this._genClientId();
	    this.prefs.setCharPref("client_id", id);
	}
	return id;
    },
    getClientVersion: function() {
	// returns a unique identifier corresponding to this browser_system_install
	if (this.__lastversion !== undefined) {
	    return this.__lastversion;
	}
	this.__lastversion = this.prefs.getCharPref("lastversion");
	return this.__lastversion;
    },
    getPrivateSalt:function() {
	// a salt is a magic string that we use to ensure with hash()
	if (this.__salt__) { return this.__salt__; }
	var salt = this.prefs.getCharPref("crypto.salt_id");
	if (salt === undefined || salt == '') {
	    salt = this.plumutil.guid();
	    this.prefs.setCharPref("crypto.salt_id",salt);
	}
	this.__salt__ = salt;
	return salt;	
    },    
    shouldAutoCommit: function() {
	var doSync = this.isSyncEnabled();
	var doAutoSync = this.prefs.getBoolPref("sync.autosync");
	var asFreq = parseInt(this.prefs.getCharPref("sync.frequency"));
	var lastSync = parseInt(this.prefs.getCharPref("sync.lastsynced"));
	return doSync && doAutoSync && (new Date()).valueOf() - lastSync > asFreq;
    },
    _update_last_synced:function(when) {
	if (when === undefined)	 {
	    when = new Date().valueOf()
	}
	this.prefs.setCharPref("sync.lastsynced",""+when);
    },
     isSyncEnabled: function() { return this.prefs.getBoolPref("sync.support"); },
     setupAutoCommitCb:function() {
	 var this_ = this;
	 var clear_alarm = function(){
	     if (this_.autoCommitCb !== undefined) {
		 this_.clearInterval(this_.autoCommitCb);
	     }
	     this_.autoCommitCb = undefined;
	 };
	 clear_alarm();
	 var doAutoSync = this_.prefs.getBoolPref("sync.autosync");
	 var asFreq = parseInt(this_.prefs.getCharPref("sync.frequency"));
	 if (doAutoSync && asFreq > 0)  {
	     var alarm_fn = function() {
		 if (this_.shouldAutoCommit()) {  this_.sync_now(); }
	     };
	     this_.autoCommitCb = this.setInterval(alarm_fn,asFreq);
	 }
     },
     sync_now:function(success_cb, error_cb) {
	 var this_ = this;
	 try {
	     if (this.sync === undefined ) {
		 this.log("sync is undefined, calling login");
		 this.login(function() {
				 /* recurse */
				// this_.log("login win " + this_.sync);
				this_.sync_now(success_cb,error_cb);
			     }, function() {
				 try {
				     // this_.log("sync_now error cb");
				     var req = arguments[0];
				     var status = arguments[1];
				     var text = arguments[2];				
				     this_.informObservers("sync-error", "Login error - (" + status + ") - " + text);				     
				 } catch (x) {
				     this_.log(x);
				 }
				 if (error_cb) { error_cb.apply(this_, arguments); }
			     });
		 return;
	     }

	     this.informObservers("sync-start");
	     this_._syncCommitCombined(		 
		 function(remotely_updated_notes) {
		     
		     // we dont really need syncCommits: this_.logAction('syncCommit',undefined,"success");
		     this.log("synccommitcombined--success")
		     
		     // note down so that shouldAutoCommit will know
		     this_._update_last_synced();
		     this_.informObservers("sync-success", "sync success");

		     if (success_cb !== undefined) {
			 success_cb.apply(this_,arguments);
		     }
		 }, function(error_message, code) {
		     this_.log("ERRORCB message: " + error_message + " code : " + code);
		     try {
			 this_.log("sync failure: " + error_message);
			 //this_.logAction('syncCommit',undefined,"fail",error_message);
			 this_.informObservers("sync-error", "sync error -" + error_message);
			 this_.sync = undefined; // so that we try to reconnect next time
			 if (error_cb !== undefined) {   error_cb.apply(this_,[error_message]);	}
		     } catch(e) {
			 this_.log(e);
		     }
		 });
	 } catch(e2) {
	     this_.log("sync fail~~ " + e2 + " " + e2.lineNumber + " " + e2.fileName);
	 }
     },
     _syncCommitCombined: function(success_cb,error_cb) {
	 var this_ = this;
	 this.sync.commitAll(function() {
				 if (success_cb) { success_cb.apply(this_,arguments); }
				 if (this_._is_mid_actlog_syncing || this_._is_mid_eventlog_syncing) {
				     this_.log("still actlogsyncing let's chill out on the logs.");
				     return;
				 }				
				 // engage other syncs
				 this_.setTimeout(function() {
						      try {
							  if (this_.prefs.getBoolPref("sync.activityLog") && !this_._is_mid_actlog_syncing) {
							      // commit combined main and act log
							      this_._is_mid_actlog_syncing = true;
							      this_.sync.commitActivityLog(function(x) {
											       // this_.log("actlog successcb");
											       this_._is_mid_actlog_syncing = undefined;
											       // this_.log("actlogs " + x.length + " at " + new Date().valueOf());
											   }, function(message,code) {
											       this_.log("actlog errorcb");
											       this_._is_mid_actlog_syncing = undefined;
											       //this_.log("ACTLOG errorcb: " + message + " :: " + code);
											   });
							  }
							  if (this_.prefs.getBoolPref("sync.contextLog") && !this_._is_mid_eventlog_syncing) {
							      // this_.log("calling commitEventLog ------------>");
							      this_._is_mid_eventlog_syncing = true;
							      this_.sync.sync_events(function(x) {
											    // this_.log("eventlog successcb");
											    delete this_._is_mid_eventlog_syncing;
											    // this_.log("event log committed : " + x.length);
											},
											function(message,code) {
											    this_.log("eventlog errorcb");
											    this_.log(message);
											    delete this_._is_mid_eventlog_syncing;
											    //this_.log("ACTLOG errorcb: " + message + " :: " + code);
											});
							  } else {
							      this_.log("is mid eventlog syncing ::  " + this_.prefs.getBoolPref("sync.contextLog") + " " + this_._is_mid_eventlog_syncing);
							  }
						      } catch(e) {
							  this_.log(e);
						      }
						  }, 1000);
	 },  error_cb);
     },    
    
     /* note model --------------------------------------------------------------------------- */

    mandatory_fields_note : ["id", "text", "edited", "created", "version", "modified", "deleted"],
    getNoteById: function(id) {
	return this.notes[id];
    },
     makeNote:function(contents,id) {
	 var this_ = this;
	 return {
	     id:id ? id : this.util.generateID(this_.notes),
	     text:contents,
	     created: new Date().valueOf(),
	     edited: new Date().valueOf(),
	     version: 0,
	     modified: true,
	     deleted:false
	 };
     },
     addNote: function(contents,active_queries,metadata,id) {	
	 // experimental! ------------------------------------------------------------------->
	 // this mojo was introduced in 0.4.0 to make sure that if someone creates
	 // a new note from a user interface that has filtering on, the new note text
	 // inherits the text of the filter

	 var this_ = this;
	 var d0 = new Date().valueOf();	 	 
	 if (active_queries) {
	     var joined = active_queries.filter(function(x) {
						    return contents.indexOf(x) < 0 && x.length >= 0;
						}).map(function(x){ return this_.plumutil.trim(x);  }).join(" ");
	     if (joined.length > 0) {
		 contents = "(" + joined  + ") " + contents;
	     }
	 }
         // <--------------------------------------------------------------------------------
	 var note = this.makeNote(contents,id);
	 this.notes[note.id] = note;
	 this.store.save(note);
	 // var dsave = new Date().valueOf();
	 this.logAction("note-add", note.id, contents, undefined, metadata);
	 // var dlogaction = new Date().valueOf();	 
	 this.ensureHasOrder(note);
	 // var desorder = new Date().valueOf();
	 var this_ = this; 
	 this.setTimeout(function() { this_.informObservers("add-note", note.id); }, 1 );	 
	 // var dinform = new Date().valueOf();	 
	 // this.log("timings : save: " + (dsave-d0) + " dla " + (dlogaction - dsave) + " order " + (desorder-dlogaction) + " dinform " + (dinform-desorder));
	 return note;
     },
     /* used by sync */    
     remoteAddNote:function(note) {
	 this.notes[note.id] = note;
	 this.store.save(note);
	 this.informObservers("remote-add-note", note.id);
     },
     remoteUpdate:function(note) {
	 this.notes[note.id] = note;
	 this.store.save(note);
	 this.informObservers("save-note", note.id);
     },
     remoteDelete:function(note) {
	 this.notes[note.id] = note;
	 this.store.save(note);
	 this.informObservers("delete-note", note.id);
     },
     /* end of calls used by sync */
     unDelete:function(note) {
	 note = this.store.loadbyID(note.id);
	 note.deleted = false;
	 note.modified = true;
	 this.notes[note.id] = note;
	 this.store.save(note);
	 this.logAction("note-undelete", note.id);
	 this.informObservers("note-undelete", note.id);
     },    
     deleteNote: function(id,metadata) {
	 var note = this.getNoteById(id);
	 note.deleted = (new Date()).valueOf();
	 note.modified = true;
	 this.store.save(note);
	 this.logAction("note-delete", id, undefined, undefined, metadata);
	 this.informObservers("delete-note", id);
     },
     saveNote:function(id, metadata) {
	 var note = this.getNoteById(id);
	 this.store.save(note);
	 this.informObservers("save-note", id, undefined, undefined, metadata);
     },
     reload_notes: function() {
	 this.load_notes();
	 this.informObservers("note-reload");
     },
     _make_repair_note : function() {	
	 return this.makeNote("");
     },
     _verify_and_construct_note: function(questionable_n, reference_n) {
	 /* this method verifies whether questionable_n has its the required fields.
	    if it does _not_, it borrows fields from reference_n.
	    returns [patched_note, complete_remote?, complete_patched?]
	    where "patched_note" = a note that has "repaired"
		  "complete_remote?" = true iff questionable_n was verified to have all required fields.
		  "complete_patched?" = true iff borrwing fields from reference_n yielded a complete note
	 */

	 var missing_fields = [], complete_patched = true;
	 reference_n = reference_n === undefined ? this._make_repair_note() : reference_n;
	 var patched_n = {};
	 var has_key = function(x, key) { return x[key] !== undefined; };
	 for (var f_i = 0; f_i < this.mandatory_fields_note.length; f_i++) {
	     // f == "field"
	     var f = this.mandatory_fields_note[f_i];
	     if (has_key(questionable_n,f)) {
		 // has it!
		 patched_n[f] = questionable_n[f];
	     } else {
		 // 'questionable'  have it. pull from reference.
		 missing_fields.push(f);
		 if (!has_key(reference_n,f)) {
		     // if not in reference, give up
		     complete_patched = false;
		 } else {
		     patched_n[f] = reference_n[f];
		 }
	     }
	 }
	 return {note: patched_n,
		 is_complete: missing_fields.length === 0,
		 is_patched_complete: complete_patched,
		 missing_fields : missing_fields};
     },
     isPrivateBrowsing:function() {
	 if (this._pbs === undefined) {
	     try {
		 this._pbs = Components.classes["@mozilla.org/privatebrowsing;1"].getService(Components.interfaces.nsIPrivateBrowsingService);
	     } catch(e) {
		 this._pbs = "error";
	     }	    
	 }
	 if (this._pbs == "error") { return false; } // not supported, must be FF3.0
	 return this._pbs.privateBrowsingEnabled;  
     },
    load_notes:function() {
	var this_ = this;
	var notes = {};
	var notelist = this.store.loadAllAsync(
	    function(notelist) {
		this_.log('notes :: ', notelist.length);		
		notelist.map(function(note) { notes[note.id] = note; });
		this_.notes = notes;
		this_.ensureHasOrders(notelist);
	    }
	);		
    },
     /* activity log -------------------------------------------------------------- */
     logAction: function(actType, noteid, notetext, search, other_stuff) {
	 if (this.actlog === undefined){
	     this.log("activity logging disabled --");
	     return;
	 }
	 var this_ = this;
	 if (actType == "user-inactive-in-listit-browser-window") {
	     try {
		 this.plumutil.assert(false,"demons!!!");	
	     } catch (x) {
		 this.log(x);
	     }

	 }
	 if (actType == "sidebar-open") {  this.set_last_opened(new Date());  }
	 if (this.__action_queue === undefined) {
	     this.__action_queue = [];
	 }
	 var make_action = function() {
	     try {
		 var action = {id:new Date().valueOf(), type:actType};
		 if (noteid) { action.noteid = Math.round(noteid);  } 
		 if (notetext) { action.noteText = ""+notetext;	}
		 if (search) { action.noteText  = (action.noteText ? action.noteText : "") + search; }

		 /*if (other_stuff !== undefined) {
		     this_.plumutil.assert(typeof(other_stuff) == 'object', "other_stuff parameter must be an object");
		 }*/

		 var misc = other_stuff ? other_stuff : {};
		 
		 if (typeof(misc) == 'object' && this_.plumutil.objKeys(misc).length > 0) {
		     action.search = this_.plumutil.toJSON(misc);
		 } else if (typeof(misc) == 'string') {
		     action.search = misc;
		 } else{
		     action.search = undefined;		     
		 }

		 /*
		  0.4.6-0.4.6.5 --
		 if (["note-save", "note-add", "note-delete", "note-edit", "search"].indexOf(actType) >= 0) {
		     var misc = {};
		     var active_page = this_.plumutil.get_active_page();
		     if (active_page !== undefined) { misc.viewing_url = active_page; }
		 if (search !== undefined) { misc.search = search; }
		     if (active_query !== undefined) { misc.active_search = active_query; }
		     if (active_filters !== undefined && this_.plumutil.objKeys(active_filters).length > 0) { misc.active_research = this_.plumutil.objKeys(active_filters); }
		     action.search = this_.plumutil.objKeys(misc).length > 0 ? this_.plumutil.toJSON(misc) : undefined;
		 }
		  */
		 return action;
	     } catch(e) {
		 this_.log(e);
	     }
	 };
	 this.__action_queue.push(make_action());
	 if (this.__action_timer !== undefined) { this.clearTimeout(this.__action_timer); }
	 this.__action_timer = this.setTimeout(function(x) {
	     this_.__action_queue.map(function(x) {try { this_.actlog.save(x); } catch(e) {  this_.log(e);  }});
	     this_.__action_queue = [];
	 },10000);	
     },

    xuload:function(scriptpath,context) {
		// thanks to http://www.getbooksmarts.org/news/2007/03/13/how-to-do-dynamic-javascript-imports-in-xul-chrome/ (!)
		try {
			var jsLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Components.interfaces.mozIJSSubScriptLoader);
			return jsLoader.loadSubScript(scriptpath,(context !== undefined ? context : this));
			//return Components.utils.import(scriptpath);
		} catch(e) {
			this.log("ERROR xuload:  " + scriptpath + " " + e + " " + e.lineNumber + " " + e.fileName);
		}
    },

     // new version that supports __defn_module() call
     xuloadCB:function(scriptpath,cb) {
	 var this_ = this;
	 if (cb === undefined) { cb = function(init) { init(this_); }; }
	 // thanks to http://www.getbooksmarts.org/news/2007/03/13/how-to-do-dynamic-javascript-imports-in-xul-chrome/ (!)
	 try {
	     var jsLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Components.interfaces.mozIJSSubScriptLoader);
	     return jsLoader.loadSubScript(scriptpath,{	__defn_module:function(name,val) { cb(val); } });
	 } catch(e) {
	     this.log("ERROR xuloadCB ");
	     this.log(scriptpath, e);
	 }
     },
    

     initialize_actlog:function() {
	 if (this.prefs.getBoolPref("actlog.enabled")) {
	     this.actlog = this.ActLogStore.open();
	     return;
	 } else {
	     if (this.__action_timer !== undefined) { this.clearTimeout(this.__action_timer); }
	     delete this.actlog;
	 }
     },

    _startup_keyprefs:function() {
	var keyPrefs = Components.classes["@mozilla.org/preferences-service;1"]
	    .getService(Components.interfaces.nsIPrefService)
	    .getBranch("ui.key.");
	keyPrefs.QueryInterface(Components.interfaces.nsIPrefBranch);
	switch(keyPrefs.getIntPref("accelKey")) {
	case 17:
	    this.accelKey = "control";
	    break;
	case 18:
	    this.accelKey = "alt";
	    break;
	case 224:
	    this.accelKey = "meta";
	    break;
	}
    },
    _startup_update_username:function() {
	try {
	    // Migrate from preferences login to nsILoginManager
	    if (this.prefs.getCharPref('sync.username') &&
	        this.prefs.getCharPref('sync.password') &&
                this.prefs.getCharPref('sync.password') !== "XXX") {
                // migrate to secure store
                this.setUser(this.prefs.getCharPref('sync.username'),this.prefs.getCharPref('sync.password'));
                // signifies password has been moved (real passwords must be 4+ characters)
	        this.prefs.setCharPref('sync.username',"");
                this.prefs.setCharPref('sync.password',"XXX");
	    }
        } catch(e) { this.log("OK: tried to migrate username but preference didn't exist -- we're all set");      }

    },

     startup: function() {
	 try {
	     this.log("---------------------- listit starting -------------------------------- ");
	     var this_ = this;
	     this.xuload("chrome://listit/content/plum-util-ns.js");
	     this.xuload("chrome://listit/content/protocrock.js");
	     this.xuload("chrome://listit/content/plum-store-type-names-protocrock.js");
	     this.xuload("chrome://listit/content/plum-store-types-protocrock.js");
	     this.xuload("chrome://listit/content/plum-store-protocrock.js");
	     this.xuload("chrome://listit/content/plum-3store-protocrock.js")(this);

	     // defines contextmaiden object
	     this.xuloadCB("chrome://listit/content/context/context-maiden.js");
	     this.xuloadCB("chrome://listit/content/context/schemas.js");
	     this.xuloadCB("chrome://listit/content/context/context-maiden-eventstore.js",function(init){ init(this_,this_.ContextMaiden); });
	     this.xuload("chrome://listit/content/listit-note-store.js")(this);		
	     this.xuload("chrome://listit/content/listit-actlog-store.js")(this);
	     
	     this.newify  = this.PROTOCROCK.newify; // comes from protocrock.js
	     
	     // Register to receive notifications of preference changes
	     this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
		 .getService(Components.interfaces.nsIPrefService)
		 .getBranch("listit.");
	     this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch);

	     this.NoteOrderers = this.make_note_orderers();	     	     
	     this.store = this.NoteStore.open(); 
	     this.load_notes(); 	// run to repair the notes
	     this.log('_____________________________________________ --> continuing init after note load call');
	     this.initialize_actlog();
	     this._startup_keyprefs();
	     this.setupAutoCommitCb();
	     this.setScriptTimeoutTolerance();
	     this._startup_update_username();

	     // why isn't this in the ui?!
	     // add listener for reorder events -- generated by scroll to the log
	     this._getObserverService().addObserver( {  observe: function(subject,topic,data) {  return this_.logAction("notes-reordered", undefined, undefined, undefined, data); }  },  "notes-reordered", false);
	     
	     // sync!
	     try {  this.xuload("chrome://listit/content/listit/synchronize.js")(this);   } catch (x) { this.log(x); }
	     try {
		 // replace sync with mixing
		 if (parseFloat(this._get_firefox_version().substring(0,3)) >= 3.5) {
	  	     this.log("enabling event sync mixin");
	  	     this.xuloadCB("chrome://listit/content/listit/sync-events-mixin.js");
		 }	     
	     } catch (x) { this.log(x); }
	     
	     // enable worker sync 
	     try {
		 if (this.prefs.getBoolPref("workersync") && parseFloat(this._get_firefox_version().substring(0,3)) >= 3.5) {
		     this.log("Enabling experimental worker-thread based sync.... (FF3.5+ only)");
		     this.log("Firefox version : " +  this._get_firefox_version());
		     this.xuload("chrome://listit/content/listit/synchronize-worker-caller.js")(this);
		 }
	     } catch (x) { this.log(x); }
	     
	     this.xuload("chrome://listit/content/context/watchme-storage.js")(this.ContextMaiden);

	     // modeling data structures -- must be loaded before scheduler
	     if ( this.prefs.getBoolPref('context.pairwiseLearn') ) {
		 this.log("pairwiseLearn enabling ========= ");
		 this.xuload("chrome://listit/content/context/context-table.js")(this,this.schemas);
		 this.log("schemas.PairwiseContextTable: " + this.schemas.PairwiseContextTable);
		 this.xuload("chrome://listit/content/context/note-event-source.js")(this,this.ContextMaiden);
		 this.xuload("chrome://listit/content/context/context-maiden-time.js")(this,this.ContextMaiden);
	     }

	     try {
		 this.xuload("chrome://listit/content/context/context-maiden-scheduler.js")(this,this.ContextMaiden);
		 this.CMS = newify(this.ContextMaiden.Scheduler, [], { });
	     } catch (E) {
		 this.log(E);
	     }
	     
	     if ( this.prefs.getBoolPref('context.watchme') ) { this.load_watchme();  }

	     try {	     
		 if ( this.prefs.getBoolPref('context.oil_location') ) {
		     this.xuload("chrome://listit/content/context/context-maiden-oil-location.js")(this,this.ContextMaiden);
		     try { this.CMS.sources.push(newify(this.ContextMaiden.OilLocation, this));  }
		     catch(e) { this.log(e + " " + e.lineNumber + " " + e.fileName);   }
		 }
	     } catch(e) { this.log(e);    }

	     this.load_wifi();

	     if (this.prefs.getBoolPref("context.debug_table_window.enabled")) {
		 this.CMS.open_table_window();
	     }

	     if (this.prefs.getBoolPref('analysis.enabled') === true) {
		 this.xuload("chrome://listit/content/analysis/analysis.js")(this);
		 this.analysis = this.newify(this.Analysis);
	     }
	     
	     this.setTimeout(function() { this_.handlediagnostics(); /*this_.sync_now();*/ }, 30000);

	     if (this.prefs.getBoolPref("context.memdb")) {
		 this.xuloadCB("chrome://listit/content/context/context-memdb.js");
		 this.xuloadCB("chrome://listit/content/context/newtabstats.js");
	     };	     

	     this.log("---------------------- listit initialization complete -------------------------------- ");	     
	 } catch (x) { this.log(x); }	     
    },
    load_wifi:function() {
	try {
	    var app = Components.classes["@mozilla.org/fuel/application;1"].getService(Components.interfaces.fuelIApplication);
	    this.log(app.id);
	    this.log(app.name);
	    // Feb 2010: There seems to be a bug in wifi on OS X 10.6.x which is causing lots of people problems
	    // so we're going to disable it until further notice.
	    if ( (this.prefs.getBoolPref('context.wifi') && (this._get_os().toLowerCase().indexOf("darwin") < 0 || this.prefs.getBoolPref('context.wifi-testing-override')))) {
		this.xuloadCB("chrome://listit/content/context/context-maiden-wifi.js");
		this.log("loaded WiFi");
	    }
	} catch (x) {  this.log(x); }
    },
    load_watchme:function() {
	this.xuload("chrome://listit/content/context/firewatcher.js")(this,this.ContextMaiden);
	this.xuload("chrome://listit/content/context/watchme.js")(this,this.ContextMaiden);
	if (parseFloat(this._get_firefox_version().substring(0,3)) >= 3.5) {
	    this.log("Enabling experimental async-db watchme... (FF3.5+ only)");
	    this.xuload("chrome://listit/content/context/context-maiden-watchme-async.js")(this,this.ContextMaiden);
	} else {
	    this.xuload("chrome://listit/content/context/context-maiden-watchme.js")(this,this.ContextMaiden);
	}
	try {	    
	    this.CMS.sources.push(newify(this.ContextMaiden.WatchMeContextProvider, this.CMS, {log:this.log, debug:true}));	
	 } catch (x) {
	     this.log(x);
	 }
    },
    insertTutorialNotes : function() {
	var this_ = this;
	var tutorialNotes = this.xuload("chrome://listit/content/tutorial-notes.js");
	tutorialNotes.map(function(tutorialNote) {
	    this_.addNote(tutorialNote);
	});
    },    
    shutdown:function() {
	if (this.autoCommitCb) {  this.clearInterval(this.autoCommitCb); }
	if (this.CMS) {  this.CMS.shutdown(); }
    },

    /* setTimeout/setInterval implementation ----------------------------------------------- */
    _makeTimer:function() {
	return Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
    },
    trywrap:function(fn) {
	var this_ = this;
	return function() { try {
				/* for performance debugging ------
				 this_.log(">>>>>>>", (fn + "").substring(0,100) );
				 var result = fn();
				 this_.log("<<<<<<<<<<<");
				 return result;
				 */
				return fn();
			    } catch (x) {  this_.log("Exception occurred in cb ", fn, x);}};	
    },
    setTimeout:function(afn,delay) {
	try {
	    var this_ = this;
	    var timer = this._makeTimer();
	    timer.initWithCallback( { notify: this_.trywrap(afn) }, delay, Components.interfaces.nsITimer.TYPE_ONE_SHOT );
	    return timer;
	} catch(e) {  this.log(e + " " + e.lineNumber + " " + e.fileName);	}
    },
    setInterval:function(afn,delay) {
	try {
	    var this_ = this;
	    var timer = this._makeTimer();
	    timer.initWithCallback( { notify: this_.trywrap(afn) }, delay, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK );// Components.interfaces.nsITimer.TYPE_REPEATING_PRECISE); 
	    return timer;
	} catch(e) {  this.log(e + " " + e.lineNumber + " " + e.fileName);	}
    },
    clearTimeout:function(timer) {
	try {
	    if (timer !== null) { /*this.log("CANCEL TIMER ", timer);*/ timer.cancel();   }
	} catch(e) {  this.log(e + " " + e.lineNumber + " " + e.fileName);	}
    },
    clearInterval:function(timer) {
	try{
	    if (timer !== null) {timer.cancel();   }
	} catch(e) {  this.log(e + " " + e.lineNumber + " " + e.fileName);	}
    },
    /* observers and event dispatch ------------------------------------ */
    _getObserverService: function() {
	if (this.__observersvc !== undefined) {
	    return this.__observersvc;
	}
	this.__observersvc = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	return this.__observersvc;
    },
    informObservers:function(event_type, data) {
	var this_ = this;
	try  {
	    this_._getObserverService().notifyObservers(null, event_type, data);
	} catch (e) {
	    this.log(e);
	}
    },
    /* misc things ------------------------------------------------------------- */
    load_page_and_focus:function(url) {
	try {
            var Application = Components.classes["@mozilla.org/fuel/application;1"].getService(Components.interfaces.fuelIApplication);
            Application.activeWindow.open(this.util.url(url)).focus();
	} catch(e) {
	    this.log(e);
	}
    },
    setScriptTimeoutTolerance: function() {
	var dom_prefs = this.plumutil.getNSPrefsBranch("dom");
	if (!dom_prefs.prefHasUserValue("max_chrome_script_run_time")) {
	    dom_prefs.setIntPref("max_chrome_script_run_time",0);
	}
    },
    parseHotkey: function(keyString) {
	keyString = keyString.replace(/\+/g,",");
	keyString = keyString.replace(/command/ig,"meta");
	return [keyString.substring(0,keyString.length-2),
		keyString.substring(keyString.length-1)];
    },
    get_current_focused_page: function(window_) {
	/*
	var m = this.util.getMainWindow(this.util.getWindow());
	var doc = m.getBrowser().selectedBrowser.contentDocument;
	var host = "";
	try { host = doc.location.host; } catch(e) {  };
	var path = "";
	try { path = doc.location.path; } catch(e) { };
	var title = "";
	try { title = doc.title; } catch(e) { };
	*/
	var app = Components.classes["@mozilla.org/fuel/application;1"].getService(Components.interfaces.fuelIApplication);
	var doc = app.activeWindow.activeTab.document;
	var host = "";
	try { host = doc.location.host; } catch(e) {  };
	var path = "";
	try { path = doc.location.path; } catch(e) { };
	var title = "";
	try { title = doc.title; } catch(e) { };	    
	return {
	    loc:doc.location.href,
	    host:host,
	    path:path,
	    title:title
	};
    },
    get_current_focused_localStorage: function(window_) {
        try {
            var app = Components.classes["@mozilla.org/fuel/application;1"].getService(Components.interfaces.fuelIApplication);
	    return app.activeWindow.activeTab.document.defaultView.localStorage;
        } catch (x) {   this.log(x);      }
        return undefined;
    },
    get_globalstorage_of_domain: function(domain) {
        /*
         takes: a hostname like "web.mit.edu"
         returns the globalstorage for that ~ 
         allows us to eat up things that fetching agents have left for us
         NEW in 0.4.9 ~         
        */         
        try {
            return this.util.getMainWindow(this.util.getWindow()).globalStorage[domain];	
        } catch (x) {   this.log(x);      }
        return undefined;
    },    
    setReturn: function () {   },
    
    setReturn: function () {   },
    
    getWindowId:function(win) {	   
	return this.util.getMainWindow(win).__id__;
    },
    registerWindowId:function(win) {
	var id = this.plumutil.guid();
	this.util.getMainWindow(win).__id__ = id;
	return id;
    },
    doEncryptActivities:function() { return this.prefs.getBoolPref("context.encrypt");    },    
    util: {
        getListItVersion:function (success) {
            var appid = "listit@csail.mit.edu";
            try {
                Components.utils.import("resource://gre/modules/AddonManager.jsm");
                AddonManager.getAddonByID(appid, function(addon) {
                                              return success(addon.version);                                           
                                              /*
                                               alert("My extension's version is " + addon.version);
                                               alert("Did I remember to include that file.txt file in my XPI? " +
                                               addon.hasResource("file.txt") ? "YES!" : "No  ");
                                               alert("Let's pretend I did, it's available from the URL " + addon.getResourceURL("file.txt"));
                                               */                                          
                                          });                
            } catch(e) {
                try {
                    var Application = Components.classes["@mozilla.org/fuel/application;1"].
		        getService(Components.interfaces.fuelIApplication);
		    var ext = Application.extensions.get(appid);
                    return success(ext.version);
                    // let's fall back to the old-school way
                } catch(EE) { JV3.log(EE); }
            }
            return undefined;
        },
	clearNode: function(node) {
	    for (var i=0; i<node.childNodes.length; i++) {
		node.removeChild(node.childNodes[i]);
	    }
	},
	defang: function(oldText) {
	    var newText = oldText.replace(/</g,'&lt;');
	    newText = newText.replace(/>/g,'&gt;');
	    newText = newText.replace(/\n/g,'<br>');
	    newText = newText.replace(/&lt;(\/?)(b|i|em|strong|sub|sup|u|p|br|ins|del|strike|s)&gt;/ig,
				      "<$1$2>");
	    newText = newText.replace(/((mailto\:|javascript\:|(news|file|(ht|f)tp(s?))\:\/\/)[A-Za-z0-9,\.:_\/~%\-+&#?!=()@\x80-\xB5\xB7\xFF]+)/g,
				      "<a onclick=\"openLink(event);\" href=\"$1\">$1</a>");
	    newText = newText.replace(/<a onclick=\"openLink\(event\);\" href=\"(((http(s?))\:\/\/)?[A-Za-z0-9\._\/~\-:]+\.(?:png|jpg|jpeg|gif|bmp))\">(((http(s?))\:\/\/)?[A-Za-z0-9\._\/~\-:]+\.(?:png|jpg|jpeg|gif|bmp))<\/a>/g,
				      "<img src=\"$1\" alt=\"$1\"/>");
	    newText = newText.replace(/  /g,' &nbsp;');
	    newText = newText.replace(/\t/g,' &nbsp;&nbsp;&nbsp&nbsp;');
	    
	    return newText;
	},

	refang: function(oldText) {
	    var newText = oldText.replace(/&lt;/g,'<');
	    newText = newText.replace(/&gt;/g, '>');
	    newText = newText.replace(/<br>/g, '\n');
	    newText = newText.replace(/&nbsp;/g, ' ');
	    return newText;
	},

	makeTitle: function(note) {
	    var words = note.text.split(/<br>|\ /);
	    var title = note.id;
	    var notGoodChars = /[^a-zA-Z0-9_\-]/g;

	    for (var i=0; i<Math.min(words.length, 3); i++) {
		title += '-'+words[i];
	    }
	    title = title.replace(notGoodChars, "");
	    title = title.toLowerCase();

	    return title;
	},

	exportNote: function(note) {
	    //get extensions file path
	    var id = "listit@csail.mit.edu";
	    var extension = Components.classes["@mozilla.org/extensions/manager;1"]
		.getService(Components.interfaces.nsIExtensionManager)
		.getInstallLocation(id)
		.getItemLocation(id);
	    
	    var env = Components.classes["@mozilla.org/process/environment;1"]
		.getService(Components.interfaces.nsIEnvironment);

	    var dirPath;
	    var filePath;
	    if (env.exists("HOME")) {
		dirPath = env.get("HOME") + "/Documents/jnotes";
		filePath = dirPath + "/" + this.makeTitle(note) + ".note";
	    } else if (env.exists("USERPROFILE")) {
		dirPath = env.get("USERPROFILE") + "\\My Documents\\jnotes";
		filePath = dirPath + "\\" + this.makeTitle(note) + ".note";
	    } else {
		alert("couldn't find home");
	    }

	    //create directory
	    var dir = Components.classes["@mozilla.org/file/local;1"]
		.createInstance(Components.interfaces.nsILocalFile);
	    
	    dir.initWithPath( dirPath );
	    if(!dir.exists() || !dir.isDirectory()) //check to see if file exists
	    {
		dir.create( Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
	    }

	    //create component for file writing
	    var file = Components.classes["@mozilla.org/file/local;1"]
		.createInstance(Components.interfaces.nsILocalFile);
	    file.initWithPath( filePath );
	    if(file.exists() === false) //check to see if file exists
	    {
		file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420);
	    }

	    //create file output stream and use write/create/truncate mode
	    //0x02 writing, 0x08 create file, 0x20 truncate length if exist
	    var stream = Components.classes["@mozilla.org/network/file-output-stream;1"]
		.createInstance(Components.interfaces.nsIFileOutputStream);

	    stream.init(file, 0x02 | 0x08 | 0x20, 0666, 0);

	    //write data to file then close output stream
	    var content = note.text;
	    content += "\n\n#!\n";
	    content += "id:"+note.id+"\n";
	    content += "created:"+note.created+"\n";
	    content += "edited:"+note.edited+"\n";

	    stream.write(content, content.length);
	    stream.close();
	},

	generateID: function(notes) {
	    var rand = Math.ceil(Math.random()*1000000);
	    if (notes !== undefined) {
		for (var i in notes) {
		    if (i == rand) {
			return this.generateID(notes);
		    }
		}
	    }
	    return rand;
	},

	sortByDate: function(x) {
	    x.sort(function(a,b){
		return b.created - a.created;
	    });
	},

        // Taken from Ubiquity
        // Given a string representing an absolute URL or a nsIURI object,
        // returns an equivalent nsIURI object.  Alternatively, an object with
        // keyword arguments as keys can also be passed in; the following
        // arguments are supported:
        //
        //   uri: a string/nsIURI representing an absolute or relative URL.
        //
        //   base: a string/nsIURI representing an absolute URL, which is used
        //         as the base URL for the 'uri' keyword argument.
        url : function(spec) {
	    var base = null;
	    if (typeof(spec) == "object") {
                if (spec instanceof Components.interfaces.nsIURI) {
		    // nsIURL object was passed in, so just return it back
		    return spec;
		}
                
                // Assume jQuery-style dictionary with keyword args was passed in.
                base = this.url(spec.base);
                spec = spec.uri ? spec.uri : null;
	    }
	    
	    var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	    return ios.newURI(spec, null, base);
        },
	getWindow: function() {	    
	    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                .getService(Components.interfaces.nsIWindowMediator);
	    var mainWindow = wm.getMostRecentWindow("navigator:browser");
	    return mainWindow;
        },
	getMainWindow:function(window) {
	    return window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIWebNavigation)
                   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                   .rootTreeItem
                   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIDOMWindow); 
	},
	openNewTab: function(window,url){
	    this.getMainWindow(window).getBrowser().addTab(url);
	}	
    },
    addCloseHookForWindow:function(window,handler) {
	var this_ = this;
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);	
	//this just doesn't seem to work. hypothesis: windowmanager isn't a singleton across browsers
	var wmlistener = {
	    onOpenWindow : function(xulwin) {},
	    onCloseWindow: function(xulwin) {
		try {
		    var Ci = Components.interfaces;
		    var chromeWindow = xulwin.docShell.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindow);
		    if (chromeWindow == window) {
			handler();
			wm.removeListener(wmlistener);
		    }			
		} catch(e) {
		    this_.log(e + " " + e.fileName + ":" + e.lineNumber);
		}
	    },
	    onWindowTitleChange:function() {}
	};
	wm.addListener(wmlistener);
    },
    _gen_diagnostics:function() {
	try {
	    var this_ = this;
	    var info = {};
	    
	    try { info.username = this_.getUser().username ? this_.getUser().username : ""; }  catch (x) {    this.log(x);  }
	    try { info.clientid = this_.getClientId();} catch (x) { this.log(x); }
	    try { info.ff_version = this._get_firefox_version(); } catch (x) { this.log(x); }
	    try { info.platform_os = this._get_os(); } catch (x) { this.log(x); }
	    try { info.last_opened = this.prefs.getIntPref("lastopened"); } catch (x) { this.log(x); }
	    try { info.nopens = this.actlog.countType("sidebar-open"); } catch (x) { this.log(x); }
	    try { info.nsearches = this.actlog.countType("search"); } catch (x) { this.log(x); }
	    
	    var notes = this.plumutil.objVals(this_.notes);
	    info.numnotes = notes.length;
	    
	    if (notes.length > 0) {
		// overall corpus
		var nminl = notes[0].text.length;
		var nmaxl = notes[0].text.length;
		var ntotl = 0;
		var first_created = notes[0].created;
		var n_deleted = 0;

		//var lengths = [];
		//var nwords = [];
		
		notes.map(function(n) {
			      if (n && n.text){
				  var l = n.text.length;
				  nminl = l < nminl ? l : nminl;
				  nmaxl = l > nmaxl ? l : nmaxl;
				  ntotl += l;
				  n_deleted = n.deleted ? n_deleted + 1 : n_deleted; 
				  first_created = n.created < first_created ? n.created : first_created;
				  // lengths.push(n.text.length);
				  // deleteds.push(n.deleted);
				  // createds.push(n.created);			      
				  //nwords.push(n.text.split(' ').length);
			      }
			  });
		info.minl = nminl;
		info.maxl = nmaxl;
		info.ntotl = ntotl;
		info.avgl = ntotl / (1.0*info.numnotes);
		info.first_created = first_created;
		info.n_deleted  = n_deleted;
		
		//info.createds = createds;
		//info.deleteds = deleteds;
		//info.nwords = nwords;
	    }
	    return info;	    
	} catch (x) {
	    this.log(x);
	}	
    },
    _get_firefox_version:function() {
	// assuming we're running under Firefox
	var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
            .getService(Components.interfaces.nsIXULAppInfo);
	var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"]
            .getService(Components.interfaces.nsIVersionComparator);
	return appInfo.version;
    },
    _get_os:function() {
	// Returns "WINNT" on Windows Vista, XP, 2000, and NT systems;  
	// "Linux" on GNU/Linux; and "Darwin" on Mac OS X.
	return Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;  
    },
    set_last_opened:function(when) { this.prefs.setIntPref("lastopened",when.valueOf()); },
    handlediagnostics:function() {	
 	try {
	    var this_ = this;
	    if (this.prefs.getIntPref("lastdiag") < this.prefs.getIntPref("lastopened")) {
		var sync = this.sync || this.Synchronize;;
		sync.run_diagnostics(
		    function(){ this_.log("successful diagnostics"); this_.prefs.setIntPref("lastdiag",new Date().valueOf());  },    function() { }
		);	    
	    }
	    else { this.log("diagnostics up to date");}
	} catch (x) {
	    this.log(x);
	}
    },

    test_worker:function() {
	var this_ = this;
	if (this.GenericWorker === undefined) {
	    this_.log("genericworker null");
	    return  this.xuloadCB("chrome://listit/content/listit/generic-worker-caller.js",function(init){   init(this_);  this_.test_worker();  });
	}
	this.GenericWorker.call("hello",[],
				function(x) {   this_.log("return successs ");   this_.log(x); },
				function(x) {    this_.log("return fail ");   this_.log(x);});				
				
    },
    
    __getLocalSiteDB: function(){
	this.log("__getLocalSiteDB_____________");
	if (this.memdb === undefined) {
	    this.memdb = this.newify(this.ContextMaiden.MemDB, [this.CMS.event_store, this.CMS.entity_store]);
	    this.__debug__stats = this.computeConditionalStats(events);
	}
	return this.memdb.getEntities({"type":"event"});
    },    

    // inported from scroll-controller, as useful for other views
    CONFIG_NOTE_ID : -1,
    getConfig:function() {
	var n = this.getNoteById(this.CONFIG_NOTE_ID);
	if (n !== undefined) {
	    try { 
		var json_obj = this.plumutil.fromJSON(n.text);
		if (json_obj !== undefined && typeof(json_obj) == 'object') {
		    return json_obj;
		}
	    } catch(e) { this.log(e); }
	}
	// return nothng
    },
    setConfig:function(key,val) {
	try {
	    
	    // debug
	    if (key == 'noteorder') {  this.log('note order is now (',val.length,')',val.slice(0,10)); }
	    
	    var n = this.getNoteById(this.CONFIG_NOTE_ID);
	    var config = this.getConfig();
	    if (n === undefined || config === undefined) {
		// emax debug
		this.log('config was undefined making new');
		n = this.makeNote("{}");
		n.id = this.CONFIG_NOTE_ID;
		this.notes[n.id] = n;
		config = {};
	    }
	    config[key] = val;
	    n.text = this.plumutil.toJSON(config);
	    n.modified = true;
	    n.deleted = true;
	    n.edited = new Date().valueOf();
	    this.store.save(n); // Note(n.id);
	} catch(e) {
	    this.log(e);
	}	
    },
    // stuff dealing with rodering/reorderability 
    getExplicitOrdering: function() {
	var config = this.getConfig();
	if (config !== undefined && config.noteorder !== undefined) {
	    // works most of the time
	    // this.log("returning config noteorder");
	    return config.noteorder;
	}
	if ( this.prefs.getCharPref("notes.order") !== undefined && this.prefs.getCharPref("notes.order") !== "" ) {
	    var ordering = this.plumutil.fromJSON(this.prefs.getCharPref("notes.order")).map(function(x) { return parseInt(x); });
	    this.prefs.setCharPref("notes.order","");	    
	    this.saveExplicitOrdering(ordering); // update it to the new system
	    return ordering;
	}
	// bummer, no orderings, let's just impose one
	var ordering = this.NoteOrderers.byDateDescending(this.plumutil.objVals(this.notes).filter(function(n) { return !(n.deleted); }) ).map(function(n) { return n.id; });
	this.saveExplicitOrdering(ordering);
	return ordering;
    },
    saveExplicitOrdering : function(order) {
	// try{ this.prefs.setCharPref("notes.order",this.plumutil.toJSON(order)); } catch (x) { this.log("FAIL                    ", x);	}
	try{
	    // this.log("Setting ordering ", order);
	    this.setConfig("noteorder", order);
	} catch (x) { this.log("FAIL --------------- ", x); }
    },
    ensureHasOrders : function(ns) {
	var ordering = this.getExplicitOrdering();
	var this_ = this;
	var toprepend = [];
	ns.reverse().map(function(n){
			     if (n.id == -1) { return;}
			     try {
				 if (ordering.indexOf( parseInt(n.id) ) < 0) {
				     this_.log("did not have order for "+n.id);
	   			     toprepend.push(parseInt(n.id));
				 }
			     } catch (x) { this_.log(x);  }});
	this.saveExplicitOrdering(toprepend.concat(ordering));	
    },        
    ensureHasOrder : function(n) {
	var ordering = this.getExplicitOrdering();
	if (ordering.indexOf( parseInt(n.id) ) < 0) {
	    ordering = [parseInt(n.id)].concat( ordering );
	    this.saveExplicitOrdering(ordering);
	}
    },    
    _sortNotes:function(m,ordering) {	
	try {
	    var this_ = this;
	    var plumutil = this.plumutil;
	    var order = function(n){
		plumutil.assert(ordering, "Explicit ordering not defined");
		var iidx = ordering.indexOf(parseInt(n.id));
		// emax debug
		// if (iidx == -1) { this_.log("++++++++++++++++++++++++++++++++ failed to find ", n.id, typeof(n.id), " in ", ordering, ordering.indexOf(n.id));		}
		return iidx;
	    };	    
	    m.sort(function(x,y) {   return order(x) - order(y);   });
	    return m;
	} catch(e) {
	    this.log(e + " " + e.lineNumber + " " + e.fileName);
	}
    },   
    make_note_orderers : function() {
	var this_ = this;
	return {
	    byDateDescending: function(m) {
		m = m.concat();
		this_.util.sortByDate(m);
		return m;
	    },
	    byExplicitOrdering: function(m) {
		try {
		    // O(n) in EO
		    var idtom = {};
		    m.map(function(n) { idtom[parseInt(n.id)] = n; });
		    var results = [];
		    var eo = this_.getExplicitOrdering();
		    eo.map(function(x) {
			       var idstr = ""+x;
			       if (idtom[idstr] !== undefined) {
				   results.push(idtom[idstr]);
			       }
			   });
		    return results;
		} catch (x) {
		    this_.log(x);
		}
	    }
	};
    },
    getMatches : function(vc,callback) {
	// returns the list of notes that should be in view
	// given the current state of filters and searches
	// ordered	
	var this_ = this;
	var CNID = this.CONFIG_NOTE_ID;
	var query = vc.query;
	var match = function (notes, query) {
	    var matches = [];
	    for (var i in notes) {
		var note = notes[i];
		if (!note.deleted && note.id !== this_.CONFIG_NOTE_ID && vc.evaluateFilters(note)) {
		    matches.push(note);
		}
	    }
	    return matches;
	};

	/* default--	
	try {
	    callback(vc.orderer(match(this.notes, query && new RegExp(query, 'i'))));
	    return;
	} catch(EEE) {
	    JV3.log(EEE);
	}
	 */

	try {

            if (query === undefined) {
                query = '';
            }
	    var filter_keys = this.plumutil.objKeys(vc.getActiveFilters());
	    if (filter_keys.length == 0 && query.length == 0) {
                // method one : no query, so we want all the notes ordered.
		var ordered = vc.orderer(this.plumutil.objVals(this.notes).filter(function(x) {  return !x.deleted && x.id != CNID; }));
		callback(ordered); 
	    } else if (query.indexOf("/") !== 0) {
		if (filter_keys.length > 0) {  query = query + " " + filter_keys.join(" ");        }
		var D1 = new Date();
		// this.log("FAST QUERY ", query);
		this.store.findTextMatch(query,
					 function(x) {
					     // this_.log("QUERY DONE ", (new Date()).valueOf() - D1.valueOf());
					     var xnotes = x.map(function(nid) {  return this_.notes[nid]; }).filter(function(n) { return n.id != CNID; });
					     // this_.log("XNOTES DONE ", (new Date()).valueOf() - D1.valueOf());					     
					     var vcx = vc.orderer(xnotes);
					     // this_.log("ORDERER DONE ", (new Date()).valueOf() - D1.valueOf());					     
					     callback(vcx); //  && vc.evaluateFilters(n); })));
					 });
	    } else {
		// this.log("SLOW DEFAULT", vc.orderer);
		callback(vc.orderer(match(this.notes, query && new RegExp(query, 'i'))));
	    }
	} catch(EE) { this.log(EE); }
    },    
    test_global_storage:function() {
	try {
	    var storageManagerService = Components.classes["@mozilla.org/dom/storagemanager;1"].
		getService(Components.interfaces.nsIDOMStorageManager);
	    var storage = storageManagerService.getLocalStorageForPrincipal(null);
	    storage.setItem("bar", 123);
	    return storage.getItem("bar");	    
	} catch (x) {
	    this.log(x);
	}
	return undefined;
    },
    close_listit:function(x) {
	this.util.getMainWindow(this.util.getWindow()).toggleSidebar('viewListitSidebar', false);	
    },
    is_open:function() {
	return this.util.getMainWindow(this.util.getWindow()).listit_window.isSidebarOpen();
    },
    open_and_search:function(x) {	
	// toggles list-it visible if sidebar is not open and starts a search
	var this_ = this;
	var isopen = this.util.getMainWindow(this.util.getWindow()).listit_window.isSidebarOpen();	
	this.util.getMainWindow(this.util.getWindow()).toggleSidebar('viewListitSidebar', true);
	var cont = function() {
	    try {
		this_.util.getMainWindow(this_.util.getWindow()).sidebar.jSidebar.setSearchState(x);
	    } catch (x) { this_.log(x);}
	};	
	if (!isopen) {	    
	    this_.setTimeout(function() {
				 if (this_.util.getMainWindow(this_.util.getWindow()).sidebar.jSidebar.search === undefined) {
				     return this_.setTimeout(arguments.callee, 500);
				 }
				 return cont();
			     },500);
	} else { cont(); }
    }
};


//=================================================
// Note: You probably don't want to edit anything
// below this unless you know what you're doing.
//
// Factory
var ListitFactory = {
    createInstance: function (aOuter, aIID)
    {
	if (aOuter != null)
	    throw Components.results.NS_ERROR_NO_AGGREGATION;
	return (new Listit()).QueryInterface(aIID);
    }
};

// Module
var ListitModule = {
    registerSelf: function(aCompMgr, aFileSpec, aLocation, aType)
    {
	aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
	aCompMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME, CONTRACT_ID, aFileSpec, aLocation, aType);
    },

    unregisterSelf: function(aCompMgr, aLocation, aType)
    {
	aCompMgr = aCompMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
	aCompMgr.unregisterFactoryLocation(CLASS_ID, aLocation);        
    },
    
    getClassObject: function(aCompMgr, aCID, aIID)
    {
	if (!aIID.equals(Components.interfaces.nsIFactory))
	    throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

	if (aCID.equals(CLASS_ID))
	    return ListitFactory;

	throw Components.results.NS_ERROR_NO_INTERFACE;
    },

    canUnload: function(aCompMgr) { return true; }
};

/**
 * * XPCOMUtils.generateNSGetFactory was introduced in Mozilla 2 (Firefox 4).
 * * XPCOMUtils.generateNSGetModule is for Mozilla 1.9.2 (Firefox 3.6).
 * */
if (XPCOMUtils.generateNSGetFactory) 
    NSGetFactory = XPCOMUtils.generateNSGetFactory([Listit]);
else
    NSGetModule = function (aCompMgr, aFileSpec) { return ListitModule; };

/*var NSGetModule = XPCOMUtils.generateNSGetModule([ListitModule]);*/

